       PROGRAM SYNOPDEQC
C
C**** *SYNOPDEQ*
C 
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         SYNOP DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1S( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(o,g), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comrec.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
      common /retarda/ iretarda
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
      irepetida = 0
      iretarda = 0
c
C
      CALL INITVAR( IERR )
      
C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='synop.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN')
C     ----------------------------------------------------------------
C*          2.   READ IN MESSAGE.
C                ----------------
 200  CONTINUE
c
      ierr = 0
C     ------------------------------------------------------------------
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
C     ------------------------------------------------------------------
C*          3.   FORMAT BULLETIN.
C                ----------------
 300  CONTINUE
C
      CALL PROCRFB( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(IERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          4.   DECODE BULLETIN HEADER.
C                -----------------------
 400  CONTINUE
C
      CALL PROCHDR( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          5.   CHECK TEXT OF BULLETIN.
C                -----------------------
 500  CONTINUE
C
      CALL PROCTXT( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C
C     ------------------------------------------------------------------
C*          6.   CALL APPROPRIATE ROUTINE TO DECODE SYNOP DATA.
C                ---------------------------------------------
 600  CONTINUE
C
      CALL PROCT1S( IERR )
C
C
      GO TO 200
C
C     ------------------------------------------------------------------
 1000 CONTINUE
      CLOSE(UNIT=99)
c
c----|-----------------------------------------------------------------|-------|
c                    estatistica do processamento das  
c               mensagens Serao incluida no arquivo cabecalho.dat.
c               
c             ________________________________________________
c             | VARIAVEL   |        DESCRICAO                |
C             |============|=================================|
c	      |	numbull    |   Numero de boletins lidos,     |
C             |------------|---------------------------------|
c             | numbullerr |   Numero de boletins com erro,  |
C             |------------|---------------------------------|
c             | numreport  |   Numero de mensagens lidas,    |
C             |------------|---------------------------------|
c	      |	numreperr  |   Numero de mensagens com erro, |
C             |------------|---------------------------------|
c    	      |	irecswriten|   Numero de mensagens gravadas, |
C             |------------|---------------------------------|
c	      |	iretarda   |   Numero de mensagens + de 48h  |
C             |------------|---------------------------------|
c	      |	irepetida  |   Numero de mensagens repetidas |
C             |------------|---------------------------------|
c             | inil       |   Numero de mensagens ignoradas |
c             |______________________________________________|
c               
c------------------------------------------------------------------------------
      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(91,file='mesg_err.dat',STATUS='UNKNOWN')
C LAC status='old',access='append')
c
c------------------------------------------------------------------------------
      write(91,20)
      write(91,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida,inil,iretarda
     
 10   format('| SYNOP     |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |',
     c       I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |',I5,'     |')

      write(91,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|----------|')

c------------------------------------------------------------------------------
c
      close(91)
      STOP
      END
      SUBROUTINE READIN( IERR )
C
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

      CHARACTER*16384 YCHAR
      Character*16384 buff_aux
      Character*4 four_chars
      Character*4 endmsg
      Character*2 endline
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
      DATA NSKIP/0/
c     Data aux/'03010D0D'Z/       ! ^C^A^M^M (separador de mensagens)
C LAC      Data aux/'0D0D0103'Z/       ! ^C^A^M^M (separador de mensagens)
      Data aux/Z'0D0D0103'/       ! ^C^A^M^M (separador de mensagens)
C

C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR= 0
      NWPT= 1
      NBPT= 0
      NSUB= 0
C
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
      IERR=0
C
      OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE='synop.dat',
     1     STATUS='OLD')

C
      Write(endmsg,10) aux     ! ^C^A^M^M (separador de mensagens)
 10   Format(a4)
 110  CONTINUE
      index = 1
      ilen = 1 
      four_chars = char(0) // char(0) // char(0) // char(0)
c       
      Do While(four_chars .ne. endmsg)
      READ (3,'(Q,A)',ERR=200,END=300,IOSTAT=IOS) ILEN,YCHAR
      buff_aux(index:index+ilen-1) = ychar(1:ilen)
C LAC
C LAC      PRINT *,'ILEN = ',ILEN
C LAC      PRINT *,'YCHAR= ',YCHAR(1:ilen)
C LAC
c     ------------------------------------------------------------------
c      Alteracao (Gamb) para cobrir problema do fortran v3.8. 
c       Na leitura do arquivo stream_LF,tem como final de registro um LF e CR,
c       sendo que este ultimo faz parte da mensagem, e por isso foi novamente 
c       acrescentado. 
c
c            A T E N C A O - checar as novas versoes do fortran/OSF.
c
c                    Rosangela.  04.07.96
c     ------------------------------------------------------------------
      index = index + ilen
C LAC
C LAC Para funcionar em Linux
C LAC
C LAC      ilen = ilen + 1  
C LAC      buff_aux(index:index) = char(13)  ! O CR nao vem na leitura
C LAC      ychar(ilen:ilen) = char(13)
C LAC
      four_chars = ychar(ilen-3:ilen)
c
      end do     
c
      ilen = index - 1     
      ychar(1:ilen) = buff_aux(1:ilen)
c     
C
      if(ilen.gt.4) NUMBULL=NUMBULL + 1
C
C*          1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C*          1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.LE.NSKIP) GO TO 100
C
C*          1.4  TRANSFER BULLETIN TO 'KCHAR', ONE CHARACTER PER WORD
C                -----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
C LAC      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
      KCHAR(I)=AND(ICHAR(YCHAR(I:I)),127)
C
 141  CONTINUE
C
      RETURN
C     -----------------------------------------------------------------
 200  CONTINUE
C
      IERR=1
      WRITE(*,9901) IOS
      PRINT*,'READIN: ILEN=',ILEN
      RETURN
C     -----------------------------------------------------------------
 300  CONTINUE
C
      IEOF=1
      PRINT*,'READIN: END OF FILE IEOF=',IEOF
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ----------------------------------------------------------------
 9901 FORMAT(1H0,'+ + + ERROR IN READING BULLETIN FILE. IOSTAT=',
     C I6,' DECIMAL')
 9902 FORMAT(1H ,'BULLETIN NUMBER IS ',I6)
 9903 FORMAT(1H0,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=',
     C I6,' DECIMAL')
C     ----------------------------------------------------------------
      END
      SUBROUTINE PROCRFB ( IERR )
C**** *PROCRFB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO FORMAT BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCRFB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C     ------------------------------------------------------------------
C*          1.   KEEP SOURCE OF DATA AND DATE/TIME OF ARRIVAL.
C                ---------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,3
C
      KHEAD(I)=MINDIC      ! THIS WILL BE CHANGED ACCORDING TO THE KEY.
C
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2.  DEFINE T1 AND T2 FROM ABBREVIATED HEADING.
C               ------------------------------------------
 200  CONTINUE

      DO 202 I=1,ILEN
C
      IF(KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 203
C
 202  CONTINUE
C
      IT1=27
      GO TO 210
C
 203  CONTINUE
C
      IT1=KCHAR(I  )-64
      IT2=KCHAR(I+1)-64
C
      IF(IT1.NE.19) THEN
                       IERR=1
                       IT1=27
                       RETURN
                    END IF
C
C     CHECK IF 'T2' CHARACTER IS LETTER.
C
      IF(IT2.LT.1.OR.IT2.GT.26) IT1=27
C
C*          2.1  LAST CHARACTER OF BULLETIN CAN BE IN ANY OF THE LAST
C                -----------------------------------------------------
C                5 WORDS. IF CHARACTER  IS 'ETX' REPLACE BY 'GS' .
C                -------------------------------------------------
C                IF NEITHER CAN BE FOUND INSERT 'GS' AS LAST CHARACTER.
C                ------------------------------------------------------
 210  CONTINUE
C
      IST=ILEN-5
C
      DO 211 I=1,ILEN
C
      IF (KCHAR(I).EQ.3.OR.KCHAR(I).EQ.29) THEN
                                              KCHAR(I)= 29
                                              IGS=I
                                              RETURN
                                           END IF
C
 211  CONTINUE
C
      I=I-1
      KCHAR(I)= 29
      IGS=I
C
      RETURN
      END
      
      SUBROUTINE PROCTXT ( IERR )
C
C**** *PROCTXT*
C
C
C     PURPOSE.
C     --------
C          CHECKS WHETHER BULLETIN CONTAINS USEFUL DATA .
C          THE FOLLOWING BULLETINS ARE CONSIDERED TO CONTAIN
C          NO USEFUL DATA.
C                 1. TEXT OF 'NIL' , OR VARIANTS OF THIS.
C                 2. TEXT OF 'NO DATA AVAILABLE'.
C                 3. TEXT OF 'NO REPORTS AVAILABLE'.
C                      1. - 3.  ARE DETERMINED SIMPLY BY CHECKING
C                      THE LENGTH OF THE TEXT . IF IT IS LESS
C                      THAN 26 THERE CANT BE ANY USEFUL DATA IN IT
C                 4. UK AND GERMAN DOMESTIC BULLETINS WHICH DO
C                    NOT CONFORM TO WMO CODES.
C
C          INPUT     : BULLETIN IN ARRAY 'KCHAR' ,
C                      ONE CHARACTER PER WORD.
C
C          OUTPUT    : KERR = 0 INDICATES BULLETIN CONTENTS REQUIRED.
C                           = 1 MEANS TEXT OF 'NIL' ETC.
C                           = 2 UK OR GERMAN DOMESTIC BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCTXT(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *SAVBULL(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'combuff.h'
      
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR.
C                ----------------------
 100  CONTINUE
C
      KERR= 0
C
C
C*          1.1  CHECK IF BULLETIN IS TOO SHORT I.E. "NIL" BULLETIN.
C                ---------------------------------------------------
 110  CONTINUE
C
      ILE = IGS - IMI
      IF(ILE .LT. 26) THEN
                         KERR = 7
                         NUMBERR(7) = NUMBERR(7) + 1
C LAC                                KCHAR(IGS)=KCHAR(IGS).OR.128
                                KCHAR(IGS)=OR(KCHAR(IGS),128)
C                               GO TO 900
                      END IF
C
C
C*          1.2  CHECK IF THE BULLETIN IS DOMESTIC FROM UK OR GERMANY.
C                -----------------------------------------------------
C                THIS IS DONE BY CHECKING IF THE BULLETIN HAS
C                --------------------------------------------
C                CCCC OF (EG--,ED--) OTHER THAN (EGRR,EDZW).
C                -------------------------------------------
 120  CONTINUE
C
      IPT=IAH+4
      CALL NEXTLET(IPT,JAH)
C
C     IF BULLETINS HAVE 'CCCC' NOT 'ED--' OR 'EG--' , RETURN.
C
      IF ( KCHAR(IPT).NE.69 ) RETURN
      IF ( KCHAR(IPT+1).NE.71.AND.KCHAR(IPT+1).NE.68 ) RETURN
C
C        FIRST UK
C
             IF (KCHAR(IPT+1).EQ.71)
     C                      THEN
                                 IF(KCHAR(IPT+2) .NE. 82 .OR.
     1                              KCHAR(IPT+3) .NE. 82)
     2                                   KERR = 8
                            ELSE
C
C        THEN GERMANY
C
                                 IF(KCHAR(IPT+2) .NE. 90 .OR.
     1                              KCHAR(IPT+3) .NE. 87)
     2                                   KERR = 8
                            END IF
C
C     MARK CCCC GROUP IF REQUIRED.
C
      IF ( KERR.EQ.8 ) THEN
C LAC                              KCHAR(IPT+4) = KCHAR(IPT+4).OR.128
                              KCHAR(IPT+4) = OR(KCHAR(IPT+4),128)
                              NUMBERR(8) = NUMBERR(8) + 1
                          END IF
C
C           1.3 TREAT IN ACCORDANCE WITH DEFINED OPTIONS.
C               -----------------------------------------
 130  CONTINUE
C
C     RETURN IF NO ERROR.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
 900  CONTINUE
C
      N = KERR - 1
C LAC      N1 =JISHFT(IOPTS(677),-N).AND.1
      N1 =AND(JISHFT(IOPTS(677),-N),1)
C LAC      N2 =JISHFT(IOPTS(678),-N).AND.1
      N2 =AND(JISHFT(IOPTS(678),-N),1)
C
C           1.4  PRINT BULLETIN IF REQUIRED.
C                ---------------------------
 140  CONTINUE
C
      IF (N1.EQ.1) THEN
                       WRITE (*,9900) KERR
                       CALL PRTBULL (1,IGS)
                   END IF
C
C           1.5 WRITE TO ERROR FILE IF REQUIRED.
C               --------------------------------
 150  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
      RETURN
C     -----------------------------------------------------------------
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C     -----------------------------------------------------------------
      END
      
      SUBROUTINE PROCHDR ( IERR )
C
C**** *PROCHDR
C
C
C     PURPOSE.
C     --------
C         DEODE BULLETIN HEADER AND INSERT REQUIRED PARAMETERS
C         IN DECODED REPORT HEADER.
C
C         LOCATES BEGINNING  AND END OF ABBREVIATED HEADER AND
C         'MIMIMJMJ' LINES.
C
C         INPUT     : BULLETIN IN KCHAR(1) - KCHAR(IGS)
C
C                     BULLETIN RECORD HEADER IN KINT(1) - KINT(5)
C
C                     'IT1' = 27 INDICATING BULLETIN HAS NOT BEEN
C                            IDENTIFIED FROM 'TT' OF ABBREVIATED HEADER.
C
C         OUTPUT    : KDEC(10) = DAY OF MONTH ( INTEGER ) . YY
C                     KDEC(11) = TIME OF BULLETIN - HOURS ( INTEGER ) . G
C                     KDEC(12) = TIME OF BULLETIN - MINS ( INTEGER ) . GG
C
C                     KDEC(14) = 0 IF ORIGIN OF REPORT IS FGGE.
C                                1  "   "     "    "    " BRACKNELL.
C                                2  "   "     "    "    " OFFENBACH.
C
C                     KDEC(20) =1 NIL
C                     KDEC(21) =1 IF BULLETIN IS 'COR' , OTHERWISE
C                                    = 0 .
C
C                     KDEC(21) = 1 IF BULLERIN IS 'CCA'
C                     KDEC(21) = 2 IF BULLERIN IS 'CCB'
C                     KDEC(21) = 3 IF BULLERIN IS 'CCC'
C                     KDEC(21) = 4 IF BULLERIN IS 'CCD'
C                     .
C                     .
C
C                     KDEC(18) = DATE OF BULLETIN ARRIVAL ( ON VAX )
C                     KDEC(19) = TIME  "    "        "      "     "
C
C                     IAH =    "      " BEGINNING OF 'ABBREVIATED HEADER'
C                     JAH =    "      "     END   "       "         "
C
C                     IMI =    "      " BEGINNING OF 'MIMIMJMJ' LINE.
C                     JMI =    "      "     END   "       "       "
C
C                     KERR = 0 IF NO ERROR FATAL TO DECODING ENCOUNTERED.
C                         = 1 IF BULLETIN HAS LESS THAN 3 LINES.
C                         = 2 IF BULLETIN IS NOT RECOGNISED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCHDR( IERR )*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I,N1,N2,N3,N4,N5,N,IRET)*
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *SAVBULL(IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION ILST(26)
      DATA ILST/65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     1          81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR AND SET REPORT HEADER AREA
C                ------------------------------------------------
C                TO MISSING DATA INDICATOR.
C                --------------------------
 100  CONTINUE
C
      KERR=0
C
      DO 101 I=1,24
C
      KDEC(I)= MINDIC
C
 101  CONTINUE
C
C*          1.1  FLAG FIELDS SET TO ZERO.
C                ------------------------
 110  CONTINUE
C
      KDEC(13)=0
      KDEC(15)=0
      KDEC(21)=0
C
C*          2.  LOCATE BEGINNING AND END OF 'STARTING LINE' ,
C               ---------------------------------------------
C               'ABBREVIATED HEADER' AND 'MIMIMJMJ LINE ' .
C               -------------------------------------------
C
      ISL = 1
      CALL NEXTPRT ( ISL,IGS )
      JSL = ISL
      CALL NEXTEND ( JSL,IGS )
      IAH = JSL
      CALL NEXTPRT ( IAH,IGS ) 
      JAH =IAH
      CALL NEXTEND ( JAH,IGS )
      IMI = JAH
      CALL NEXTPRT ( IMI,IGS )
      JMI = IMI
      CALL NEXTEND ( JMI,IGS )
C
C*          2.1 IF THESE 3 LINES CANNOT BE LOCATED , BULLETIN CONSISTS
C               ------------------------------------------------------
C               OF LESS THAN 3 LINES.
C               ---------------------
 210  CONTINUE
C
      IF ( JMI.GT.IGS ) THEN
C
C                           SET ERROR NUMBER AND MARK ERROR.
C
                            KERR = 1
C LAC                            KCHAR(IGS)=KCHAR(IGS).OR.128
                            KCHAR(IGS)=OR(KCHAR(IGS),128)
                            NUMBERR(1) = NUMBERR(1) + 1
                            GO TO 300
                        END IF
C
C
C
C*          2.2  BULLETIN CANNOT BE IDENTIFIED FROM 'TT' .
C                -----------------------------------------
 220  CONTINUE
C
      IF ( IT1.EQ.27 ) THEN
C
C                          SET ERROR NUMBER AND MARK ERROR.
C
                           KERR = 2
C LAC                           KCHAR(IAH+2)=KCHAR(IAH+2).OR.128
                           KCHAR(IAH+2)=OR(KCHAR(IAH+2),128)
                           NUMBERR(2) = NUMBERR(2) + 1
                           GO TO 300
                       END IF
C
C
C*          2.3  NO CHECKS ARE MADE ON TTAAII OR CCCC GROUPS.
C                --------------------------------------------
 230  CONTINUE
C
C
C
C*          2.4  LOCATE AND DECODE 'YYGGGG' GROUP .
C                ----------------------------------
 240  CONTINUE
C
C     SCAN 'KCHAR' FOR FIRST FIGURE AFTER 'II' FIGURES.
C
      IPT = IAH + 6
      CALL NEXTFIG ( IPT,JAH )
      IF ( IPT.GE.JAH ) THEN
                          KERR = 5
                        ELSE
C
C                         EXTRACT YY,GG AND GG AND CONVERT TO INTEGERS
C                         IN WORDS 10-12 OF 'KINT' .
C
                          CALL EXTGRP( IPT,2,2,2,0,0,10,IRET )
                          IPT = IABS(IPT)
C
C                         TEST VALIDITY OF YY,GG AND GG.
C                         THIS TEST MAKES CHECKING RETURN CODE 'IRET'
C                         UNNECESSARY.
C
                          IF ( KINT(10).LT.1.OR.KINT(10).GT.31 )
     C                             THEN
                                        KERR = 5
                                        KINT(10) = MINDIC
                                   END IF
C
                          IF ( KINT(11).LT.0.OR.KINT(11).GT.23 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
                          IF ( KINT(12).LT.0.OR.KINT(12).GT.59 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
C
C                                  COPY TO DECODED REPORT HEADER AREA
C                                  AND RESET WORDS IN 'KINT'.
C
                                   DO 241 I=10,12
                                          KDEC(I) = KINT(I)
                                          KINT(I) = MINDIC
  241                              CONTINUE
C
                        END IF
C
C     MARK ERROR IN YYGGGG GROUP.
C
      IF ( KERR.EQ.5 ) THEN
C LAC                              KCHAR(IPT)=KCHAR(IPT).OR.128
                              KCHAR(IPT)=OR(KCHAR(IPT),128)
                              NUMBERR(5) = NUMBERR(5) + 1
                          END IF
C
C
C
C
C*          2.5 THE ONLY CHECK ON 'BBB' IS FOR 'COR'.
C               -------------------------------------
 250  CONTINUE
C
C     FIND NEXT LETTER IN ABBREVIATED HEADER LINE AND CHECK IF 'C' (67)
C
C      CALL PRTBULL(1,IGS)
      CALL NEXTLET ( IPT,JAH )
C
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.79) THEN
                                                       KDEC(21)=1
                                                       GO TO 260
                                                    END IF
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.67)
     1     THEN
              DO 251 IJ=1,26
              IF(KCHAR(IPT+2).EQ.ILST(IJ)) THEN
                                              KDEC(21)=IJ
                                              GO TO 260
                                           END IF
C
 251          CONTINUE
C
           END IF
C
C
C
C*          2.6 INSERT ORIGIN AND DATE/TIME OF ARRIVAL OF BULLETIN.
C               ---------------------------------------------------
 260  CONTINUE
C
C     ORIGIN IS DERIVED FROM KEY . BRACKNELL FILE
C     NAMES START WITH 'B' AND OFFENBACH WITH 'C'. THIS FILENAME IS
C     IN ASCCI CODE       ( 'B' =66 , 'C' = 67)
C
      KDEC(14) = MINDIC    !    ORIGIN WILL BE DEFINED FROM KEY.
C
C
      KDEC(18) = MINDIC               ! DATE AND TIME OF ARRIVAL
      KDEC(19) = MINDIC               !
C
C
C
C*          2.7 TREAT ERROR BULLETIN IN ACCORDANCE WITH DEFINED OPTIONS.
C               --------------------------------------------------------
 270  CONTINUE
C
C     RETURN IF NO ERRORS FOUND.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
C*          3. HANDLE ERROR BULLETIN.
C              ----------------------
 300  CONTINUE
C
      N = KERR-1
C LAC      N1 =JISHFT(IOPTS(677),-N).AND.1
      N1 =AND(JISHFT(IOPTS(677),-N),1)
C LAC      N2 =JISHFT(IOPTS(678),-N).AND.1
      N2 =AND(JISHFT(IOPTS(678),-N),1)
C
C*          3.1 PRINT BULLETIN IF REQUIRED.
C               ---------------------------
 310  CONTINUE
C
      IF ( N1.EQ.1 ) THEN
                         WRITE (*,9900) KERR
                         CALL PRTBULL ( 1,IGS)
                     END IF
C
C*          3.2 WRITE BULLETIN TO ERROR FILE IF REQUIRED.
C               -----------------------------------------
 320  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
C
C*          3.3  ONLY ERRORS 1 AND 2 ARE FATAL TO DECODING , SO CLEAR
C                -----------------------------------------------------
C                ERROR INDICATOR BEFORE RETURNING.
C                ---------------------------------
 330  CONTINUE

c     IF ( KERR.GT.2 ) KERR = 0
      if(kerr.gt.2) then
        kerr = 0
c       ierr = 0
      end if
c
      RETURN
C
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C
      END
      
      SUBROUTINE PROCT1S ( IERR )
C
C**** *PROCT1S*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING SURFASE
C         DATA ( BULLETINS WITH 'T1' OF 'S' )
C
C         INPUT    : IERR IS NOT USED ON INPUT.
C
C                    IT2  = 1-26 CORRESPONDING TO 'T2' OF A-Z.
C
C         OUTPUT   : IERR IS UNALTERED UNLESS A FATAL ERROR OCCURRS ,
C                     WHEN IT IS SET TO 1.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCT1S(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *BULLSM(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c           R. CINTRA.
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  CALL APPROPRIATE ROUTINE, 'IT2' CONTAINS AN INTEGER IN THE
C                ---------------------------------------------------------
C               RANGE 1-26, CORRESPONDING TO 'T2' OF ABBREVIATED HEADER.
C                -------------------------------------------------------
 100  CONTINUE
C
C
      GOTO ( 110,120,130,140,150,160,170,180,190,200,210,220,230,
     C       240,250,260,270,280,290,300,310,320,330,340,350,360) IT2
C
C     -----------------------------------------------------------------
C*              1.1  BULLETINS WITH 'TT' = 'SA'.
C                    ----------------------------------------------
 110  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.2  BULLETINS WITH 'TT' = 'SB'.
C                    ---------------------------
 120  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.3  BULLETINS WITH 'TT' = 'SC'.
C                    ---------------------------
  130 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.4  BULLETINS WITH 'TT' = 'SD'.
C                    ---------------------------
  140 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.5  BULLETINS WITH 'TT' = 'SE'.
C                    ----------------------------
  150 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.6  BULLETINS WITH 'TT' = 'SF'.
C                    ---------------------------
  160 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.7  BULLETINS WITH 'TT' = 'SG'.
C                    ----------------------------
  170 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.8  BULLETINS WITH 'TT' = 'SH'.
C                    ---------------------------
  180 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.9  BULLETINS WITH 'TT' = 'SI'. SYNOP INTERMED.HOURS.
C
  190 CONTINUE
      CALL BULLSI( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.0  BULLETINS WITH 'TT' = 'SJ'.
C                    ---------------------------
 200  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.1  BULLETINS WITH 'TT' = 'SK'.
C                    ---------------------------
 210  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.2  BULLETINS WITH 'TT' = 'SL'.
C                    ---------------------------
 220  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.3  BULLETINS WITH 'TT' = 'SM'. SYNOP MAIN HOURS.
C                    ---------------------------
 230  CONTINUE
      CALL BULLSM( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.4  BULLETINS WITH 'TT' = 'SN'. NON-STANDARD HOUR.
C                    ---------------------------
 240  CONTINUE
      CALL BULLSN( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.5  BULLETINS WITH 'TT' = 'SO'.
C                    ---------------------------
 250  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.6  BULLETINS WITH 'TT' = 'SP'.
C                    ---------------------------
 260  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.7  BULLETINS WITH 'TT' = 'SQ'.
C                    ---------------------------
 270  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.8  BULLETINS WITH 'TT' = 'SR'.
C                    ---------------------------
 280  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.9  BULLETINS WITH 'TT' = 'SS'.
C                    ---------------------------
 290  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.0  BULLETINS WITH 'TT' = 'ST'.
C                    ---------------------------
 300  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.1  BULLETINS WITH 'TT' = 'SU'.
C
 310  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.2  BULLETINS WITH 'TT' = 'SV'.
C
 320  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.3  BULLETINS WITH 'TT' = 'SW'.
C
 330  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.4  BULLETINS WITH 'TT' = 'SX'.
C
 340  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.5  BULLETINS WITH 'TT' = 'SY'.
C
 350  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.6  BULLETINS WITH 'TT' = 'SZ'.
C
 360  CONTINUE
      RETURN
      END
      
      SUBROUTINE BULLSM ( IERR )
C
C**** *BULLSM*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF SURFACE OBSERVATIONS.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLSM(IERR)*
C
C          INPUT      : BULLETIN IN CCITT 5 CHARACTERS , 1 CHARACTER PER
C                       WORD IN 'KCHAR' .
C
C                       POINTERS TO BEGINNING AND END OF 'STARTING LINE' ,
C                       'ABBREVIATED HEADING','MIMIMJ LINE' AND END OF
C                       BULLETIN .
C
C                       IERR NOT USED.
C
C          OUTPUT     : DECODED REPORTS WRITTEN TO FILE AND ERROR
C                       REPORTS TO ERROR FILE.
C
C                       IERR = 1 , IF ANY FILE HANDLING ERROR .
C
C
C
C     METHOD.
C     -------
C
C         THIS ROUTINE HAS 3 ENTRY POINTS . SYNOP AND SHIP
C         REPORTS FOR MAIN,INTERMEDIATE AND NON-STANDARD HOURS
C         ARE DECODED BY THIS ROUTINE.
C
C         THIS MAINTAINS SUBROUTINE NAMING CONVENTIONS.
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SMDEC(IHEAD,IERR)*
C         *CALL* *SMINT(IHEAD,IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
                   ENTRY BULLSI ( IERR )
                   ENTRY BULLSN ( IERR )
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /inil/ inil
C     ------------------------------------------------------------------
C
C*          1.   SET FLAGS AND WORKING POINTERS.
C                -------------------------------
 100  CONTINUE
C
C*    SHIP REPORTS IN OLD CODE ARE NOT HANDLED BY THIS ROUTINE SO
C     CHECK FOR MIMIMJMJ OF NNXX .
C
      IF ( KCHAR(IMI).EQ.78.AND.KCHAR(IMI+1).EQ.78) RETURN
C
C-----PRINT INPUT BULLETINS OF SURFACE REPORTS
C      CALL PRTBULL (1,IGS)
C-----PRINT INPUT BULLETINS OF SURFACE REPORTS
C
C     WORKING POINTER SET TO POINT TO FIRST LETTER OF MIMIMJMJ
C     GROUP.
C
      IPT = IMI
C
C     CLEAR FLAG WHICH INDICATES YYGGIW GROUP PRESENT.
C
      ISYYGG = 0
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN
C     TO ERROR FILE.
C
      IHEAD = 0
C
C*    HANDLE MIMIMJMJ LINE . SET DATA BASE REPORT TYPE INDICATORS
C     IN DECODED REPORT HEADER  AND LOCATE START OF FIRST REPORT .
C
C     DATA BASE INDICATOR FOR LAND REPORTS IS 11 AND FOR SEA REPORTS
C     21 . THESE ARE MODIFIED LATER IF REDUCED SHIP , BUOY OR
C     AUTOMATIC REPORT ENCOUNTERED.
C
C
C     DISTINGUISH BETWEEN LAND ( TT = AA ) AND SEA ( TT = BB ) STATIONS.
C     'A' = 65 , 'B' = 66 .
C
C
C     MIMIMJMJ OF A--- OR -A-- ACCEPTED AS LAND STATION BULLETIN.
C     THE LINE LENGTH IS CHECKED IN CASE OF MISSING MIMIMJ LINE IN
C     A BULLETIN OF SHIP REPORTS AND SHIP'S NAME INCLUDES -A OR A- .
C
      L = JMI - IMI
      IF ( KCHAR(IMI).EQ.65.OR.KCHAR(IMI+1).EQ.65.AND.L.LT.15 )
     C THEN
C
C          SET DATA BASE CODE TYPE INDICATOR AND YYGGIW FLAG.
C
           KDEC(4) = 11
           ISYYGG = 1
C
C          LOCATE YYGGIW GROUP - NEXT FIGURE.
C
           CALL NEXTFIG ( IPT,JMI )
C
       ELSE
C
C          IF MIMIMJ IS B--- OR -B-- BULLETIN IS OF SEA REPORTS
C
           IF ( KCHAR(IMI).EQ.66.OR.KCHAR(IMI+1).EQ.66 )
     C         THEN
C
C                  SET DATA BASE CODE FIGURE FOR REPORT TYPE
C
                   KDEC(4) = 21
C
C                  LOCATE D---D GROUP . THIS SHOULD BE THE NEXT
C                  CHARACTER AND ON A NEW LINE , BUT THERE ARE SOME
C                  COMMON VARIATIONS .
C
C                  (1) A YYGGIW OR YYGG GROUP IS ADDED AFTER BBXX ,
C                      ON THE SAME LINE .
C                  (2) THE REPORT CONTINUES ON THE SAME LINE AS BBXX.
C
C                  SET K1 TO POINT TO THE NEXT 'SPACE' CHARACTER (32)
C
                   K1 = IPT
                   CALL NEXTVAL ( K1,32,IGS )
C
C                  SET K2 TO POINT TO THE NEXT 'CR' CHARACTER.
C
                   K2 = IPT
                   CALL NEXTEND ( K2,IGS )
C
C                  IF A 'CR' CHARACTER IS ENCOUNTERED BEFORE 'SPACE'
C                  D---D IS ON THE NEXT LINE.
C
                   IF ( K2.LT.K1 )
     C                 THEN
                           IPT = K2
                       ELSE
C
C                          IF THE REST OF BBXX LINE CONSISTS OF ONLY
C                          5 FIGURES IT IS CONSIDERED TO BE YYGGIW,
C                          AND D---D IS SOUGHT ON THE NEXT LINE.
C
                           K = K2 - K1
                           IF ( K.GT.6 ) THEN
                                             IPT = K1
                                         ELSE
                                             IPT = K2
                                         END IF
                       END IF
C
C                  IPT NOW POINTS TO THE CHARACTER BEFORE D---D GROUP.
C
                   CALL NEXTPRT ( IPT,IGS )
C
               ELSE
C
C                  BULLETIN CANNOT BE IDENTIFIED FROM MIMIMJMJ , SO
C                  INSPECT  AA  OF ABBREVIATED HEADING.
C
C----              PRINT BULLETINS WITH ERROR IN MIMIMJMJ
C----
C----              CALL PRTBULL (1,IGS)
C----
C----              PRINT BULLETINS WITH ERROR IN MIMIMJMJ
C
C
C                  IF A1 IS V OR W AND A2 IS A,B,C,D,E,F,J OR X
C                  THEN BULLETIN IS OF SEA REPORTS.
C
                   IF ( (KCHAR(IAH+2).EQ.86.OR.KCHAR(IAH+2).EQ.87).
     C                  AND.(KCHAR(IAH+3).EQ.65.OR.KCHAR(IAH+3).
     C                  EQ.66.OR.KCHAR(IAH+3).EQ.67.OR.KCHAR(IAH+3).
     C                  EQ.68.OR.KCHAR(IAH+3).EQ.69.OR.KCHAR(IAH+3).
     C                  EQ.70.OR.KCHAR(IAH+3).EQ.74.OR.KCHAR(IAH+3).
     C                  EQ.88) )
     C                       THEN
C
C                                 SEA STATION
C
C                                 SET DATA BASE CODE FIGURE
C
                                  KDEC(4) = 21
C
C                                 CHECK MIMIMJ LINE LENGTH TO DECIDE
C                                 WHETHER LINE IS MISSING OR MIMIMJMJ
C                                 IS CORRUPT.
C
                                  IF ( (JMI-IMI).LT.11 )

     C                                   THEN
C
C                                            CORRUPT MIMIMJ
C
                                             CALL NEXTEND ( IPT,IGS )
                                             CALL NEXTPRT ( IPT,IGS )
                                         ELSE
C
C                                            MISSING MIMIMJMJ LINE
C
                                             IPT = IMI
                                         END IF
C
                              ELSE
C
C                                 LAND STATION BULLETIN
C
C                                 SET DATA BASE CODE FIGURE
C
                                  KDEC(4) = 11
C
C                                 CHECK MIMIMJMJ LINE LENGTH TO DECIDE
C                                 WHETHER GROUP IS CORRUPT OR LINE IS
C                                 MISSING.
C
                                  IF ( (JMI-IMI).LT.11 )
     C                                    THEN
C
C                                              CORRUPT MIMIMJMJ
C
                                               CALL NEXTEND (IPT,IGS)
                                               IPT =IPT - 5
C
C                                              SET YYGGIW FLAG
C
                                               ISYYGG = 1
                                          ELSE
C
C                                               MISSING LINE
C
                                                IPT = IMI
C
C                                               SET WORDS FOR YY GG IW
C                                               TO MISSING DATA VALUE.
C
                                                KINT(1) = MINDIC
                                                KINT(2) = MINDIC
                                                KINT(3) = MINDIC
C
                                          END IF
                    END IF
                END IF
        END IF
c
C     IF LAND STATION REPORT EXTRACT 'YYGGIW' FROM 'MIMIMJMJ' LINE.
C
C
  101 IF ( KDEC(4).EQ.11.AND.ISYYGG.EQ.1 )
     C    THEN
              CALL NEXTPRT ( IPT,IGS )
              CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET)
              CALL NEXTPRT ( IPT,IGS )
              ISYYGG = 0
C
C             CHECK VALUES OF YY,GG AND IW . IF ANY ERROR IS
C             FOUND DECODED VALUE IS CHANGED TO MISSING DATA VALUE
C             AND GROUP FLAGGED AS BEING IN ERROR . ERRORS IN THIS
C             GROUP ARE NOT FATAL AS YYGG FROM HEADING AND IW FROM
C             WMO STATIONS MASTER FILE ARE SUBSTITUTED LATER , IF
C             NECESSARY.
C
              I = 0
              IF (KINT(1).LT.1.OR.KINT(1).GT.31)
     C             THEN
                       I = 1
                       KINT(1) = MINDIC
                   END IF
C
              IF ( KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       I = 1
                       KINT(2) = MINDIC
                   END IF
C
              IF ( KINT(3).EQ.2.OR.KINT(3).LT.0.OR.KINT(3).GT.4)
     C             THEN
                       I = 1
                       KINT(3) = MINDIC
                   END IF
C
              IF ( I.NE.0 )
     C             THEN
C LAC                       KCHAR(IPT-1) = KCHAR(IPT-1).OR.128
                       KCHAR(IPT-1) = OR(KCHAR(IPT-1),128)
                       NOER(1,3)=NOER(1,3)+1
                   END IF
           END IF
C
C
C***
C*    LOCATE END OF REPORT ( = ) AND INCREMENT COUNTER.
C***
C
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
C
C
      NUMREP(1) = NUMREP(1) + 1
C
C
C
C***
C*    DECODE REPORT .
C***
C
C     CONVERT REPORT TO INTERMEDIATE FORMAT.
C
      CALL SMINT( IHEAD,IERR )
c
      isaverr = ierr

C     "NIL" REPORTS (KERR=1) WILL NOT BE DECODED FOR
C     DATA MONITORING PURPOSES
C
      if (kerr .ne. 0) inil = inil + 1
      IF(KERR .NE. 0) GO TO 200
C
C
C     CONVERT INTERMEDIATE TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL SMDEC ( IHEAD,IERR )
C
      IF ( KERR.NE.0 ) GO TO 200

C***
C*    LOCATE START OF NEXT REPORT.
C***
C
200   IPT = IEQ + 1
c
      if(isaverr.ne.0) numreperr = numreperr + 1
       isaverr = 0
       kerr = 0
       ierr = 0
c
       CALL NEXTPRT ( IPT,IGS )
C
C***
C*    CHECK FOR END OF BULLETIN.
C***
C
       IF ( IPT.GT.IGS ) THEN
C
C                           END OF BULLETIN , SO IF ANY REPORT HAS
C                           BEEN WRITTEN TO ERROR FILE , ADD 'GS'
C                           CHARACTER BEFORE RETURNING.
C
                            IF (IHEAD.EQ.0) RETURN
                            IHEAD = 2
                            CALL SAVREP ( IHEAD,IERR )
C
C-----                      PRINT SURFACE DATA WRITTEN TO ERROR FILE
C-----                      CALL PRTBULL (1,IGS)
C-----                      PRINT SURFACE DATA WRITTEN TO ERROR FILE
C
                            RETURN
                        END IF
C
C
C***
C*    RESET LAND OR SEA STATION RDB CODE FIGURE.
C***
C
      IF ( KDEC(4).GT.14 ) THEN
                               KDEC(4) = 21
                           ELSE
                               KDEC(4) = 11
                           END IF
C
C***
C*    IF LAND STATION REPORT IT IS POSSIBLE TO GET NEW 'MIMIMJMJ'
C*    AND 'YYGGIW' GROUPS , SO CHECK .
C***
C
      IF ( KDEC(4).EQ.11.AND.KCHAR(IPT).EQ.65 )
     C                 THEN
C
C                          SET YYGGIW FLAG AND LOCATE START OF NEW
C                          YYGGIW GROUP.
C
                           ISYYGG = 1
                           CALL NEXTFIG ( IPT,IGS )
                           IF ( IPT.GE.IGS ) RETURN
                       END IF
      GO TO 101
      END
      
      SUBROUTINE SMDEC ( IHEAD,IERR )
C
C**** *SMDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE SURFACE REPORT FROM INTERMEDIATE FORMAT
C         TO DECODED SURFACE REPORT
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SMDEC(IHEAD,IERR)*
C
C          INPUT    :  REPORT IN INTERMEDIATE FORMAT IN KINT
C
C          OUTPUT   :  DECODED REPORT ON KDEC
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IC3333 (     )*      FOR LATTITUDE AND LONGITUDE
C         *CALL* *IT5TODC(     )*      CONVERSION FROM CITT5 TO DISPLAY CODE
C         *CALL* *IC0877 (     )*      WIND DIRECTION AND SPEED
C         *CALL* *IC4377 (     )*      HORIZONTAL VOISIBILITY
C         *CALL* *IC3845 (     )*      TEMPERATURE
C         *CALL* *IC0264 (     )*      INDICATOR OF ISOBARIC SURFACE  (A3)
C         *CALL* *IC3590 (     )*      PRECIPITATION
C         *CALL* *ICTRTR (     )*      PERIOD FOR PRECIPITATION MEASUREMENT
C         *CALL* *IC1677 (     )*      HEIGHT OF BASE OF CLOUD  (HH)
C         *CALL* *IC0700 (     )*      SHIP'S DIRECTION
C         *CALL* *IC4451 (     )*      SHIP'S SPEED
C         *CALL* *ICPWPW (     )*      PERIOD OF WAVES
C         *CALL* *ICHWHW (     )*      HEIGHT OF WAVES
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C           1. IN THIS SUBROUTINE THE ONLY PARTS OF THE HEADER
C              DECODED ARE IDENTIFIER , THE LENGTH OF REPORT ,
C              DAY OF THE MONTH AND TIME (HOUR & MIN) FROM REPORT
C              AND IN CASE OF SHIP OR BUOY
C              LAT, LONG, ALT=0
C
 100  CONTINUE

C     CLEAR ERROR INDICATOR.

      KERR = 0
      IERR = 0 

C*    SET DECODED REPORT TO MISSING DATA VALUE

      DO 1 I=25,120
      KDEC(I)=MINDIC
 1    CONTINUE

C*    CHECK IF SHIP OR BUOY

      IF(KDEC(4) .LT. 21 ) GO TO 101

C*   LAT & LONG

      CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,KDEC(5),KDEC(6))

C*    ALTIT   FOR SEA STATION=0

      KDEC(8)=0

101   CONTINUE

C*    IDENT   STATION OR BUOY IDENTIFICATION NUMBER
C             OR SHIP CALL SIGN
C             KINT(12) - KINT(16) CONTAIN ID.
C
      KDEC(7)=88

C*     DAY AND TIME
C
C      CHECK IF DAY AND HOUR ARE MISSING. IN THAT CASE USE 
C      DATE FROM ABBREVIATED HEADER.
C
       KDEC(1)=KINT(1)
       KDEC(2)=KINT(2)
C
       IF(KINT(1).EQ.MINDIC) THEN
                                KDEC(1)=KDEC(10)
                                IF(KDEC(10).EQ.MINDIC) RETURN
                             END IF
C
       IF(KINT(2).EQ.MINDIC) THEN
                                KDEC(2)=KDEC(11)
                                IF(KDEC(11).EQ.MINDIC) RETURN
                             END IF
c
      KDEC(9)=0

C*    REPORT LENGTH

      KDEC(24)=120

C*    SECTION 1

C*    DD & FF   WIND DIRECTION AND SPEED

      K=MINDIC
      IF(KDEC(4) .GE. 21) GO TO 120
      K=KDEC(17)*1000 + KDEC(16)
120   CONTINUE
C
      if(kint(255).eq.0.and.kint(256).ne.mindic) then
         CALL IC0877(KINT(19),KINT(256),KINT(3),K,MINDIC,KDEC(25),
     1            KDEC(26))
      else
         CALL IC0877(KINT(19),KINT(20),KINT(3),K,MINDIC,KDEC(25),
     1            KDEC(26))
      end if

C*    VV   HORIZONTAL VISIBILITY

      CALL IC4377(KINT(17),MINDIC,KDEC(27))

C*    WW, W1, W2   PRESENT AND PAST WEATHER

      IF(KINT(38) .EQ. MINDIC .AND. (KINT(15) .EQ. 2 .OR.
     *                 KINT(15) .EQ. 5))
     *                     THEN
                              KDEC(28)=2
                              KDEC(29)=1
                              KDEC(30)=1
                              GO TO 210
                           END IF
C
C
      DO 200 I=39,41
      IF(KINT(I) .EQ. MINDIC) GO TO 200
      KDEC(I-11)=KINT(I)
200   CONTINUE
C
210   CONTINUE

C*    TTT   AIR TEMPERATURE IN TENTHS OF DEGREE CELSIUS

      CALL IC3845(KINT(23),KINT(22),KDEC(16),KDEC(17),MINDIC,KDEC(31))

C*    TDTDTD   DEW POINT TEMPERATURE IN TENTHS OF DEGREE

      IF(KINT(26) .EQ. MINDIC) GO TO 320
      CALL IC3845(KINT(26),KINT(25),KDEC(16),KDEC(17),MINDIC,KDEC(32))

C***  UUU RELATIVE HUMIDITY
C
C
C     IF (KINT(25) .EQ. 9) THEN DEW POINT TEMP IS NOT AVAILABLE
C     AND RELATIVE HUMIDITY IS MEASURED INSTEAD
C
      IF(KINT(25) .EQ. 9) KDEC(33)=KINT(26)
C
C     CHECK RANGE
C
      IF ( KDEC(33).GT.100 ) KDEC(33) = MINDIC
C
320   CONTINUE

C*    P0P0P0   PRESSURE AT STATION LEVEL IN TENTHS OF HECTOPASCAL

      IF(KINT(28) .EQ. MINDIC) GO TO 340
      KDEC(34)=KINT(28)
      KK = KINT(28) / 1000
      IF ( KK.EQ.0 ) KDEC(34) = KDEC(34) + 10000
340   CONTINUE

C      CHECK IF THERE IS SEA LEVEL PRESSURE OR GEOPOTENTIAL IN THIS
C      THIS REPORT (IF A3 (=KINT(30)) .NE. 0 AND .NE. 9, THEN GEOPOT

      IF(KINT(30).EQ.MINDIC.OR.KINT(31).EQ.MINDIC ) GO TO 370
      IF(KINT(30) .NE. 0 .AND. KINT(30) .NE. 9) GO TO 350

C*    PRESSURE AT SEA LEVEL IN TENTHS OF HECTOPASCAL

      KDEC(35)=KINT(31) + 1000*KINT(30)
      IF(KINT(30) .EQ. 0) KDEC(35)=KINT(31) + 10000
      GO TO 370

350   CONTINUE

C***  A3   INDICATOR OF STANDARD ISOBARIC SURFACE (CODE 264)

      CALL IC0264(KINT(30),MINDIC,KDEC(36))

C*    HHH   GEOPOTENTIAL AT AN AGREED ISOBARIC SURF, GIVEN BY A3

      KDEC(37)=KINT(31)

C     ADD 1000 IF 850 HPA LEVEL

      IF (KINT(30).EQ.8) KDEC(37)=KDEC(37) + 1000

C     ADD 2000 OR 3000 IF 700 HPA LEVEL

      IF (KINT(30).EQ.7) THEN
                             IF (KINT(31).LT.500)KDEC(37)=KDEC(37)+3000
                             IF (KINT(31).GE.500)KDEC(37)=KDEC(37)+2000
                         END IF

C     ADD 5000 IF 500 HPA LEVEL

      IF (KINT(30).EQ.5) KDEC(37) = KDEC(37) + 5000

370   CONTINUE

C*    A   CHARACTERISTIC OF PRESSURE TENDENCY DURING 3 HOURS

      IF(KINT(33) .EQ. MINDIC) GO TO 380
      KDEC(38)=KINT(33)
380   CONTINUE

C*    PPP   AMOUNT OF PRESSURE TENDENCY IN TENTHS OF HECTOPASCAL

      IF ( KINT(34).NE.MINDIC )
     C   THEN
             KDEC(39)=KINT(34)
C
C            VALUE IS NEGATIVE IF CHARACTERISTIC ( A ) IS 5 - 8.
C
             IF (KDEC(38).GE.5.AND.KDEC(38).LE.8) KDEC(39) = -KDEC(39)
C
         END IF

C*     TEST IF PRESSURE TENDENCY IS FOR 24 HOUR PERIOD
C      INDICATED BY KINT(104)

      IF(KINT(104) .EQ. 8 .OR. KINT(104) .EQ. 9)
     1                   THEN
                            KDEC(38)=9
                            KDEC(39)=KINT(105)
                         END IF
C
      IF(KINT(104) .EQ. 9 .AND. KINT(105) .NE. MINDIC)
     1   KDEC(39)=-KDEC(39)

C***  RRR   AMOUNT OF PRECIPITATION TENTHS OF MILLIMETRES

      CALL IC3590(KINT(36),KINT(14),MINDIC,KDEC(40))
C
C     DURATION NOT DECODED IF RAINFALL VALUE IS MISSING.
C
      IF (KDEC(40).EQ.MINDIC) GO TO 415

C***  TR   DURATION OF PERIOD OF REFERENCE FOR PRECIP.(HOURS)

      IHOURS=KDEC(2)
      IF(IHOURS .EQ. MINDIC) IHOURS=KDEC(11)
      IF(IHOURS .LT. 0 .OR. IHOURS .GT. 24) IHOURS=MINDIC
      IF(IHOURS .EQ. MINDIC) GO TO 415
C
      CALL ICTRTR (KDEC(16),KDEC(17),KINT(37),IHOURS,MINDIC,KDEC(41))

415   CONTINUE

C***  N   TOTAL CLOUD COVER

      IF(KINT(18) .EQ. MINDIC) GO TO 420
      KDEC(42)=KINT(18)
420   CONTINUE

C***  H   HEIGHT OF THE BASE OF LOWEST CLOUD

      IF(KINT(16) .EQ. MINDIC) THEN
                                  IF (KDEC(4).NE.23)
     C                            KDEC(43)=16382
                                  GO TO 430
                               END IF
C
      IF(KINT(18) .EQ. 0) THEN
                             KDEC(43)=16381
                             GO TO 430
                          END IF
C
      LOWEST=MINDIC
C
      DO 425 I=46,44,-1
      IF(KINT(I) .EQ. MINDIC) GO TO 425
      IF (KINT(I).EQ.0) GO TO 425
      LOWEST=I-44
425   CONTINUE

      CALL IC1600(KINT(16),LOWEST,MINDIC,KDEC(43))
C
430   CONTINUE

C***  NH   TOTAL LOW CLOUDS

      IF(KINT(42) .EQ. MINDIC) GO TO 451
      KDEC(44)=KINT(43)

C***  CL, CM, CH   TYPE LOW MEDIUM AND HIGH CLOUDS

      DO 450 I=45,47
      KDEC(I)=KINT(I-1)
      IF(KINT(I-1) .EQ. MINDIC) KDEC(I)=14
450   CONTINUE
451   CONTINUE
C
C***  HH   HEIGHT OF THE BASE OF THE LOWEST CLOUD
C
      IF(KINT(48) .EQ. MINDIC) GO TO 455
C
      CALL IC1677(KINT(48),MINDIC,KDEC(43))
C
455   CONTINUE

C***
C*
C*           SECTION 2
C*
C*    CHECK IF THERE IS SECTION 2 IN THIS REPORT
C***
C
      IF(KINT(50) .EQ. MINDIC) GO TO 690

C***  DS   DIRECTION OF THE SHIP

      CALL IC0700(KINT(51),MINDIC,KDEC(49))

C***  VS   SHIP"S SPEED

      CALL IC4451(KINT(52),MINDIC,KDEC(50))

C***  TWTWTW   SEA-SURFACE TEMPERATURE

      IF(KINT(53) .EQ. MINDIC) GO TO 510
      IF(KINT(54) .EQ. 0) KDEC(51)=KINT(55)
      IF(KINT(54) .EQ. 1) KDEC(51)=-1*KINT(55)
510   CONTINUE

C***  PWAPWA   PERIOD OF WAVES IN SECONDS

      CALL ICPWPW(KINT(57),MINDIC,KDEC(52))

C***  HWAHWA   HEIGHT OF WAVES IN DECIMETERS 

      CALL ICHWHW(KINT(58),MINDIC,KDEC(53))
C
C       CHECK IF HIGHT WITH .1 M REPORTED.
C
      IF(KINT(250).EQ.70) THEN
         IF(KINT(251).NE.MINDIC) KDEC(53)=KINT(251)
      END IF

C***  PWPW   PERIOD OF WIND WAVES IN SECONDS

      CALL ICPWPW(KINT(60),MINDIC,KDEC(54))

C***  HWHW   HEIGHT OF WIND WAVES IN DECIMETERS 

      CALL ICHWHW(KINT(61),MINDIC,KDEC(55))

C***  DW1DW1 & DW2DW2   DIRECTION FROM WHICH WAVES ARE COMING

      DO 560 I=56,57
      IF(KINT(I+7) .EQ. MINDIC) GO TO 560
      KDEC(I)=KINT(I+7)*10
      IF(KINT(I+7) .EQ. 99) KDEC(I)=620
560   CONTINUE

C***  PW1PW1, HW1HW1    PERIOD AND HEIGHT OF
C***  PW2PW2, HW2HW2    SWELL WAVES

      CALL ICPWPW(KINT(66),MINDIC,KDEC(58))
      CALL ICHWHW(KINT(67),MINDIC,KDEC(59))
C
      CALL ICPWPW(KINT(69),MINDIC,KDEC(60))
      CALL ICHWHW(KINT(70),MINDIC,KDEC(61))

C***  IS     TYPE OF ICE
C***  ESES   ICE THICKNESS IN DECIMETERS
C***  RS     RATE OF ICING

      DO 620 I=72,74
      IF(KINT(I) .EQ. MINDIC) GO TO 620
      KDEC(I-10)=KINT(I)
620   CONTINUE
C
      IF(KDEC(63) .NE. MINDIC) KDEC(63)= (KDEC(63) + 5) / 10

C***  CI    CONCENTRATION OR ARRANGEMENT OF SEA ICE
C***  SI    STAGE OF DEVELOPMENT
C***  BI    LAND ICE
C***  DI    BEARING OF ICE
C***  ZI    TREND

      DO 650 I=76,80
      IF(KINT(I) .EQ. MINDIC) GO TO 650
      KDEC(I-11)=KINT(I)
650   CONTINUE
C
      IF(KDEC(68) .EQ. 99) KDEC(68)=620
C
C***         Wet bulb temperature (from 2.11.1993)
C
      if(kint(252).ne.mindic.and.kint(253).ne.mindic.and.
     1   kint(254).ne.mindic) then
         iwtsign=1
         if(kint(253).eq.0) iwtsign=1
         if(kint(253).eq.1) iwtsign=-1
         if(kint(253).eq.2) iwtsign=-1
         if(kint(253).eq.5) iwtsign=1
         if(kint(253).eq.6) iwtsign=-1
         if(kint(253).eq.7) iwtsign=-1
         kdec(120)=iwtsign*kint(254)
      end if
c
690   CONTINUE
C***
C*
C*         SECTION 3
C*
C*     THIS IS THE REGIONAL PART AND THERE ARE DIFFERENCIES
C*     IN DIFFERENT REGIONS. REGION NUMBER IS KDEC(17).
C***
C*      TEST IF THERE ARE ANY REGIONAL DATA
C***
      IF(KDEC(17) .EQ. MINDIC) GO TO 950
      IF(KINT(81) .EQ. MINDIC) GO TO 950
      
C***   TGTG   GROUND MIN TEMPERATURE IN TENTHS OF DEGREE
C             ONLY REGION I
c     THE FIRST GROUP IS 0TGTGRCRT AT 0600Z OR 0//RCRT
C     AT 0000 OR 1200. ONLY TGTG IS DECODED. TIME IS KDEC(11).
C
      IF(KDEC(11) .NE. 6) GO TO 700
      IF(KINT(83) .EQ. MINDIC) GO TO 700
      IF(KDEC(17) .NE. 1) GO TO 700
C
      KDEC(70)=KINT(83)*10
      IF(KDEC(70) .GT. 500) KDEC(70)=500-KDEC(70)
C
700   CONTINUE

C***   TXTXTX   MAX AIR TEMPERATURE IN TENTHS OF DEGREE
C               THE PERIOD FOR MAX IS DIFFERENT FOR
C               DIFFERENT REGIONS
C     FOR REGION IV AT 1200Z THE MAX TEMP IS DEFINED FOR THE PERIOD
C     OF CALENDAR DAY, AND IT WILL NOT BE DECODED.
C     FOR REGION III DAYTIME TEMPERATURE IS USED, AND IT WILL
C     NOT BE DECODED EITHER.
C
      IF(KDEC(17) .EQ. 4 .AND. KDEC(11) .EQ. 12) GO TO 720
c
c     Alteracao:  Para monitoramento das previsoes de tempo pela metop.
c     Existiu a necessidade de ter a temperatura maxima no buffer subtipo 2
c     para a regiao da america do sul ----------------  28.09.95
c
c     IF(KDEC(17) .EQ. 3) GO TO 720

      IF(KINT(87) .EQ. MINDIC) GO TO 720
      CALL IC3845(KINT(89),KINT(88),KDEC(16),KDEC(17),MINDIC,KDEC(71))

C***   TX-PERIOD   LENGTH OF THE PERIOD FOR MAX TEMPERATURE (HOURS)
C                  IT VARIES FROM REGION TO REGION
C            REGION I   12 HOURS  (AT 1800)
C            REGION II  12 HOURS  (AT 1800)
C            REGION III DAYTIME TEMPERATURE  (MINDIC)
C            REGION IV  12 HOURS  (AT 0000 & 1800)
C                       24 HOURS  (AT 0600)
C                       CALENDAR DAY (AT 1200)   (MINDIC)
C            REGION V   24 HOURS  (AT 1200)
C            REGION VI  12 HOURS  (AT 1800)
C
      IF(KDEC(17) .EQ. 1 .OR. KDEC(17) .EQ. 2 .OR. KDEC(17) .EQ. 6)
     1                    THEN
                              KDEC(72)=12
                              GO TO 720
                          END IF
C
C
      IF(KDEC(17) .EQ. 4)
     1       THEN
                 IF(IHOURS .EQ. 12) GO TO 720
                 IF(IHOURS .EQ. 0 .OR. IHOURS .EQ. 18)
     1                    THEN
                              KDEC(72)=12
                              GO TO 720
                          END IF
                 IF(IHOURS .EQ. 6)
     1                    THEN
                              KDEC(72)=24
                              GO TO 720
                          END IF
             END IF
C
      IF(KDEC(17) .EQ. 5) KDEC(72)=24
C
720   CONTINUE

C***   TNTNTN   MIN AIR TEMPERATURE IN TENTHS OF DEGREE,
C               THE PERIOD FOR MIN VARIES FROM REGION TO REGION
C
C      FOR REGION III MIN TEMP IS DEFINED AT NIGHT TIME,
C      AND IT WILL NOT BE DECODED
C
c
c     Alteracao:  Para monitoramento das previsoes de tempo pela metop.
c     Existiu a necessidade de se ter a temperatura minima no buffer subtipo 2
c     para a regiao da america do sul ----------------  28.09.95
c
c     IF(KDEC(17) .EQ. 3) GO TO 740
C
C
      IF(KINT(90) .EQ. MINDIC) GO TO 740
      CALL IC3845(KINT(92),KINT(91),KDEC(16),KDEC(17),MINDIC,KDEC(73))

C***   TN-PERIOD   LENGHT OF THE PERIOD FOR MIN TEMPERATURE
C                  REGION I    12 HOURS  (AT 0600)
C                         II   12 HOURS  (AT 0600)
C                         III  NIGHT TIME  (MINDIC)
C                         IV   18 HOURS  (AT 0000)
C                         V    24 HOURS  (AT 0000)
C                         VI   12 HOURS  (AT 0600)
C
      IF(KDEC(17) .EQ. 1 .OR. KDEC(17) .EQ. 2 .OR.
     1   KDEC(17) .EQ. 6) THEN
                             KDEC(74)=12
                             GO TO 740
                          END IF
C
      IF(KDEC(17) .EQ. 4) THEN
                             IF(IHOURS .EQ. 0)
     1                             THEN
                                      KDEC(74)=18
                                      GO TO 740
                                   END IF
                             IF(IHOURS .EQ. 6 .OR. IHOURS .EQ.
     1                         18) THEN
                                      KDEC(74)=24
                                      GO TO 740
                                   END IF
                             IF(IHOURS .EQ. 12)
     1                             THEN
                                      KDEC(74)=12
                                      GO TO 740
                                   END IF
                          END IF
C
      IF(KDEC(17) .EQ. 5) KDEC(74)=24
C
740   CONTINUE
C
C***  RRR AMOUNT OF PRECIPITATION 1/10THS OF MM
C
C     DECODE RAINFALL IF NOT ALREADY DECODED FROM SECTION 1.
C
      IF (KDEC(40).NE.MINDIC) GO TO 750
C
      CALL IC3590 (KINT(114),KINT(14),MINDIC,KDEC(40))
C
C     DURATION NOT DECODED IF RAINFALL VALUE IS MISSING.
C
      IF (KDEC(40).EQ.MINDIC) GO TO 750

C***DURATION OF RRR
         IHOURS = KDEC(2)
         IF (IHOURS.EQ.MINDIC) IHOURS=KDEC(11)
         IF (IHOURS.LT.0.OR.IHOURS.GT.24) IHOURS=MINDIC
         IF (IHOURS.EQ.MINDIC) GO TO 750

      CALL ICTRTR (KDEC(16),KDEC(17),KINT(115),IHOURS,MINDIC,KDEC(41))
C
C
  750 CONTINUE
C
C***   NS     AMOUNT OF CLOUD  (CODE FIGURE)
C      C      TYPE OF CLOUD
C      HSHS   HEIGHT OF BASE OF CLOUD LAYER

      DO 800 I=75,84,3
      J=(I - 75)/3 + I
      IF(KINT(J+46) .EQ. MINDIC) GO TO 810
      KDEC(I)=KINT(J+47)
      KDEC(I+1)=KINT(J+48)
      CALL IC1677(KINT(J+49),MINDIC,KDEC(I+2))
800   CONTINUE
C
810   CONTINUE

C      KDEC(87) -- KDEC(94)   SPSP SPSP  SPECIAL PHENOMENA
C                                        (CODE FIGURES)
      DO 900 I=87,94
      J=(I-87)/2 + I
      IF(KINT(J+50) .EQ. MINDIC) GO TO 910
      KDEC(I)=KINT(J+51)
      KDEC(I+1)=KINT(J+52)
900   CONTINUE
910   CONTINUE

C***   E   STATE OF GROUND, NO SNOW OR ICE

      IF(KINT(93) .NE. MINDIC) KDEC(97)=KINT(94)

C***   E'   STATE OF GROUND WITH SNOW OR ICE

      IF(KINT(98) .NE. MINDIC)
     *            THEN
                     KDEC(98)=KINT(99)
                     KDEC(99)=KINT(100)
                     IF(KDEC(99) .EQ. 997) KDEC(99)=0
                     IF(KDEC(99) .GE. 998) KDEC(99)=MINDIC
                     IF(KDEC(99) .GE. 999) KDEC(99)=MINDIC
                  END IF
 
C     FROM CHINA SNOW INFORMATION IS IN SPECIAL PHENOMENA. 9 SPSP SPSP
C     IN FORM 93 SPSPSP, WHERE SPSPSP = SNOW DEPTH IN CM.

      IF( KDEC(16) .EQ. 250 )
     C   THEN
            IF(KINT(137) .EQ. 9)
     C         THEN
                  INDSNOW = KINT(138) / 10
                  IF(INDSNOW .EQ. 3)
     C               THEN
                        KDEC(99) = 100 * (KINT(138) - 30) + KINT(139)
                        KDEC(98) = 1
                     END IF
               END IF
         END IF
 
C     IF E' IS MISSING AND E IS AVAILABLE IT MEANS THAT SNOWDEPTH=0
C
      IF((KDEC(98) .EQ. MINDIC) .AND. (KDEC(97) .NE. MINDIC))
     1    KDEC(99)=0
C
C     J1J2J3J4J5 GROUP
C
C      EEE EVAPORATION/EVAPOTRANSPIRATION
C
      IF(KINT(181).NE.MINDIC) THEN
C        KG/M**2
         IF(KINT(182).NE.MINDIC) KDEC(110)=KINT(182)/10.
      END IF
C
C      SSS DURATION OF SUNSHINE 
C
      IF(KINT(189).NE.MINDIC) THEN
         IF(KINT(191).NE.MINDIC) THEN
            IH=KINT(191)/10
            IMM=(KINT(191)-IH*10)*6
            KDEC(111)=IH*60+IMM
         END IF
      END IF
C
C       NET RADIATION OVER 24 HOUR PERIOD
C
C          (OTHER RADIATION DATA ARE NOT PASSED)!!!!
C        
      IF(KINT(192).NE.MINDIC.AND.KINT(193).NE.MINDIC) THEN
         KDEC(112)=KINT(193)
      END IF
      IF(KINT(194).NE.MINDIC.AND.KINT(195).NE.MINDIC) THEN
         KDEC(112)=-KINT(195)
      END IF
C
950   CONTINUE
 
C      CALL PRTKINT(KINT,1,300,MINDIC) 
C      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      CALL SYNEXP1( IERR )
      CALL QCSYNOP( 1,KDEC(4),KDEC(23),IERR )
      CALL BUFRENC( 1,IERR )
C
      CALL SYNEXP2( IERR )
      CALL QCSYNOP( 2,KDEC(4),KDEC(23),IERR )
      CALL BUFRENC( 2,IERR )

      RETURN
      END
      
      SUBROUTINE SMINT (IHEAD,IERR)
C
C**** *SMINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT SURFACE REPORTS FROM CCITT. NO.5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
c
C**   INTERFACE.
C     ----------
C
C         *CALL* *SMINT(IHEAD,IERR)*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN  CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                      IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                                WRITTEN TO ERROR FILE.
C                            = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                      IERR IS NOT USED ON INPUT.
C
C
C         OUTPUT     : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                      DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION )
C
C                      IERR = 1 IF ANY FILE HANDLING ERROR ENCOUNTERED.
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
c
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR.KEEP POINTER
C              TO FIRST CHARACTER OF REPORT.
C
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
C
C     ERROR INDICATOR.
C
  10  KERR = 0

C***
C*    CHECK FOR 'NIL' REPORT.
C***

      LEN = IEQ - IPT
C
C     RETURN IF REPORT SHORTER THAN 5 CHARS, FLAG ERROR = 2
C     SO IT WONT BE DECODED AT ALL (EVEN AS 'NIL')
C
      IF(LEN .LT. 5)
     C   THEN
            KERR = 2
            RETURN
         END IF
C
      NIL = 0
C
      IF (KDEC(4).LE.14.AND.LEN.LE.17) NIL = 1
      IF (KDEC(4).GE.21.AND.LEN.LE.28) NIL = 1
C
      IF (NIL.EQ.1) THEN
                         KERR = 1
                         NOER(1,1) = NOER(1,1) + 1
C
C-----                   PRINT 'NIL' SURFACE REPORTS
C-----                   CALL PRTBULL (IPT,IEQ)
C-----                   PRINT 'NIL' SURFACE REPORTS
                    END IF

C***
C*    SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C*    START IS IN WORD 4 AS YY GG IW FOR LAND STATIONS MAY ALREADY
C*    HAVE BEEN INSERTED .
C***

      DO 101 I=4,300
         KINT(I) = MINDIC
  101 CONTINUE

C     WORDS 9-13 SET TO CCITT.5 'XXX  ' ( 'X' = 88, 'SPACE' = 32 )
C     STATION/SHIP IDENTIFIER RETAINED IN THESE WORDS IN CCITT 5 CHARS.
C
      DO 200 I=9,11
         KINT(I) = 88
  200 CONTINUE
C
      KINT(12) = 32
      KINT(13) = 32
C***
C*    CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C***
      DO 300 I=1,3
         KDEC(I) = MINDIC
  300 CONTINUE
C
      DO 400 I=5,9
         KDEC(I) = MINDIC
  400 CONTINUE
C
C     CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
C LAC      KDEC(15) = KDEC(15).AND.4
      KDEC(15) = AND(KDEC(15),4)
C
      DO 500 I=16,17
         KDEC(I) = MINDIC
  500 CONTINUE
C
      KDEC(20)=0
C
      DO 600 I=22,23
         KDEC(I) = MINDIC
  600 CONTINUE

C***
C*    CONVERT SECTION 0 , WHICH IS DIFFERENT FOR LAND AND SEA
C*    STATIONS.
C***

  700 IF ( KDEC(4).EQ.11.OR.KDEC(4).EQ.14)
     C    THEN
C
C             LAND STATION .
C
C             RETAIN POINTER TO STATION IDENTIFIER .
C
C             IIIII
C
              KPT = IPT
              ID = 5
C
              CALL EXTINT ( IPT,5,4 )
              CALL LOCSTAT (IWIND,IRET)
C
              IF ( IRET.EQ.1 )
     C            THEN
C
C                     STATION NUMBER IN RANGE BUT NO MASTER FILE ENTRY
C                     ,SO REPORT IS IGNORED.
C
                      KERR=2
                      NOER(1,2)=NOER(1,2)+1
C
C-----                PRINT IIIII WITH NO MASTER FILE ENTRY
                      WRITE (*,9901) KINT(4)
 9901                 FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
                      RETURN
                  END IF
C
              IF (IRET.EQ.2 )
     C            THEN
C
C                     CORRUPT NUMBER   -   FATAL ERROR.
C
                      KPT=IABS(KPT)
C LAC                      KCHAR(KPT+5)=KCHAR(KPT+5).OR.128
                      KCHAR(KPT+5)=OR(KCHAR(KPT+5),128)
                      KERR = 2
                      IF ( IFIRST.EQ.0 ) NOER(1,2)=NOER(1,2) + 1
C
C                     RETURN IF REPORT TOO SHORT TO CONTAIN IDENT
C
                      IF( (KPT+5) .GE. IEQ) RETURN
C
                      GO TO 4000
                  END IF
C
              IF (IRET.EQ.3) RETURN

C     FOR "NIL" REPORTS ONLY THE HEADER WILL BE DECODED

            IF(NIL .EQ. 1) THEN
               KDEC(20)=1
                GO TO 790
            END IF

C             IF WIND INDICATOR IW IS MISSING USE THE MASTER FILE
C             INDICATOR TO REPLACE IW.  REPLACEMENT IW INDICATES
C             WIND MEASURED AND UNITS KNOTS OR METRES PER SECOND.

              IF ( KINT(3).EQ.MINDIC )
     C            THEN
C
C                     KNOTS
C
                      IF ( IWIND.EQ.0 ) KINT(3)=4
C
C                     METRES PER SECOND
C
                      IF ( IWIND.EQ.1 ) KINT(3)=1
                  END IF
C
           ELSE
C
C              SEA STATION
C
C              RETAIN POINTER TO STATION IDENTIFIER .
C
               KPT=IPT
C
C              CHECK WHETHER BUOY REPORT OR SHIP,RIG OR PLATFORM.
C              BUOUY REPORTS HAVE D---D OF 5 FIGURES.
C
               IBUOY = 0
               K = IPT
               J = K + 4
C
               DO 750 I=K,J
                    IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750          CONTINUE
C
C              IF A 5 FIGURE GROUP IS FOUND CHECK FOLLOWING GROUP.
C              IF THE FOLLOWING GROUP STARTS WITH A 9 THE SHIP CALL
C              SIGN GROUP IS PRESUMED MISSING.
C
               CALL NEXTPRT (I,IEQ)
               IF ( IBUOY.EQ.0 )
     C             THEN
                       IF (KCHAR(I).EQ.57) IBUOY = 2
                   END IF
C
               IF ( IBUOY.NE.0 )
     C             THEN
C
C                      SHIP,RIG OR PLATFORM. IDENTIFIER NO. SET TO 0
C
                       KINT(4) = 0
C
                       IF (IBUOY.EQ.1)
     C                    THEN
C
C                             MOVE POINTER PAST CALL SIGN . THE FIRST
C                             FIGURE AFTER START OF THE NEXT GROUP IS
C                             LOCATED AS SOME SHIPS USE THE FULL NAME
C                             ( WHICH CAN CONSIST OF 2 WORDS ) INSTEAD
C                             OF CALL SIGN.
C
                              CALL NEXTVAL (IPT,32,IEQ)
                              CALL NEXTFIG (IPT,IEQ)
C
                              ID = IPT-KPT-1
C
                          ELSE
C
C                             D---D MISSING , SO SET LENGTH OF CALL
C                             SIGN TO 0.
C
                              ID = 0
C
                          END IF
C
                   ELSE
C
C                      BUOY- A1 BW NBNBNB
C
                       CALL EXTINT ( IPT,5,4 )
C
C                      ALTER RDB REPORT TYPE FIGURE
C
                       KDEC(4) = 24
                       ID = 5
C
                   END IF
C
C                  YY GG IW
C
                   CALL NEXTPRT ( IPT,IEQ )
C
C                  IF FIRST OF FIGURE OF GROUP IS NOT 0-3 , YYGGIW
C                  GROUP IS MISSING.
C
                   IF (KCHAR(IPT).GE.48.AND.KCHAR(IPT).LE.51)
     C                  CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
                   JPT = IPT
C
C                  99 LALALA
C
                   CALL NEXTPRT ( IPT,IEQ )
                   CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                  CHECK VALIDITY OF LALALA
C
                   IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                         THEN
                                   IPT =IABS(IPT)
C LAC                                   KCHAR(IPT)=KCHAR(IPT).OR.128
                                   KCHAR(IPT)=OR(KCHAR(IPT),128)
                                   KERR = 4
                                   IF (IFIRST.EQ.0)
     C                                 NOER(1,4) = NOER(1,4) + 1
                                   GO TO 4000
                               END IF
C
C                  QC LOLOLOLO
C
                   CALL NEXTPRT ( IPT,IEQ )
                   CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                  CHECK VALIDITY OF LOLOLOLO
C
                   IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                   IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                   IF (IRET.NE.0)
     C                        THEN
                                  IPT= IABS(IPT)
C LAC                                  KCHAR(IPT)=KCHAR(IPT).OR.128
                                  KCHAR(IPT)=OR(KCHAR(IPT),128)
                                  KERR=4
                                  IF ( IFIRST.EQ.0 )
     C                                NOER(1,4)=NOER(1,4) + 1
                                  GO TO 4000
                              END IF
C
           END IF
790   CONTINUE
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 9 + ID -1
              DO 800 I=9,K
C
C                  IF LETTER ENCOUNTERED FOR LAND STATION CONVERT
C                  IT TO FIGURE (NOT FOR SHIP'S CALL SIGN)
C
                   IF(KDEC(4) .LE. 14) CALL LETFIG(KCHAR(J))
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C
      IF(NIL .EQ. 1) RETURN

C     CHECK VALUES OF YY GG IW FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C     IF THERE IS AN ERROR IN IW THE  WIND CANNOT BE DECODED .
C
      IF ( KDEC(4).GT.14 )
     C     THEN
               IRET = 0
               IF (KINT(1).LT.1.OR.KINT(1).GT.31)
     C             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
               IF (KINT(3).EQ.2.OR.KINT(3).LT.0.OR.KINT(3).GT.4)
     C             THEN
                       IF (IRET.EQ.0) IRET = 1
                       KINT(3) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
C LAC                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KCHAR(JPT)=OR(KCHAR(JPT),128)
                       IF ( IFIRST.EQ.0 )
     C                      NOER(1,3) = NOER(1,3) + 1
                       IF ( IRET.EQ.2 )
     C                      THEN
                                KERR = 3
                                GO TO 4000
                            END IF
C
                   END IF
           END IF

C***
C*    CONVERT SECTION 1 .
C***
C     IR IX H VV
C
      CALL NEXTPRT ( IPT,IEQ )
      CALL EXTGRP ( IPT,1,1,1,2,0,14,IRET )
C
C     CHECK RANGES OF VALUES.
C
C     IR   1 - 4 OR /

      IF (KINT(14).LT.1.OR.KINT(14).GT.4.AND.
     C                KINT(14).NE.MINDIC) IRET = 1
C
C     IX  1 - 7 OR /
C
      IF (KINT(15).LT.1.OR.KINT(15).GT.7.AND.
     C                KINT(15).NE.MINDIC) IRET = 1
C
      IF (IRET.NE.0 )
     C    THEN
               IPT = IABS(IPT)
C LAC               KCHAR(IPT) = KCHAR(IPT).OR.128
               KCHAR(IPT) = OR(KCHAR(IPT),128)
               KERR = 5
               IF (IFIRST.EQ.0) NOER(1,5) = NOER(1,5) + 1
          END IF

C     IF AUTO REPORT ALTER RDB CODE FIGURE .
C
      IF ( KINT(15).GE.4.AND.KINT(15).LE.7)
     C                  THEN
                            IF (KDEC(4).EQ.11) KDEC(4) =14
                            IF (KDEC(4).EQ.21) KDEC(4) =24
                        END IF

C     N DD FF
C
      CALL NEXTPRT ( IPT,IEQ )
      CALL EXTGRP ( IPT,1,2,2,0,0,18,IRET )
C
C     CHECK RANGE OF VALUES.
C
      IF (KINT(19).LT.0) IRET = 1
      IF (KINT(19).GT.86.AND.KINT(19).NE.99) IRET = 1
      IF (KINT(19).GT.36.AND.KINT(19).LT.51) IRET = 1
      IF (KINT(19).EQ.0.AND.KINT(20).NE.0) IRET = 1
C
C     IF GROUP IS  ///// , N//FF OR N////  IT IS ACCEPTED.
C
      IF (KINT(19).EQ.MINDIC) IRET = 0
C
C     check if ff = 99
C
      if(kint(20).eq.99) then
c
C        LOCATE NEXT GROUP .
C
         CALL NEXTPRT ( IPT,IEQ )
         IF (IPT.GE.IEQ) GO TO 3000
         if(kchar(ipt).eq.48.and.kchar(ipt+1).eq.48) then
            CALL EXTGRP ( IPT,2,3,0,0,0,255,IRET )
         end if
      end if
C
      IF (IRET.NE.0) THEN
                         IPT = IABS(IPT)
C LAC                         KCHAR(IPT) = KCHAR(IPT).OR.128
                         KCHAR(IPT) = OR(KCHAR(IPT),128)
                         KERR = 6
                         IF (IFIRST.EQ.0) NOER(1,6) = NOER(1,6)+1
                     END IF

C     LOCATE NEXT GROUP .
C
      CALL NEXTPRT ( IPT,IEQ )
      IF (IPT.GE.IEQ) GO TO 3000
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 1 ( '1' = 49 ) .
C
      IF ( KCHAR(IPT).EQ.49 )
     C     THEN
C
C              1 SN TTT
C
C              SHIP REPORTS IN REDUCED FORM USE TT/ , SO
C              REPLACE / BY '0' .
C
C              MODIFY RDB CODE FIGURE AS WELL.
C
               IF ( KCHAR(IPT+4).EQ.47 )
     C              THEN
                        KCHAR(IPT+4) = 48
                        IF(KDEC(4).GT.14) KDEC(4) = 23
                    END IF
C
               CALL EXTGRP( IPT,1,1,3,0,0,21,IRET )
C
               IF (KINT(22).LT.0.OR.KINT(22).GT.1) IRET = 1
C
C              IF SN  = / , GROUP IS TREATED AS 1////
C
               IF (KINT(22).EQ.MINDIC) IRET = 0
C
               IF ( IRET.NE.0 )
     C              THEN
                        IPT = IABS(IPT)
C LAC                        KCHAR(IPT)=KCHAR(IPT).OR.128
                        KCHAR(IPT)=OR(KCHAR(IPT),128)
                        KERR = 7
                        IF (IFIRST.EQ.0)  NOER(1,7) =NOER(1,7) + 1
                     END IF
C
                CALL NEXTPRT ( IPT,IEQ )
           END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 2 ( '2' = 50 )
C     FIRST CHECK THAT IT IS NOT START OF SECTION 2.
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.50.AND.KCHAR(IPT+1).NE.50 )
     C     THEN
C
C              2 SN TDTDTD  OR   2 9 UUU
C
C              IF TDTDTD IS IN THE FORM TDTD/ , REPLACE / BY 0 .
C
               IF (KCHAR(IPT+4).EQ.47 ) KCHAR(IPT+4) = 48
C
               CALL EXTGRP ( IPT,1,1,3,0,0,24,IRET )
C
               IF (KINT(25).LT.0.OR.KINT(25).GT.9)IRET=1
               IF (KINT(25).GT.1.AND.KINT(25).LT.9) IRET = 1
C
C              IF SN = / , GROUP IS TREATED AS 2////
C
               IF (KINT(25).EQ.MINDIC) IRET = 0
C
               IF (IRET.NE.0)
     C              THEN
                        IPT = IABS(IPT)
C LAC                        KCHAR(IPT) = KCHAR(IPT).OR.128
                        KCHAR(IPT) = OR(KCHAR(IPT),128)
                        IF (IFIRST.EQ.0)  NOER(1,8) = NOER(1,8)+1
                        KERR = 8
                     END IF
               CALL NEXTPRT ( IPT,IEQ )
           END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 3 ( '3' = 51 )
C     FIRST CHECK THAT IT IS NOT START OF SECTION 3.
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.51.AND.KCHAR(IPT+1).NE.51 )
     C     THEN
C
C              3 POPOPOPO
C
C              IF POPOPOPO IS OF THE FORM POPOPO/ , REPLACE / BY 0.
C
               IF (KCHAR(IPT+4).EQ.47) KCHAR(IPT+4) = 48
C
               CALL EXTGRP( IPT,1,4,0,0,0,27,IRET )
C
               IF (IRET.NE.0)
     C              THEN
                        IPT = IABS(IPT)
C LAC                        KCHAR(IPT)=KCHAR(IPT).OR.128
                        KCHAR(IPT)=OR(KCHAR(IPT),128)
                        KERR = 9
                        IF (IFIRST.EQ.0) NOER(1,9) = NOER(1,9)+1
                    END IF
C
               CALL NEXTPRT ( IPT,IEQ )
           END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 4 ( '4' = 52 )
C     FIRST CHECK THAT IT IS NOT START OF SECTION 4.
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR (IPT).EQ.52.AND.KCHAR(IPT+1).NE.52 )
     C     THEN
C
C              4 P PPP    OR  4 A3 HHH
C
C              SHIP REPORTS IN REDUCED FORM USE PPP/ ,
C              SO REPLACE '/' BY '0' .
C              MODIFY RDB CODE FIGURE AS WELL.
C
               IF ( KCHAR(IPT+4).EQ.47 )
     C              THEN
                        KCHAR(IPT+4) = 48
                        IF(KDEC(4).GT.14) KDEC(4) = 23
                    END IF
C
               CALL EXTGRP( IPT,1,1,3,0,0,29,IRET )
C
               IF ( IRET.NE.0 )
     C              THEN
                        IPT = IABS(IPT)
C LAC                        KCHAR(IPT) = KCHAR(IPT).OR.128
                        KCHAR(IPT) = OR(KCHAR(IPT),128)
                        IF (IFIRST.EQ.0) NOER(1,10)=NOER(1,10)+1
                        KERR = 10
                    END IF
C
               CALL NEXTPRT ( IPT,IEQ )
           END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 5 ( '5' = 53 )
C     FIRST CHECK THAT IT IS NOT START OF SECTION  5.
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.53.AND.KCHAR(IPT+3).NE.32)
     C                    THEN
C
C                             5 A PPP
C
                              CALL EXTGRP ( IPT,1,1,3,0,0,32,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 6 ( '6' = 54 )
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.54 )
     C                    THEN
C
C                             6 RRR TR
C
                              CALL EXTGRP ( IPT,1,3,1,0,0,35,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 7 ( '7' = 55 )
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.55 )
     C                    THEN
C
C                             7 WW W1 W2
C
                              CALL EXTGRP ( IPT,1,2,1,1,0,38,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 8 . ( '8' = 56 )
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.56 )
     C                    THEN
C
C                             8 NH CL CM CH
C
                              CALL EXTGRP ( IPT,1,1,1,1,1,42,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF
C
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 9 . ( '9' = 57 )
C
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.57 )
     C                    THEN
C
C                             9 GGgg
C
                              CALL EXTGRP ( IPT,1,2,2,0,0,47,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C***
C*    CONVERT SECTION 2 .
C***
C     CONVERT 222 GROUP .( '2' = 50 )
C
  900 IF (IPT.GE.IEQ) GO TO 3000
      IF (KCHAR(IPT).NE.50 )
     C                   THEN
C
C                            NOT SECTION 2
C
                             GO TO 1000
                         ELSE
C
C                            222 DS VS
C
                             CALL EXTGRP ( IPT,3,1,1,0,0,50,IRET )
                             CALL NEXTPRT ( IPT,IEQ )
C
C                            ALTER RDB CODE FIGURE IF ABBREVIATED
C                              REPORT ( DSVS = // )
C
                             IF ( KDEC(4).EQ.21.AND.KINT(51).EQ.MINDIC.
     C                           AND.KINT(52).EQ.MINDIC ) KDEC(4) =22
                         END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 0 ( '0' = 48 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.48 )
     C                    THEN

C                              0 SN TWTWTW

                               CALL EXTGRP (IPT,1,1,3,0,0,53,IRET )
                               CALL NEXTPRT ( IPT,IEQ )
                          END IF

C    CONVERT IF GROUP IDENTIFYING FIGURE IS 1 ( '1' = 49 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.49 )
     C                    THEN

C                              1 PWAPWA HWAHWA

                               CALL EXTGRP( IPT,1,2,2,0,0,56,IRET )
                               CALL NEXTPRT ( IPT,IEQ )
                           END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 2 ( '2' = 50 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.50 )
     C                    THEN

C                             2 PWPW HWHW

                              CALL EXTGRP( IPT,1,2,2,0,0,59,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 3 ( '3' = 51 )
C     FIRST CHECK IF START OF SECTION 3 .

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.51.AND.KCHAR(IPT+3).NE.32)
     C                    THEN

C                              3 DW1DW1 DW2DW2

                               CALL EXTGRP ( IPT,1,2,2,0,0,62,IRET)
                               CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 4 ( '4' = 52 )
C     FIRST CHECK IF START OF SECTION 4 .

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.52.AND.KCHAR(IPT+3).NE.32)
     C                    THEN

C                             4 PW1PW1 HW1HW1

                              CALL EXTGRP ( IPT,1,2,2,0,0,65,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 5 ( '5' = 53 )
C     FIRST CHECK IF START OF SECTION 5 .

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.53.AND.KCHAR(IPT+3).NE.32)
     C                    THEN

C                             5 PW2PW2 HW2HW2

                              CALL EXTGRP ( IPT,1,2,2,0,0,68,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 6 ( '6' = 54 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.54 )
     C                    THEN

C                             6 IS ESES RS

                              CALL EXTGRP ( IPT,1,1,2,1,0,71,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 70 ( '7' = 55 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.55.AND.KCHAR(IPT+1).EQ.48 ) THEN

C          70HwaHwaHwa

           CALL EXTGRP(IPT,2,3,0,0,0,250,IRET)
           CALL NEXTPRT ( IPT,IEQ )
      END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 8 ( '8' = 56 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.56) THEN

C          8swTbTbTb

           CALL EXTGRP(IPT,1,1,3,0,0,252,IRET)
           CALL NEXTPRT ( IPT,IEQ )
      END IF

C     CHECK FOR 'ICE' INDICATOR.

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.73 )
     C                    THEN

C                             ICE , SO SET FLAG.

                              KINT(75) = 1
                              IPT =IPT + 3
                              CALL NEXTPRT( IPT,IEQ )

C                             CI SI BI DI ZI

                              CALL EXTGRP ( IPT,1,1,1,1,1,76,IRET )
                              CALL NEXTPRT (IPT,IEQ)
                          END IF
C***
C*    CONVERT SECTION 3.
C***

 1000 IF (IPT.GE.IEQ) GO TO 3000
      IF (KCHAR(IPT).NE.51)
     C                    THEN

C                             NOT SECTION 3

                              GO TO 2000
                          ELSE

C                             333 GROUP

                              CALL EXTGRP ( IPT,3,0,0,0,0,81,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 0 ( '0' = 48 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.48 )
     C                    THEN
                              IF ( KDEC(17).EQ.1 )
     C                               THEN
C                                        REGION 1
C                                        O  TGTG  RC  RT
                                         CALL EXTGRP
     C                                      (IPT,1,2,1,1,0,82,IRET)
                                         CALL NEXTPRT(IPT,IEQ)
                                     ELSE
C                                        REGION 4
C                                        0  CS  DL  DM  DH
                                         CALL EXTGRP
     C                                       (IPT,1,1,1,1,1,82,IRET)
                                         CALL NEXTPRT(IPT,IEQ)
                                     END IF
                        END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 1 ( '1' = 49 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.49 )
     C                    THEN

C                             1 SN TXTXTX

                              CALL EXTGRP ( IPT,1,1,3,0,0,87,IRET )
                              CALL NEXTPRT( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 2 ( '2' = 50 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.50 )
     C                    THEN
     
C                             2 SN TNTNTN

                              CALL EXTGRP ( IPT,1,1,3,0,0,90,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 3 ( '3' = 51 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.51 )
     C                    THEN

C                             3 E SN TGTG

                              CALL EXTGRP ( IPT,1,1,1,2,0,93,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 4 ( '4' = 52 )
C     FIRST CHECK IF START OF SECTION 4 .

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.52.AND.KCHAR(IPT+3).NE.32)
     C                    THEN

C                             4  E'  SSS

                              CALL EXTGRP (IPT,1,1,3,0,0,98,IRET)
                              CALL NEXTPRT (IPT,IEQ)
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 5 ( '5' = 53 )
C     FIRST CHECK IF START OF SECTION 5 .

 1050 IF (IPT.GE.IEQ) GO TO 3000
      IF (KCHAR(IPT).EQ.53.AND.KCHAR(IPT+3).NE.32) THEN
C
C        5  ?
C
         CALL EXTINT (IPT,1,101)
         CALL EXTINT (IPT,1,102)
         IF(IPT.LT.0) THEN
            IPT=IABS(IPT)
C
C           SKIP PROBLEM GROUP
C
            CALL NEXTPRT(IPT,IEQ)
            CALL NEXTSEP(IPT,IEQ)
            GO TO 1050
         END IF
         CALL EXTINT (IPT,1,103)
         IF(IPT.LT.0) THEN
            IPT=IABS(IPT)
C
C           SKIP PROBLEM GROUP
C
            CALL NEXTPRT(IPT,IEQ)
            CALL NEXTSEP(IPT,IEQ)
            GO TO 1050
         END IF
         IPT = IABS(IPT)
         IPT = IPT-3
         IC1=KINT(101)
         IC2=KINT(102)
         IC3=KINT(103)
C
C        IF ? IS 8 OR9  P24P24P24
C
         IF (IC2.EQ.8) THEN
             CALL EXTGRP (IPT,1,1,3,0,0,233,IRET)
             CALL NEXTPRT (IPT,IEQ)
         END IF
         IF (IC2.EQ.9) THEN
             CALL EXTGRP (IPT,1,1,3,0,0,236,IRET)
             CALL NEXTPRT (IPT,IEQ)
         END IF
C
C        IF ? IS 4 , 6 OR 7 THEN PARAMS ARE
C        GO SN DT , DL DM DH OR C DA EC . USE
C        DEPENDS ON REGION.
C
C              54 g0 Sn dT (TEMPERATURE CHANGE DATA IN PERIOD COV. BY W1W2
C
         IF (IC2.EQ.4) THEN
            CALL EXTGRP(IPT,1,1,1,1,1,184,IRET)
            CALL NEXTPRT (IPT,IEQ)
         END IF
C
C              56 DL DM DH   DIRECTION ON CLOUD DRIFT
C
         IF (IC2.EQ.6) THEN
            CALL EXTGRP(IPT,1,1,1,1,1,223,IRET)
            CALL NEXTPRT (IPT,IEQ)
         END IF
C
C              57 C Da eC   DIRECTION AND ELEVATION OF CLOUD
C
         IF (IC2.EQ.7) THEN
            CALL EXTGRP(IPT,1,1,1,1,1,228,IRET)
            CALL NEXTPRT (IPT,IEQ)
         END IF
C
C        IF ? IS 5  SSS  (SUNSHINE)
C
         IF (IC2.EQ.5.AND.IC3.NE.3) THEN
            CALL EXTGRP(IPT,1,1,3,0,0,189,IRET)
            CALL NEXTPRT (IPT,IEQ)
C
C               RADIATION DATA
C
            IF(KCHAR(IPT).EQ.48) THEN
C
C              POSITIVE NET RADIATION DURING THE PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,192,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.49) THEN
C
C              NEGATIVE NET RADIATION DURING THE PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,194,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.50) THEN
C
C              GLOBAL SOLAR RADIATION DURING THE PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,196,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.51) THEN
C
C              DIFFUSED SOLAR RADIATION DURING PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,198,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.52) THEN
C
C              DOWNWARD LONG WAVE RADIATION DURING PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,200,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.53) THEN
C
C              UPWARD LONG WAVE RADIATION DURING PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,202,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.54) THEN
C
C              SHORT WAVE RADIATION DURING PRECEDING 24 H
C
               CALL EXTGRP(IPT,1,4,0,0,0,204,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
         END IF
         IF (IC2.EQ.5.AND.IC3.EQ.3) THEN
            CALL EXTGRP(IPT,1,2,2,0,0,206,IRET)
            CALL NEXTPRT (IPT,IEQ)
C
C               RADIATION DATA
C
            IF(KCHAR(IPT).EQ.48) THEN
C
C              POSITIVE NET RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,209,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.49) THEN
C
C              NEGATIVE NET RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,211,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.50) THEN
C
C              GLOBAL SOLAR RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,213,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.51) THEN
C
C              DIFFUSED SOLAR RADIATION DURING THE PREVIOUS HOUR 
C
               CALL EXTGRP(IPT,1,4,0,0,0,215,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.52) THEN
C
C              DOWNWARD LONG WAVE RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,217,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.53) THEN
C
C              UPWARD LONG WAVE RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,219,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
            IF(KCHAR(IPT).EQ.54) THEN
C
C              SHORT WAVE RADIATION DURING THE PREVIOUS HOUR
C
               CALL EXTGRP(IPT,1,4,0,0,0,221,IRET)
               CALL NEXTPRT (IPT,IEQ)
            END IF
         END IF
C
C        IF ? IS 0,1,2,3 OR EEEIE (EVAPOTRANSPIRATION)
C
         IF(IC2.GE.0.AND.IC2.LE.3.OR.IC2.EQ.MINDIC) THEN
            CALL EXTGRP(IPT,1,3,1,0,0,181,IRET)
            CALL NEXTPRT (IPT,IEQ)
         END IF
C
C        SKIP GROUP IF SECOND CHARACTER INVALID.
C
         IF(IC2.LT.0.OR.IC2.GT.9.AND.IC2.NE.MINDIC) THEN
            IPT = IPT + 5
            CALL NEXTPRT (IPT,IEQ)
         END IF
C
C        INTERMEDIATE FORMAT ACCOMMODATES ONLY 1
C        5-GROUP . OVERWRITE IF A SECOND GROUP.
C
         IF ( KCHAR(IPT).EQ.53 ) GO TO 1050
C
      END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 6 ( '6' = 54 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.54 )
     C                    THEN

C                             6  RRR  TR

                              CALL EXTGRP ( IPT,1,3,1,0,0,113,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF

C     CONVERT IF GROUP IDENTIFYING FIGURE IS 7 ( '7' = 55 )

      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.55 )
     C                    THEN
C
C                             7  R24R24R24R24
C
                              CALL EXTGRP ( IPT,1,4,0,0,0,116,IRET )
                              CALL NEXTPRT ( IPT,IEQ )
                          END IF
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 8 ( '8' = 56 )
C     CAN ACCEPT UP TO 4 SUCH GROUPS.
C
      N = 121
      DO 1100 I=1,4
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.56 )
     C                    THEN
C
C                             8 NS C HSHS
C
                              CALL EXTGRP (IPT,1,1,1,2,0,N,IRET)
                              N = N + 4
                              CALL NEXTPRT (IPT,IEQ)
                          END IF
 1100 CONTINUE
C
C
C     CONVERT IF GROUP IDENTIFYING FIGURE IS 9 ( '9' = 57 )
C     CAN BE UP TO 4 SUCH GROUPS.
C
      N = 137
      DO 1200 I=1,4
      IF (IPT.GE.IEQ) GO TO 3000
      IF ( KCHAR(IPT).EQ.57 )
     C                    THEN
C
C                             9  SPSP  SPSP
C
                              CALL EXTGRP ( IPT,1,2,2,0,0,N,IRET )
                              N = N + 3
                              CALL NEXTPRT ( IPT,IEQ )
                         END IF
 1200 CONTINUE
C
C***
C*    CONVERT SECTION 4.
C***
 2000 IF (IPT.GE.IEQ) GO TO 3000
      IF (KCHAR(IPT).NE.52)
     C                   THEN
C
C                            NOT SECTION 4
C
                             GO TO 3000
                         ELSE
C
C                            444 N' C' H'H' TT
C
                             CALL EXTINT (IPT,3,149)
                             CALL NEXTPRT ( IPT,IEQ )
                             CALL EXTGRP (IPT,1,1,2,2,0,150,IRET)
                             CALL NEXTPRT ( IPT,IEQ )
                         END IF
C***
C*    SECTION 5 . NATIONAL GROUPS NOT USED.
C***
C     ERROR IF NOT SECTION 5 AND NOT END OF REPORT.

 3000 IF (KCHAR(IPT).NE.53.AND.IPT.LT.IEQ)
     C    THEN
              KERR = 60
C LAC              KCHAR(IEQ) = KCHAR(IEQ).OR.128
              KCHAR(IEQ) = OR(KCHAR(IEQ),128)
              IF (IFIRST.EQ.0) NOER(1,60) = NOER(1,60) + 1
          END IF
C***
C*    ERROR CHECKING AND HANDLING.
C***
C     RETURN IF NO ERROR IN REPORT.
C
 4000 IF ( KERR.EQ.0 ) RETURN
C
C     IF FIRST DECODING ATTEMPT , TRY TO CORRECT ERROR AND DECODE
C     AGAIN.
C
      IF ( IFIRST.EQ.0 ) THEN
                        IPT = KEEP
                        CALL FIXSM
                        IFIRST = 1
                        GO TO 10
                    ELSE
                        CALL SAVREP( IHEAD,IERR )
C
C
C                       CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                        DO 4100 I=KEEP,IGS
C LAC                        KCHAR(I) = KCHAR(I) .AND. 127
                        KCHAR(I) = AND(KCHAR(I),127)
4100                    CONTINUE
C
C                       ONLY REPORTS WITH ERROR IN DATE/TIME OR
C                       LAT/LONG ARE NOT PROCESSED FURTHER.
C
c                       IF (KERR.GT.4) KERR = 0
                        if(kerr.gt.4) then
                          kerr = 0
c                         ierr = 0
                        end if
c
                        RETURN
                    END IF
C
      END
      
      SUBROUTINE FIXSM
C
C**** *FIXSM*
C
C
C     PURPOSE.
C     --------
C
C
C         *CALL* *FIXSM*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CLEAR PARITY BITS.
C                -----------------
 100  CONTINUE
C
      DO 101 I=IPT,IGS
C LAC         KCHAR(I) = KCHAR(I).AND.127
         KCHAR(I) = AND(KCHAR(I),127)
  101 CONTINUE
C
      ICOR = 0
C
      CALL REMEEE
C
C*    TEST IF SEA STATION REPORT.
C
      IF ( KDEC(4).GT.14 ) GO TO 5000
C
C*    CLEAR SPURIOUS SM CHARACTERS FROM KWBC REPORTS
C
C
      K = IPT + 10
      DO 200 I=IPT,K
         IF ( KCHAR(I).EQ.32.AND.KCHAR(I+1).EQ.83.AND.KCHAR(I+2).
     C      EQ.77.AND.KCHAR(I+3).EQ.32)
     C           THEN
C---                 WRITE (*,9901) ICOR
C---                 CALL PRTBULL (IPT,IEQ)
                     KCHAR(I+1) = 32
                     KCHAR(I+2) = 32
                     ICOR = 1
                 END IF
C
  200 CONTINUE
C
C
C*    SOME CENTRES USE '333' GROUP IN THE FORM '333//'
C
C
      DO 250 I=IPT,IEQ
         IF ( KCHAR(I).EQ.51.AND.KCHAR(I+1).EQ.51.AND.KCHAR(I+2).
     C      EQ.51.AND.KCHAR(I+3).EQ.47.AND.KCHAR(I+4).EQ.47)
     C           THEN
C---                 WRITE (*,9901) ICOR
C---                 CALL PRTBULL (IPT,IEQ)
                     KCHAR(I+3) = 32
                     KCHAR(I+4) = 32
                     ICOR = 1
                 END IF
  250 CONTINUE
C
C
C*    FIXUP COMMON ERRORS IN IIIII GROUP FROM LAND STATIONS.
C
C
C     REMOVE EXTRA CHARACTER PRECEDING IIIII IN REPORTS FROM
C     MXKF,AMMC,NZKL AND EESA.
C
      K = IPT+5
      DO 300 I=IPT,K
         IF ( KCHAR(I).GE.48.AND.KCHAR(I).LE.57) GO TO 350
         IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 350
         IF (KCHAR(I).EQ.32) GO TO 300
C--      WRITE (*,9901) ICOR
C--      CALL PRTBULL (IPT,IEQ)
         ICOR = 2
         KCHAR(I) = 32
  300 CONTINUE
  350 IF (ICOR.EQ.2) CALL NEXTPRT (IPT,IEQ)
C
C     ADD II OF 03 TO U.K. REPORTS FROM CENTRES OTHER THAN EGRR.
C
      K = IAH + 4
      CALL NEXTLET (K,JAH)
      IF (KCHAR(K).EQ.69.AND.KCHAR(K+1).EQ.71)
     C          THEN
                    IF (KCHAR(K+2).EQ.82.AND.KCHAR(K+3).EQ.82)
     C                THEN
C----                     WRITE (*,9901) ICOR
C----                     CALL PRTBULL (IPT,IEQ)
                          IPT = IPT - 2
                          KCHAR(IPT) = 48
                          KCHAR(IPT+1) = 51
                          ICOR = 3
                      END IF
                END IF
C
C
C     REMOVE ANY EXTRA SHORT GROUPS BEFORE IIIII
C
      K = IPT
      CALL NEXTVAL (K,32,IEQ)
      K = K - IPT
      IF (K.LE.3) THEN
C--                   WRITE (*,9901) ICOR
C--                   CALL PRTBULL (IPT,IEQ)
                      IPT = K+ IPT
                      CALL NEXTPRT (IPT,IEQ)
                      ICOR = 4
                  END IF
C***
C*    COMMON FORMAT ERRORS IN REPORTS FROM SOUTH AMERICA
C     AND AFRICA

      DO 400 K=IPT,IEQ
C
C          $,],:,*,V OR ? INSTEAD OF = AT END OF REPORT
C         IF ANY OF THESE CHARACTERS IS FOLLOWED BY LF IT IS
C         REPLACED BY = .
C
           IF (KCHAR(K).EQ.36.OR.KCHAR(K).EQ.93.OR.KCHAR(K)
     C        .EQ.58.OR.KCHAR(K).EQ.42.OR.KCHAR(K).EQ.86
     C        .OR.KCHAR(K).EQ.63.AND.KCHAR(K+1).EQ.13)
     C           THEN
C--                  WRITE (*,9901) ICOR
C--                  CALL PRTBULL (IPT,IEQ)
                     KCHAR(K) = 61
                     ICOR = 5
                 END IF
C
C          = SIGN MISSING AT END OF NIL REPORTS
C
           IF (KCHAR(K).EQ.76.AND.KCHAR(K+1).EQ.13)
     C           THEN
C--                  WRITE (*,9901) ICOR
C--                  CALL PRTBULL (IPT,IEQ)
                     KCHAR(K) = 61
                     ICOR = 6
                 END IF
C
C          - INSTEAD OF SPACE
C
           IF (KCHAR(K).EQ.45)
     C           THEN
C--                  WRITE (*,9901) ICOR
C--                  CALL PRTBULL (IPT,IEQ)
                     KCHAR(K) = 32
                     ICOR = 7
                 END IF
C
C          $ INSTEAD OF =
C
           IF (KCHAR(K).EQ.36)
     C           THEN
C--                  WRITE (*,9901) ICOR
C--                  CALL PRTBULL (IPT,IEQ)
                     KCHAR(K) = 61
                     ICOR = 8
                 END IF
C
C
  400 CONTINUE
C
C     RESET POINTER TO END OF REPORT
C
      IEQ = IPT
      CALL NEXTEQ (IEQ,IGS)
C
C
C     IF NO END OF REPORT HAS BEEN FOUND INSERT = AT END OF
C     LINE . THIS ENSURES THAT AT LEAST SECTION 1 OF REPORTS IS
C     DECODED.
C
C     IF THE REPORT IS LONGER THAN 144 CHARACTERS = IS ALSO
C     PRESUMED MISSING.
C
      LEN = IEQ - IABS(IPT)
C
      IF (IEQ.GE.IGS.OR.LEN.GE.144)
     C      THEN
C--           WRITE (*,9901) ICOR
C--           CALL PRTBULL (IPT,IEQ)
              K = IPT
              CALL NEXTEND (K,IGS)
              IEQ = K
              KCHAR(K) = 61
              ICOR = 9
C
            END IF
 5000 CONTINUE
      IF (ICOR.EQ.0) RETURN
      IF (ICOR.EQ.3) RETURN
      
C--   CALL PRTBULL (IPT,IEQ)
C--   WRITE (*,9901)ICOR
C
c 9901 FORMAT (1H ,'***************',I3,' *********************')

      RETURN
      END
      
      SUBROUTINE ICHWHW(IN,MINDIC,OUT)
C
C****
C*
C*    NAME     : ICHWHW
C*
C*    FUNCTION :  DECODE THE HEIGHT OF WAVES IN DECIMETERS.
C*
C*    INPUT    :  IN      - CODE FIGURE FOR THE HEIGHT
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUT     - DECODED HEIGHT
C*
C*             OUT IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN IN
C*
C****
C
      INTEGER OUT
C
C***   SET MISSING VALUE
C
      OUT=MINDIC
C
      IF(IN .EQ. MINDIC) RETURN
C
      OUT=IN*5
C
      RETURN
      END
      
      SUBROUTINE IC2700(ICODE,ICOVER)
C
C**** *IC2700*
C
C
C     PURPOSE.
C     --------
C         TO CONVERT CODE TABLE 2700 INTO PERCENTAGE CLOUD COVERAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC2700(ICODE,ICOVER)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ICT(10),IPR(10)
      DATA ICT/ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA IPR/ 0,10,25,40,50,60,75,90,100,999999/
C
C     ------------------------------------------------------------------
C*          1.   CONVERT CLOUD COVERAGE IN OKTAS INTO PERCENTAGE.
C                ------------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,10
C
      IF(ICODE.EQ.ICT(I)) THEN
                             ICOVER=IPR(I)
                             GO TO 200
                          END IF
 101  CONTINUE
C
      ICOVER=999999
C
 200  CONTINUE
      RETURN
      END 
      
      SUBROUTINE IC1751(ICODE,ICOVER)
C
C**** *IC1751*
C
C
C     PURPOSE.
C     --------
C         TO CONVERT CODE TABLE 1751 INTO BUFR TABLE 20033.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC1751(ICODE,ICOVER)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ICT(5),IPR(5)
      DATA ICT/  1, 2, 3, 4, 5/
      DATA IPR/  1, 2, 3, 4, 5/
C
C     ------------------------------------------------------------------
C*          1.   CONVERT CLOUD COVERAGE IN OKTAS INTO PERCENTAGE.
C                ------------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,5 
C
      IF(ICODE.EQ.ICT(I)) THEN
                             ICOVER=IPR(I)
                             GO TO 200
                          END IF
 101  CONTINUE
C
      ICOVER=999999
C
 200  CONTINUE
C
      RETURN
      END
       
      SUBROUTINE IC3551(ICODE,ICOVER)
C
C**** *IC3551*
C
C
C     PURPOSE.
C     --------
C         TO CONVERT CODE TABLE 3551 INTO BUFR TABLE 20032.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC3551(ICODE,ICOVER)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ICT( 5),IPR( 5)
      DATA ICT/ 0, 1, 2, 3, 4/
      DATA IPR/ 0, 1, 2, 3, 4/
C
C     ------------------------------------------------------------------
C*          1.   CONVERT CLOUD COVERAGE IN OKTAS INTO PERCENTAGE.
C                ------------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,5 
C
      IF(ICODE.EQ.ICT(I)) THEN
                             ICOVER=IPR(I)
                             GO TO 200
                          END IF
 101  CONTINUE
C
      ICOVER=999999
C
 200  CONTINUE
      RETURN
      END
       
      SUBROUTINE IC639(ICODE,ICOVER)
C
C**** *IC639*
C
C
C     PURPOSE.
C     --------
C         TO CONVERT CODE TABLE 639 INTO BUFR TABLE 20034.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC639(ICODE,ICOVER)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ICT(10),IPR(10)
      DATA ICT/ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA IPR/ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9/
C
C     ------------------------------------------------------------------
C*          1.   CONVERT CLOUD COVERAGE IN OKTAS INTO PERCENTAGE.
C                ------------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,10
C
      IF(ICODE.EQ.ICT(I)) THEN
                             ICOVER=IPR(I)
                             GO TO 200
                          END IF
 101  CONTINUE
C
      ICOVER=999999
C
 200  CONTINUE
C
      RETURN
      END 
      
      SUBROUTINE ICPWPW(IN,MINDIC,OUT)
C
C****
C*
C*    NAME     : ICPWPW
C*
C*    FUNCTION :  DECODE THE PERIOD OF WAVES IN SEC
C*
C*    INPUT    :  IN      - CODE FIGURE FOR THE PERIOD
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUT     - THE DECODED PERIOD
C*
C*             OUT IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN IN
C*
C****
C
      INTEGER OUT
C
C***   SET MISSING VALUE
C
      OUT=MINDIC
C
      IF(IN .EQ. MINDIC) RETURN
C
      OUT= IN
      IF(IN .EQ. 99) OUT=126
C
      RETURN
      END
      
      SUBROUTINE ICTRTR (ICOUNT,IREG,KTR,IHOURS,MINDIC,ITR)
C****
C*
C*    NAME     : ICTRTR
C*
C*    FUNCTION :  DETERMINE DURATION OF RAINFALL . REGIONAL AND
C*                NATIONAL PRACTICES ARE HANDLED.
C*
C*    INPUT    :  IREG   : WMO REGION NUMBER
C*                ICOUNT : WMO COUNTRY NUMBER
C*                KTR    : CODE FIGURE FOR 'TR'
C*                IHOURS : REPORT TIME (HOURS)
C*                MINDIC : MISSING DATA VALUE
C*
C*    OUTPUT   :  ITR    :  MEASUREMENT PERIOD FOR RAINFALL (HOURS)
C*
C*                       ITR IS SET TO MISSING VALUE
C*                       IF ANY ERRORS IN IREG OR IHOURS
C*
C***
C
      DIMENSION IDURAT(28)
C
      DATA IDURAT / 6, 24,  6, 12, 12, -9, 12, -9,
     *              6,  6, 24,  6,  6,  6,  6,  6,
     C             24,  6,  6,  6,  6, 12,  6, 12,
     C             24,  6, 12, 18 /
C
C
C
C***   SET MISSING VALUE
C
      ITR=MINDIC
C
C
      IF (IREG.LT.1.OR.IREG.GT.7) RETURN
      IF(IHOURS .LT. 0 .OR. IHOURS .GT. 24) RETURN
C
C***
C*    VALID 'TR' CODE FIGURE REPORTED.
C***
C
      IF (KTR.NE.MINDIC) THEN
                             ITR = KTR * 6
                             RETURN
                         END IF
C
C***
C*    NO 'TR' FIGURE . GROUP MAY HAVE BEEN OMITTED BECAUSE RRR = 0
C*    OR BECAUSE NATIONAL PRACTICE IS TO CODE A / .
C***
C
C     ARRAY IDURAT IS USED TO DEFINE THE PERIOD FOR
C     DIFFERENT REGIONS AND DIFFERENT REPORT TIMES
C
C
C      REGION I     00 & 12 Z        6
C                      18 Z         12
C                      06 Z         24
C      REGION II    00 & 12 Z       12
C                   06 & 18 Z     MINDIC
C      REGION III   00&06&12 Z       6
C                      12 Z         24
C      REGION IV       ALL           6
C      REGION V        00 Z         24
C                   06&12&18 Z       6
C      REGION VI    00 & 12 Z        6
C                   06 & 18 Z       12
C
C
C     SOME OBSERVATIONS ARE MADE + OR - 1 HOUR FROM STANDARD
C     MAIN HOURS.
C
      K = IHOURS
      IF ( K.EQ.1.OR.K.EQ.23 ) K = 0
      IF ( K.EQ.7.OR.K.EQ.5  ) K = 6
      IF ( K.EQ.13.OR.K.EQ.11) K = 12
      IF ( K.EQ.19.OR.K.EQ.17) K = 18
C
C     IND IS THE INDEX TO DEFINE THE REGION AND REPORT TIME
C
      IND=(IREG-1)*4 + K/6 +1
C
C
C     SOME COUNTRIES IN REGION 2 HAVE NATIONAL PRACTICES.
C
      IF ( IREG.NE.2 ) THEN
                           ITR = IDURAT(IND)
                           RETURN
                       END IF
C***
C*    REGION 2 NATIONAL PRACTICES.
C***
C
C     SAUDI ARABIA . 'TR' ALWAYS REPORTED AS / . PERIOD IS 12 HOURS.
C     COUNTRY NUMBER IS 020 ( REGION 2 ).
C
      IF ( ICOUNT.EQ.20 ) THEN
                                 ITR = 12
                                 RETURN
                             END IF
C
C     CHINA . PERIOD IS ALWAYS 6 HOURS.
C     COUNTRY NUMBER IS 250 ( REGION 2 ).
C
      IF ( ICOUNT.EQ.250 ) THEN
                                 ITR = 6
                                 RETURN
                             END IF
C
C     INDIA AND SRI LANKA . PERIOD IS FROM 0300.
C     COUNTRY NUMBERS FOR INDIA ARE 100 AND 110 AND FOR SRI LANKA 120.
C
      IF ( ICOUNT.GE.100.AND.ICOUNT.LE.120 )
     C     THEN
               ITR = IHOURS - 3
               IF (ITR.LE.0) ITR = ITR + 24
               RETURN
           END IF
C***
C*    REGION 2 REGIONAL PRACTICE.
C***
      IF(IDURAT(IND) .EQ. -9) RETURN
      ITR=IDURAT(IND)
C
      RETURN
      END
      
      SUBROUTINE IC0264(INA3,MINDIC,OUTA3)
C****
C*
C*    NAME     : IC0264
C*
C*    FUNCTION :  DECODE THE INDICATOR OF STANDARD ISOBARIC
C*                SURFACE A3 IN HECTOPASCAL
C*
C*    INPUT    :  INA3    - CODE FIGURE FOR A3
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTA3   - DECODED A3
C*
C*             OUTA3 IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INA3
C*
C****
C
      INTEGER OUTA3
C
C***   SET MISSING VALUE
C
      OUTA3=MINDIC
C
      IF(INA3 .EQ. MINDIC) RETURN
      IF(INA3 .LE. 0 .OR. INA3 .GE. 9) RETURN
C
      GO TO (100,900,1000,1000,500,900,700,850) INA3
C
100   OUTA3=1000
      RETURN
C
500   OUTA3=500
      RETURN
C
700   OUTA3=700
      RETURN
C
850   OUTA3=850
      RETURN
C
900   OUTA3=925
      RETURN
C
1000  RETURN
C
      END
      
      SUBROUTINE IC0700(INDD,MINDIC,OUTDD)
C
C****
C*
C*    NAME     : IC0700
C*
C*    FUNCTION :  DECODE THE DIRECTION FROM WHICH SURF. WIND IS
C*                BLOWING, OR THE DIRECTION OF THE SHIP (D,DS,...)
C*
C*    INPUT    :  INDD    - DIRECTION CODE FIGURE
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTDD  - DECODED DIRECTION IN DEGREES
C*
C*             OUTDD IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INDD
C*
C****
C
      INTEGER OUTDD
C
C
      DIMENSION IDIR(9)
C
      DATA IDIR/0,45,90,135,180,225,270,315,360/
C
C***   SET MISSING VALUE
C
      OUTDD=MINDIC
C
      IF(INDD .LT. 0 .OR. INDD .GT. 8) RETURN
C
      OUTDD=IDIR(INDD+1)
C
      RETURN
      END
      
      SUBROUTINE IC0777(IDD,ITEMP,MINDIC,IDEWPT)
C
C****
C*
C*    NAME     :  IC0777
C*
C*    FUNCTION :  DECODE DEW-POINT TEMPERATURE IN TENS OF DEGREE
C*
C*    INPUT    :  IDD     - DEW-POINT EPRESSION
C*             :  ITEMP   - TEMPERATURE
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  IDEWPT  - DECODED DEW-POINT TEMPERATURE
C*
C*             IDEWPT IS SET TO MISSING VALUE IF
C*             ANY ERRORS FOUND IN IDD
C*
C*   A.HOLOPAINEN  JAN.83
C*
C***   CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC) RETURN
C
      IF(ITEMP .EQ. MINDIC) RETURN
C
C     CHECK THE RANGE OF IDD
C
      IF(IDD .LT. 0 .OR. IDD .GT. 99) RETURN
C
      IF(IDD .GT. 51 .AND. IDD .LE. 55) RETURN
c
      IDEW=IDD
      IF(IDD .GE. 56) IDEW=10 * (IDD - 50)
C
      IDEWPT=ITEMP - IDEW
      RETURN
      END
      
      SUBROUTINE IC0877(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C****
C*
C*    NAME     :  IC0877
C*
C*    FUNCTION :  DECODE WIND DIRECTION AND SPEED
C*
C*    INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C*             :  IFF     - WIND SPEED
C*             :  IWW     - WIND SPEED INDICATOR , CODE TABLE 1855
C*             :  ICOUNT  - COUNTRY NUMBER
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C*                ISPEED  - DECODED WIND SPEED
C*
C*             IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C*             ANY ERRORS FOUND IN IDD, IFF OR IWW
C*
C****
C
C***   SET MISSING VALUE
C
      IDIR=MINDIC
      ISPEED=MINDIC

C***   CHECK MISSING DATA INDICATOR
C
      IF(IWW .EQ. MINDIC .OR. IDD .EQ. MINDIC .OR.
     1   IFF .EQ. MINDIC) RETURN
C
C     CHECK IF WIND INDICATOR IR IS CORRECT
C
      IF(IWW .NE. 0 .AND. IWW .NE. 1 .AND. IWW .NE. 3
     1  .AND. IWW .NE. 4) RETURN
C
C
C     IW IS THE MODIFIED WIND SPEED INDICATOR TO MAKE
C     IF-STATEMENTS SHORTER
C        IW=0 FOR METER/SEC
C        IW=1 FOR KNOTS
C
      IW=(IWW-1)/2
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C
C
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
C     CHECK IF SHIP OR BUOY, BECAUSE THEN THERE IS NO COUNT NUMBER
C
      IF(ICOUNT .EQ. MINDIC)
     *    THEN
             IF(IDIR .GT. 50 .AND. IDIR .NE. 99) ISPEED=ISPEED+100
             GO TO 100
          END IF
C
C
C     CHECK IF THE DATA IS FROM U.S.S.R.
C
      IF(ICOUNT .EQ. 6310 .OR. ICOUNT .EQ. 2010)
     1        THEN
                   IF(ISPEED .EQ. 77) ISPEED=20
                   IF(ISPEED .EQ. 88) ISPEED=40
                 ELSE
                   IF(IDIR .GT. 50 .AND. IDIR .NE. 99) ISPEED=ISPEED+100
              END IF
C
100   CONTINUE
C
C     IF SPEED IN KNOTS MODIFY TO M/S
C
      IF(IW .EQ. 1) CALL KTOMPSI(ISPEED)
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      RETURN
      END
      
      SUBROUTINE IC1600(INHEI,LOWEST,MINDIC,OUTHEI)
C
C****
C*
C*    NAME     :  IC1600
C*
C*    FUNCTION :  DECODE THE HEIGHT OF LOWEST CLOUDS
C*
C*    INPUT    :  INHEI   - CODE FIGURE FOR THE HEIGHT
C*                LOWEST  - INDICATOR FOR LOWEST CLOUD
C*                          0 = LOW CLOUD
C*                          1 = MEDIUM CLOUD
C*                          2 = HIGH CLOUD
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTHEI  - DECODED HEIGHT OF LOWEST CLOUDS IN METRES
C*
C*             OUTHEI SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INHEI
C*
C****
C
      INTEGER OUTHEI
C
      DIMENSION IHEIGHT(12)
C
      DATA IHEIGHT/25,75,150,250,450,800,1250,1750,2250,2600,3500,8000/
C
C***   SET MISSING VALUE
C
      OUTHEI=MINDIC
C
C***   TEST THE VALIDITY OF THE CODE FIGURE
C
      IF(INHEI .EQ. MINDIC .OR. LOWEST .EQ. MINDIC) RETURN
C
      IF(INHEI .LT. 0 .OR. INHEI .GT. 9) RETURN
C
C
C     FOR N = 9 DEFAULT HEIGHTS ARE ALLOCATED DEPENDING ON
C     WHETHER LOWEST CLOUD IS LOW, MEDIUM OR HIGH.
C
      IF ( INHEI.NE.9 ) LOWEST = 0
C
      IND=INHEI + 1 + LOWEST
      OUTHEI=IHEIGHT(IND)
      RETURN
      END
      
      SUBROUTINE IC1677(ICODE,MINDIC,IHEIGHT)
C
C****
C*    NAME     : IC677
C*
C*    FUNCTION :  DECODE THE HEIGHT OF THE BASE OF THE
C*                LOWEST CLOUD  HH OR HSHS
C*
C*    INPUT    :  ICODE    CODE NUMBER FOR THE HEIGHT
C*                MINDIC   MISSING DATA VALUE
C*
C*    OUTPUT   :  IHEIGHT   DECODED HEIGHT IN METRES
C*
C*             IHEIGHT SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN ICODE
C*
C****
C
      DIMENSION IHSHS(9)
C
      DATA IHSHS/25,75,150,250,450,800,1250,1750,2250/
      
C***  SET MISSING VALUE
C
      IHEIGHT=MINDIC
C
      IF(ICODE .LT. 0 .OR. ICODE .GT. 98) RETURN
c
      IF(ICODE .EQ. 89) THEN
                 IHEIGHT=22000
                 RETURN
                 END IF
c
      IF(ICODE .LE. 50) THEN
                 IHEIGHT=ICODE*30+15
                 IF(IHEIGHT .LT. 0) IHEIGHT=0
                 RETURN
                 END IF
C
      IF(ICODE .GE. 56 .AND. ICODE .LE. 80) THEN
                 IHEIGHT=(ICODE-50)*300+150
                 RETURN
                 END IF
C
      IF(ICODE .GE. 81 .AND. ICODE .LE. 88) THEN
                 IHEIGHT=(ICODE-80)*1500+9750
                 RETURN
                 END IF
C
C     CODE VALUE 99 IS NOT USED FOR HH, ONLY FOR HSHS
C     AND FOR TIME BEING 99 IS NOT DECODED AT ALL.
C
      IF(ICODE .GE. 90) THEN
                           IND=ICODE-89
                           IHEIGHT=IHSHS(IND)
                           RETURN
                        END IF
C
C
      END
      
      SUBROUTINE IC3590(INPRE,NILPRE,MINDIC,OUTPRE)
C
C****
C*
C*    NAME     : IC3590
C*
C*    FUNCTION :  DECODE THE AMOUNT OF PRECIPITATION
C*
C*    INPUT    :  INPRE   - PRECIPITATION CODE FIGURE
C*                NILPRE  - INDICATOR FOR 'NIL' PRECIPITATION
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTPRE  - DECODED PRECIPITATION IN TENTHS OF MM
C*
C*             OUTPRE SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INPRE
C*
C****
      INTEGER OUTPRE
C
C***   SET MISSING VALUE
C
      OUTPRE=MINDIC
C***
C*    TEST IF 'NILPRE' ( IR , CODE TABLE 1819 ) INDICATES THAT
C*    PRECIPATION GROUP IS OMITTED BECAUSE RRR = 0 .
C***
      IF ( NILPRE.EQ.3 ) OUTPRE = 0
C
C     IR IS FREQUENTLY MISCODED SO AMOUNT OF RRR REPORTED IS ALSO
C     EXAMINED BEFORE RETURNING.
C
      IF ( INPRE.EQ.MINDIC ) RETURN
C
C
      IF(INPRE .LE. 989) THEN
                  OUTPRE=INPRE*10
                  RETURN
                  END IF
C
      IF(INPRE .GE. 990 .AND. INPRE .LE. 999) THEN
                  OUTPRE=INPRE-990
                  RETURN
                  END IF
C
      RETURN
      END
      
      SUBROUTINE IC3845(INTEMP,ISIGN,ICOUNT,IREG,MINDIC,OUTTEMP)
C****
C*
C*    NAME     : IC3845
C*
C*    FUNCTION :  DECODE THE TEMPERATURE
C*
C*    INPUT    :  INTEMP   TEMPERATURE VALUE
C*                ISIGN    SIGN INDICATOR FOR TEMPERATURE
C*                         0 = NOT NEGATIVE, 1 = NEGATIVE
C*                ICOUNT  COUNTRY NUMBER.
C*                IREG  REGION NUMBER.
C*                MINDIC   MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTTEMP  OUTPUT TEMPERATURE WITH CORRECT SIGN
C*
C*             OUTTEMP IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INTEMP
C*
C****
      INTEGER OUTTEMP
C
C***   SET MISSING VALUE
C
      OUTTEMP=MINDIC

C     TEST FOR MISSING DATA AND VALIDITY OF SIGN
C
      IF(INTEMP .EQ. MINDIC .OR. ISIGN .EQ. MINDIC) RETURN
      IF(ISIGN .LT. 0 .OR. ISIGN .GT. 1) RETURN
C
      OUTTEMP=INTEMP
      IF(ISIGN .EQ. 1) OUTTEMP = -1*OUTTEMP
C
      RETURN
C     TEMPERATURE IS GIVEN IN FAHRENEIT IN CUBA,NICARAGUA AND PANAMA
C     ( REGION 4 COUNTRY NUMBERS 70,170 AND 190 ) AND HAS TO BE
C     CONVERTED TO CELSIUS.
C
C      IF ( IREG.NE.4 ) RETURN
C      IF ( ICOUNT.NE.70.AND.ICOUNT.NE.170.AND.ICOUNT.NE.190) RETURN
C      CALL FTOC2 ( OUTTEMP )
C
C
C      RETURN
      END
      
      SUBROUTINE IC3931(ITA,ITT,MINDIC,ITEMP)
C
C****
C*
C*    NAME     :  IC3931
C*
C*    FUNCTION :  DECODE TEMPERARURE IN TENTHS OF DEGREE
C*
C*    INPUT    :  ITA     - APPROXIMATE TENTHS VALUE AND SIGN BIT
C*             :  ITT     - TENS AND UNIT DIGITS OF TEMPERATURE
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  ITEMP   - DECODED TEMPERATURE
C*
C*
C*   A.HOLOPAINEN  JAN.83
C*
C****

C***   CHECK MISSING VALUES
C
      IF(ITA .EQ. MINDIC .OR. ITT .EQ. MINDIC) RETURN
C
C     CHECK THE RANGE OF ITA
C
      IF(ITA .LT. 0 .OR. ITA .GT. 9) RETURN
C
C     POSITIVE TEMPERATURE
C
      IVA=2*(ITA/2)
      IF(IVA .EQ. ITA) THEN
                    ITEMP = 10 * ITT + ITA
                          RETURN
                       END IF
C
C     NEGATIVE TEMPERATURE
C
      ITEMP = -10 * ITT - ITA
      RETURN
      END
      
      SUBROUTINE IC4377(INVIS,MINDIC,OUTVIS)
C
C****
C*
C*    NAME     :  IC4377
C*
C*    FUNCTION :  DECODE HORIZONTAL VISIBILITY AT SURFACE VV
C*
C*    INPUT    :  INVIS   -VISIBILITY CODE FIGURE
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTVIS  -DECODED VISIBILITY IN METRES
C*
C*             OUTVIS IS SET TO MISSING DATA VALUE
C*             IF ANY ERRORS FOUND IN INVIS
C*
C****
      INTEGER OUTVIS
      DIMENSION IVISIB(9)
C
      DATA IVISIB /50,200,500,1000,2000,4000,10000,20000,55000/
C
C***   SET OUTVIS TO MISSING VALUE
C
      OUTVIS=MINDIC
C
      IF(INVIS .EQ. MINDIC) RETURN
      IF(INVIS .GE. 51 .AND. INVIS .LE. 55) RETURN
      IF(INVIS .LT. 0 .OR. INVIS .GT. 99) RETURN
C
      IF(INVIS .EQ. 89) THEN
                              OUTVIS=75000
                              RETURN
                           END IF
C
      IF(INVIS .EQ. 90) THEN
                              OUTVIS=25
                              RETURN
                           END IF
C
      IF(INVIS .EQ. 0) THEN
                             OUTVIS=50
                             RETURN
                           END IF
C
C
      IF(INVIS .GE. 1 .AND. INVIS .LE. 50)
     1       THEN
                 OUTVIS=100 * INVIS
                 RETURN
             END IF
C
      IF(INVIS .GE. 56 .AND. INVIS .LE. 80)
     1       THEN
                 OUTVIS=(INVIS - 50) * 1000
                 RETURN
             END IF
C
      IF(INVIS .GE. 81 .AND. INVIS .LE. 88)
     1       THEN
                 OUTVIS=(INVIS - 80) * 5000 + 30000
                 RETURN
             END IF
C
      IF(INVIS .GE. 91 .AND. INVIS .LE. 99)
     1       THEN
                 IND=INVIS-90
                 OUTVIS=IVISIB(IND)
                 RETURN
             END IF

      RETURN
      END
      
      SUBROUTINE IC4451(INVS,MINDIC,OUTVS)
C
C****
C*
C*    NAME     : IC4451
C*
C*    FUNCTION :  DECODE SHIPS AVERAGE SPEED  VS
C*
C*    INPUT    :  INVS    - SPEED CODE FIGURE
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTVS   - DECODED SPEED M/S
C*
C*
C*             IF ANY ERRORS FOUND IN INVS
C*
C****
      INTEGER OUTVS
C
      DIMENSION ISPEED(10)
C
      DATA ISPEED/0,1,4,7,9,12,14,17,20,22/
C
C***   SET MISSING VALUE
C
      OUTVIS = MINDIC
C
      IF(INVS .LT. 0 .OR. INVS .GT. 9) RETURN
C
      OUTVS=ISPEED(INVS+1)
C
      RETURN
      END
      
      SUBROUTINE MARDSEN(LAT,LONG,M,IERROR)
C
C**** *MARDSEN*
C
C
C     PURPOSE.
C     --------
C
C         CHECK THE LAT&LONG AGAINST MARDSEN SQUARE
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *MARDSEN(LAT,LONG,M,IERROR)*
C
C          INPUT     : LATITUDE  IN HUNDREDTH'S OF DEGREE
C                      LONGITUDE IN HUNDREDTH'S OF DEGREE
C              M     - MARDSEN SQUARE VALUE GIVEN IN REPORT
C
C          OUTPUT   : IERROR  - ERROR INDICATOR
C
C
C     AUTHOR.
C     -------
C
C     A. HOLOPAINEN  JUNE -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.   CHECK POSITION.
C                ---------------
 100  CONTINUE
C
C
      IERROR = 0
      LOLO = LONG
C
C     DON'T CHECK IF POSITION ON THE LINE BETWEEN TWO (OR FOUR) SQUARES
C
      LAA = 1000*(LAT/1000)
      LOO = 1000*(LONG/1000)
C
      IF(LAA .EQ. LAT) RETURN
      IF(LOO .EQ. LONG) RETURN
C
      LAT = LAT /10
      LONG= LONG/10
C
C
      IF(LAT .GE. 0)
     C   THEN
            LO = IABS(LONG/100)+1
            IF(LOLO .GE. 0) LO = 37 - LO
C
            IF( LAT .LT. 800 )
     C         THEN
                  MMM = (LAT/100)*36 + LO
               ELSE
                  MMM = 900 + LO
               END IF
         END IF
C
C
      IF(LAT .LT. 0)
     C   THEN
            LO = IABS( LONG/100 )
            IF(LOLO .GE. 0) LO = 35 - LO
            MMM = 300 + IABS( LAT/100 )*36 +LO
         END IF
C
      IF(MMM .NE. M) IERROR = 1
C
      RETURN
      END
      
      SUBROUTINE IC3333(IQUADR,LAT,LONG,MINDIC,LAT2,LONG2)
C
C****
C*
C*    NAME     :  IC3333
C*
C*    FUNCTION :  DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C*                99LALALA QCL0L0L0L0
C*
C*    INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C*             :  LAT      LATITUDE IN TENTHS OF DEGREE
C*             :  LONG     LONGITUDE IN TENTHS OF DEGREE
C*             :  MINDIC   MISSING DATA VALUE
C*
C*
C*    OUTPUT   :  LAT2   LATITUDE IN HUNDREDTHS OF DEGREE
C*                       SOUTHERN LATITUDE NEGATIVE
C*             :  LONG2: LONGITUDE IN HUNDREDTHS OF DEGREE
C*                       WESTERN LONGITUDE NEGATIVE
C*
C*                LAT2 AND LONG2 ARE SET TO MISSING DATA VALUE IF
C*                ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C*
C****
      DIMENSION LATSIGN(4),LONSIGN(4)
C
      DATA LATSIGN/ 1,-1,-1, 1/
      DATA LONSIGN/ 1, 1,-1,-1/
C
C***  SET LAT2 AND LONG2 TO MISSING DATA VALUE
C
      LAT2=MINDIC
      LONG2=MINDIC
C
C
C     THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C     LAT. AND LONG. ARE NEGATIVE OR POSITIVE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF(IQUADR .NE. 1 .AND. IQUADR .NE. 3 .AND. IQUADR .NE.
     1     5 .AND. IQUADR .NE. 7) RETURN
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(LAT .LT. 0 .OR. LAT .GT. 900) RETURN
C
      IF(LONG .LT. 0 .OR. LONG .GT. 1800) RETURN
C
C
      IQ=(IQUADR+1)/2
C
      LAT2=10*LAT*LATSIGN(IQ)
      LONG2=10*LONG*LONSIGN(IQ)
C
      RETURN
      END
      
      SUBROUTINE STATION(IERR)
C
C**** *STATION*
C
C
C     PURPOSE.
C     --------
C         READ IN STATION LIST AND MAKE LIST OF IMPORTANT STATIONS.
C         ( WMO VOLUMEN A - LIST OF OBSERVING STATIONS)
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *STATION(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   READ IN STATION LIST.
C                ---------------------
      ios = 0
 100  CONTINUE
C
      OPEN(UNIT=4,IOSTAT=IOS,ERR=300,
     1     FILE='station_list.dat',
     1     READONLY,
     1     STATUS='OLD',
     1     FORM='UNFORMATTED')
C
C
      READ(4) IPARAMS,IPOINTS
      CLOSE(4)
C
C
C*           2.  FIND IMPORTANT STATIONS.
C                ------------------------
 200  CONTINUE
C
      CALL IMPSTAT
C
      RETURN
C
 300  CONTINUE
C
      WRITE(*,9901) IOS
 9901 FORMAT(1H ,' ERROR DURING OPENING  STATION FILE , ERROR=',I5)

      RETURN
      END
      
      SUBROUTINE IMPSTAT
C
C**** *IMPSTAT*
C
C
C     PURPOSE.
C     --------
C
C         DEFINES FROM WMO MASTER FILE THE SATION NUMBERS
C         FOR IMPORTANT STATIONS (ECMWF INTERNAL DEFINOTIONS)
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C             INPUT     : IPARAMS   STATION INFORMATION IN PACKED FORM
C                         IPOINTS   NUMBER OF STATION / WMO BLOCK
C
C             OUTPUT    : IMPSTA    THE NUMBERS OF IMPORTATNT SATIONS
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C
C     ------------------------------------------------------------------
C*          1.   FIND IMPORTANT STATIONS.
C                ------------------------
C
      J = 0
      K = 1
C
C
            DO 300 I = 1,30000,3
C
            IF(IPARAMS(I) .EQ. MINDIC) GO TO 400
            IF(I .LT. IPOINTS(K+1)) GO TO 200
C
100         K = K + 1
            IF(K .GE. 99) GO TO 400
            IF(IPOINTS(K) .EQ. IPOINTS(K+1)) GO TO 100
C
200         CONTINUE
C
            CALL GBYTE(IPARAMS(I+2),ITEMP,28,1)
            CALL GBYTE(IPARAMS(I+2),IBIT ,25,1)
C
           IF(ITEMP .EQ. 1 .AND. IBIT .EQ. 1)
     C         THEN
                  CALL GBYTE(IPARAMS(I),III,0,10)
                  ISTA= 1000*K+ III
                  IF(J .NE. 0)
     C               THEN
                        DO 250 N=1,J
                        IF(ISTA .EQ. IMPSTA(N)) GO TO 300
250                     CONTINUE
                     END IF
                  J = J + 1
                  IF(J.GT.2000) THEN
                     PRINT*,'DIMENSION IF IMPSTA TOO SMALL'
                     GO TO 400
                  END IF
C
                  IMPSTA(J) = ISTA
               END IF
C
300        CONTINUE
400   CONTINUE
500   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE LOCSTAT ( IWIND,IRC )
C
C**** *LOCSTAT*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACT PARTICULARS OF WMO OBSERVING STATIONS AND
C         PUT IN DECODED REPORT HEADER.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LOCSTAT(IWIND,IRC)*
C
C          INPUT    : ARGUMENTS NOT USED ON INPUT .
C
C                     KINT(4) - WMO STATION NUMBER IN INTEGER.
C                     KDEC(4) - INTEGER DENOTING OBSERVATION TYPE.
C
C          OUTPUT   : KDEC(5) - LATITUDE IN HUNDREDTHS OF DEGREES ,
C                               NORTH + , SOUTH - .
C                     KDEC(6) - LONGITUDE IN HUNDREDTHS OF DEGREES ,
C                               EAST + , WEST - .
C                     KDEC(8) - STATION PRESSURE ELEVATION (H/P) OR IF
C                               NONE EXISTS STATION GROUND ELEVATION (H/A).
C                               IF NEITHER EXIST MINDIC IS RETURNED . VALUE
C                               IS INTEGER IN METRES.
C
C                     KDEC(15) - IMPORTANT STATION OR GOOD QUALITY STATION
C                                FLAG BITS SET IN THIS WORD.
C
C                     KDEC(16) - WMO COUNTRY NUMBER , EXCLUDING FIRST 2
C                                DIGITS ( REGION NUMBER ) . INTEGER.
C                     KDEC(17) - WMO REGION NUMBER , INTEGER.
C
C                     KDEC(23) - PRESSURE LEVEL INDICATOR , INTEGER.
C                            0 = SEA LEVEL
C                            1 = STATION LEVEL
C                            2 = 850 HPA
C                            3 = 700 HPA
C                            4 = 500 HPA
C                            5 = 1000 GPM
C                            6 = 2000 GPM
C                            7 = 3000 GPM
C                            8 = 4000 GPM
C                            9 = 900 HPA
C
C                     IRC - INTEGER RETURN CODE
C                            0 = NO ERROR
C                            1 = STATION NUMBER NOT IN DIRECTORY
C                            2 = INVALID STATION NUMBER
C                            3 = INVALID OBSERVATION TYPE
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KBPT,KSI)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC
C
C     MODIFICATIONS.
C     --------------
C
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   LOCATE STATION.                   .
C                ---------------
 100  CONTINUE
C
C     CLEAR ERROR RETURN INDICATOR
C
      IRC = 0
C
C     INITIALIZE TYPE OF STATION
C
      ITYPE = 0
C
C     'ITYPE' IS SET TO 4 FOR SYNOP , 2 FOR PILOT AND 1 FOR TEMP.
C
      IF ( KDEC(4).EQ.11.OR.KDEC(4).EQ.14 ) ITYPE = 4
      IF ( KDEC(4).EQ.32 ) ITYPE = 2
      IF ( KDEC(4).EQ.35 ) ITYPE = 1
C
      IF ( ITYPE.EQ.0 ) THEN
                            IRC = 3
                            RETURN
                        END IF
C
C     CHECK VALIDITY OF STATION NUMBER
C
      IF ( KINT(4).LE.1000.OR.KINT(4).GT.99999 )
     C                       THEN
                                 IRC = 2
                                 RETURN
                             END IF
C
C
C     LOCATE STARTING POINT IN ARRAY 'IPARAMS' OF THE WMO BLOCK
C     OF THE STATION.
C
C     EXTRACT WMO BLOCK NUMBER
C
      II = KINT(4) / 1000
C
C     WORD 'II' OF 'IPOINTS' SHOWS WHERE THE ENTRIES FOR BLOCK 'II'
C     START IN 'IPARAMS'.
C
      IND1 = IPOINTS(II)
      IND2 = IPOINTS(II+1)-3
C
C     STARTING AT THIS WORD A SEQUENTIAL SEARCH IS MADE FOR AN ENTRY
C     FOR THE REQUIRED STATION NUMBER ( III ) >
C
      III = KINT(4) - ( II * 1000 )
C
C     FOR ONE STATION ENTRY 3 WORDS ARE USED
C
      DO 101 I=IND1,IND2,3
         CALL GBYTE(IPARAMS(I),ISTN,0,10)
         IF(ISTN.EQ.III) GO TO 200
  101 CONTINUE
C
C     STATION NUMBER NOT FOUND
C
      IRC = 1
      RETURN
C     -----------------------------------------------------------------
C*             2.  EXTRACT REQUIRED PARAMETERS FROM 1ST WORD ENTRY.
C                  -----------------------------------------------
 200  CONTINUE
C
C     PRESSURE LEVEL CODE FIGURE
C
      IF(ITYPE .EQ. 4)
     C   CALL GBYTE(IPARAMS(I),KDEC(23),16,4)
C
C
C     WIND SPEED UNIT INDICATOR
C
      CALL GBYTE(IPARAMS(I),IWIND,20,1)
C
C
C     STATION ELEVATION
C
      CALL GBYTE(IPARAMS(I),KDEC(8),24,14)
      IF ( KDEC(8).GT.9999 ) KDEC(8) = KDEC(8)-16383
      IF ( KDEC(8).EQ.9999 ) KDEC(8) = MINDIC
      call gbyte(iparams(i+1),isgn,6,2)
      if(kdec(8).ne.mindic.and.isgn.eq.1) kdec(8)=-kdec(8)
      
C     LONGITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(6),8,16)
      IF ( KDEC(6).EQ.65535 ) KDEC(6) = MINDIC
      IF ( KDEC(6).NE.MINDIC.AND.KDEC(6).GT.18000)
     C      KDEC(6) = KDEC(6) - 36000

C     LATITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(5),24,14)
      IF ( KDEC(5).EQ.16383 ) KDEC(5) = MINDIC
      CALL GBYTE(IPARAMS(I+2),ISGN,6,1)
      IF(ISGN.EQ.1.AND.KDEC(5).NE.MINDIC)
     C                KDEC(5) = - KDEC(5)

C     WMO REGION NUMBER
C
      CALL GBYTE(IPARAMS(I+2),KDEC(17),8,3)
      IF ( KDEC(17).EQ.0 ) KDEC(17) = 8

C     WMO COUNTRY NUMBER ( LAST 3 DIGITS )
C
      CALL GBYTE(IPARAMS(I+2),KDEC(16),11,10)

C     IMPORTANT STATION AND GOOD QUALITY FLAGS.
C
      CALL GBYTE(IPARAMS(I+2),ISGQ,24,2)
      KDEC(15) = KDEC(15).OR.ISGQ

C     CHECK THAT PARAMETERS ARE VALID FOR OBSERVATION TYPE REQUESTED.
C     SOME STATIONS HAVE MORE THAN 1 ENTRY , DEPENDING ON TYPE OF
C     OBSERVATION.
C
      IF(ITYPE.EQ.1) ISKIP=26
      IF(ITYPE.EQ.2) ISKIP=27
      IF(ITYPE.EQ.4) ISKIP=28
C
      CALL GBYTE(IPARAMS(I+2),ITP,ISKIP,1)
      IF (  ITP.NE.0 ) RETURN
C
C     PARAMETERS NOT CORRECT FOR CODE TYPE , SO USE NEXT ENTRY
C     IF IT EXIST
C
      I = I + 3
C
      CALL GBYTE(IPARAMS(I),ISTN,0,10)
      IF(ISTN.EQ.III) GO TO 200
C
C     RETAIN ALREADY EXTRACTED PARAMETERS
C     THAT MEAN THAT STATION TYPE DOES NOT CORRESPOND TO THE MESSAGE
C     RECEIVED. 
C     
      RETURN
      END
      
      SUBROUTINE EXTVAL ( I,N,IVAL)
C
C**** *EXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN IVAL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTVAL(I,N,IVAL)*
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTE
C
C         OUTPUT    : IVAL - INTEGER VALUE
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES FROM KCHAR ARRAY.
C                -----------------------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
      DO 101 J=IA,IB
C
C
C     STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE
C
      KTEMP=KCHAR(J)
C LAC      KAR = KCHAR(J) .AND. 127
      KAR = AND(KCHAR(J),127)
C
C          CHECK FOR SPACE CHARACTER .
C
           IF ( KAR.EQ.32 ) THEN
                                      IVAL = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     IVAL = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR.LT.48.OR.KAR.GT.57 )
     C                      THEN
                                  DO 102 JA=1,11
                                       IF ( KAR.EQ.ILET(JA))
     C                                       KAR = IFIG(JA)
  102                             CONTINUE
                           END IF
C
           IF ( KAR.GE.48.AND.KAR.LE.57 )
     C                             THEN
C LAC                                    IAC = (IAC + (KAR.AND.15))*10
                                    IAC = (IAC + (AND(KAR,15)))*10
                                   ELSE
                                      IVAL = MINDIC
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  101 CONTINUE
C
      IVAL = IAC / 10

      RETURN
      END
      
      SUBROUTINE PRESEP ( I,J,*)
C
C**** *PRESEP*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRESEP(I,J,*)
C
C                 INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                             J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C                 OUTPUT    : I - POSITION OF PREVIOUS 'CR' OR 'LF' OR 'S
C                                 IF NO CHARACTER FOUND THE CONTROL RETUR
C                                 ALTERNATIVE RETURN POINT *
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C                ---------------------------------------------
C                CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C                --------------------------------------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE LETFIG(K)
C
C*****
C*
C*    NAME      : LETFIG
C*
C*    FUNCTION  : IF K IS NOT FIGURE CONVERT IT USING THE
C*                CCITT NO.2 LETTER/FIGURE RELATION SHIP.
C*
C*    INPUT     : K - KHARACTER VALUE TO BE CONVERTED
C*
C*    OUTPUT    : K - CONVERTED TO FIGURE IF IT WAS EITHER
C*                    E,O,P,Q,R,T,U,W,X,Y OR I, OTHERWISE
C*                    K REMAINS UNCHANGED.
C*
C*****
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /

C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( K.LT.48.OR.K.GT.57 )
     C                      THEN
                                  DO 100 JA=1,11
                                       IF ( K.EQ.ILET(JA))
     C                                       K = IFIG(JA)
  100                             CONTINUE
                           END IF
C
C
      RETURN
      END
      
      SUBROUTINE DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C**** *DDFFF*
C
C
C     PURPOSE.
C
C
C         DECODE WIND DIRECTION AND SPEED
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)*
C
C          INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C                   :  IFF     - WIND SPEEDIN METERS/SEC OR KNOTS
C                   :  IWW     - WIND SPEED INDICATOR (1 FOR KNOTS)
C                   :  ICOUNT  - COUNTRY NUMBER
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C                      ISPEED  - DECODED WIND SPEED
C
C              IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C              ANY ERRORS FOUND IN IDD, IFF OR IWW
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C     ------------------------------------------------------------------
C*          1.   DECODE WIND DIRECTION AND SPEED.
C                --------------------------------
 100  CONTINUE
C
C      CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC .OR. IFF .EQ. MINDIC) RETURN
C
C     CHECK IF IDD ID FEASABLE
C
      IF(IDD .LT. 0 .OR. IDD .GT. 36) RETURN
C
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      IF(ISPEED .GE. 500) THEN
                             ISPEED=ISPEED-500
                             IDIR=IDIR+5
                            END IF
C
C
C     IF SPEED IN KNOTS MODIFY IT TO M/S
C
      IF(IWW .EQ. 1) CALL KTOMPSI(ISPEED)
C
      RETURN
      END
      
      SUBROUTINE PREPRT(I,J,*)
C
C**** *PREPRT*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR PREVIOUS CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PREPRT(I,J,*)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
C LAC         KAR = KCHAR(I).AND.127
         KAR = AND(KCHAR(I),127)
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXSEP2 ( I,J,*)
C
C**** *NEXSEP2*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C         'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C                         IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                         ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXSEP2(I,J,*)*.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  SCAN BULLETIN.                     .
C                -------------
 100  CONTINUE

C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXPRT2(I,J,*)
C
C**** *NEXPRT2*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXPRT2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
C LAC         KAR = KCHAR(I).AND.127
         KAR = AND(KCHAR(I),127)
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXTEQ ( I,J )
C
C**** *NEXTEQ*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '=' CHARACTER.
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEQ(I,J)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
C     '=' IS 61 .
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF(KAR .EQ. 61) RETURN
  101 CONTINUE
C
      I=J
      RETURN
      END
      
      SUBROUTINE EXTINT ( I,N,K )
C
C**** *EXTINT*
C
C
C     PURPOSE.
C     --------
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN WORD K OF 'KINT' .
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTED.
C
C         OUTPUT    : I - POINTS TO CHARACTER AFTER THE LAST ONE EXTRACTED.
C                         MADE NEGATIVE IF A 'SEPARATOR' IS FOUND IN THE
C                         CHARACTERS BEING EXTRACTED.
C                         IF NEGATIVE , THE ABSOLUTE VALUE IS POSITION OF
C                         'SEPARATOR' ENCOUNTERED .
C                     K - INTEGER VALUE IN WORD K OF 'KINT'. MISSING DATA
C                         VALUE INSERTED IF '/' OR NON DIGIT ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTINT ( I,N,K )*
C
C     AUTHOR.
C     -------
C
C          J. HENNESSY
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C     ------------------------------------------------------------------
C*          1.   EXTRACT N FIGURES.
C                ------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
C*           1.1 STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE.
C                ------------------------------------------------------------
 110  CONTINUE
C
      DO 111 J=IA,IB
C
      KTEMP=KCHAR(J)
      KTEMP=KCHAR(J)
C LAC      KAR = KCHAR(J) .AND. 127
      KAR = AND(KCHAR(J),127)
C
C
C          CHECK FOR SPACE,LINE FEED AND CARRIAGE RETURN CHARACTER .
C
           IF ( KAR .EQ. 32 .OR. KAR .EQ. 10 .OR. KAR .EQ. 13)
     C                           THEN
                                      I = - J
                                      KINT(K) = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     I = IB + 1
                                     KINT(K) = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR .LT. 48 .OR. KAR .GT. 57 )
     C                      THEN
                                  DO 112 JA=1,11
                                       IF ( KAR .EQ. ILET(JA))
     C                                       KAR = IFIG(JA)
  112                             CONTINUE
                           END IF
C
           IF ( KAR .GE. 48 .AND. KAR .LE. 57 )
     C                             THEN
C LAC                                    IAC = (IAC + (KAR.AND.15))*10
                                    IAC = (IAC + (AND(KAR,15)))*10
                                   ELSE
                                      KINT(K) = MINDIC
                                      I = IB + 1
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  111 CONTINUE
C
      KINT(K) = IAC / 10
      I = J

      RETURN
      END
      
      SUBROUTINE NEXTPRT ( I,J )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
C LAC         KAR = KCHAR(I).AND.127
         KAR = AND(KCHAR(I),127)
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTSEP ( I,J )
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C                        'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
C LAC KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTEND ( I,J )
C
C**** *NEXTEND*
C
C
C     PURPOSE.
C     --------
C         FUNCTION  : LOCATE NEXT OCCURRENCE OF EITHER 'CR' OR 'LF'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' CHARACTER.
C                     I > J INDICATES NO CHARACTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 .
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF ( KAR .EQ. 13 .OR. KAR .EQ. 10 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTBULL ( I,M )
C
C**** *PRTBULL*
C
C
C     PURPOSE.
C     --------
C         PRINTS BULLETIN IN ARRAY 'KCHAR'
C
C         INPUT      : BULLETIN IN 'KCHAR' .
C                      I - PRINT STARTS AT CHARACTER I
C                      M - PRINT ENDS AT CHARACTER M .
C
C         OUTPUT     : BULLETIN IS PRINTED . ARRAY 'KCHAR' AND POINTERS
C                      UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTBULL(I,M)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
C      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION LINE(80)
C     ------------------------------------------------------------------
C*          1.   PRINT BULLETIN.
C                ---------------
 100  CONTINUE
C
      IP = I
      J = M
C
C*          1.1  SET OUTPUT LINE TO ALL SPACES .
C                -------------------------------
 110  CONTINUE
C
      K = 80
      DO 111 N=1,K
             LINE(N) = 32
  111 CONTINUE
C
C     LOCATE START AND END OF NEXT LINE OF CHARACTERS ( IF ANY ).
C
      CALL NEXTPRT ( IP,J )
      IF ( IP.GT.J ) RETURN
      JP = IP
      CALL NEXTEND ( JP,J )
      K = JP - IP
      IF(K.GT.80) K=80
C
C     INSERT IN OUTPUT LINE AND SUPPRESS PARITY BIT.
C
      DO 112 N =1,K
C LAC             LINE(N) = KCHAR(IP).AND.127
             LINE(N) = AND(KCHAR(IP),127)
             IP = IP + 1
  112 CONTINUE
C
      WRITE ( *,9900) (LINE(N),N=1,K)
C
C     GET NEXT LINE
C
      GO TO 110
C
 9900 FORMAT (1H ,80A1)

      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
c
      INCLUDE 'parameter.h'
C
      CHARACTER *10 IFA
      CHARACTER CUNIT*24,CVAL*9
C
      CHARACTER CTABBEN(JP2)*64,CTABBU(JP2)*24
      DIMENSION NTABP(64,255)
C
      CHARACTER*8 YDATE
      CHARACTER*5 YTIME,YFAMILY,YTASK
C

      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comstd.h'
      include 'comdate.h'
      
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE.
c
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING OF
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS ,
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'17777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                         '17777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CALL SETTAB( IERR )
C     --------------------------------------------------------------------
C*          9.   SET UP WMO STATION LIST AND IMPORTANT STATIONS.
C                -----------------------------------------------
 900  CONTINUE
C
      CALL STATION(IERR)
C     --------------------------------------------------------------------
C*          10.   SET UP date of observations.
C                -----------------------------------------------
 905  CONTINUE
C
      call datim (ny,nm,nd,nutc,nh,nmin,nsec,ncc)

      if (nm .lt. 0) nm = nm * -1     
c       print*,'initvar',ny,nm,nd    
C     --------------------------------------------------------------------
C*          10.   SET UP HEIGHT AND PRESSURE OF STANDARD ATMOSPHERE.
C                ---------------------------------------------------
1000  CONTINUE
C
      OPEN(UNIT=11,IOSTAT=IOS,ERR=1005,
     1     FILE='standard_atmosphere.dat',
     1     READONLY,
     1     STATUS='OLD')
C
      DO 1001 I=1,512
      READ(11,FMT=7777,ERR=1010,END=1100,IOSTAT=IOS)  SH(I),P(I)
 7777 FORMAT(1X,F5.0,2X,F8.2)
 1001 CONTINUE
C
      CLOSE(11)
C
      GO TO 1100
C
 1005 CONTINUE
C
      PRINT*,' Open error ',ios,' on file standard_atmosphere.dat'
C
 1010 CONTINUE
C
      PRINT*,' Read error ',ios,' on file standard_atmosphere.dat'
      
 1100 CONTINUE

      RETURN
      END
      
      SUBROUTINE NEXTFIG ( I,K )
C
C**** *NEXTFIG*
C
C
C     PURPOSE.
C     --------
C         LOCATE FIRST WORD CONTAINING A FIGURE IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO FIGURE FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTFIG(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C*          1.   FIND POINTER TO NEXT FIGURE.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF ( KAR .GE. 48 .AND. KAR .LE. 57 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTLET ( I,K )
C
C**** *NEXTLET*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE FIRST WORD CONTAINING A LETTER IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO LETTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTLET(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C     ------------------------------------------------------------------
C*          1.   FIND POINTER TO NEXT LETTER.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 110 I=J,K
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF ( KAR .GE. 65 .AND. KAR .LE. 90 ) RETURN
  110 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    N1 - NUMBER OF CHARACTERS CONVERTED TO FIRST INTEGER
C                    N2 -    "    "     "          "     " SECOND   "
C                    N3 -    "    "     "          "     "  THIRD   "
C                    N4 -    "    "     "          "     "  FOURTH  "
C                    N5 =    "    "     "          "     "  FIFTH   "
C
C
C                    N - INDEX TO ARRAY 'KINT' , WHERE THE INSERTION OF
C                        INTEGER VALUES STARTS.
C                        VALUES ARE INSERTED IN CONSECUTIVE WORDS.
C
C                    IRET = 0 , ALL CONVERSIONS PERFORMED OK.
C                         = N , ERROR FOUND IN N TH INTEGER CONVERSION.
C
C                    I - POINTS TO CHARACTER AFTER LAST ONE EXTRACTED ,
C                        UNLESS A 'SEPARATOR' (= 'SPACE' , 'LINE FEED',
C                        'CARRIAGE RETURN') IS ENCOUNTERED IN FIGURES
C                        BEING EXTRACTED . IN THIS CASE I IS MADE NEGATIVE
C                        WITH THE ABSOLUTE VALUE OF 'I' POINTING TO THE
C                        'SEPARATOR' FOUND. IN THIS CASE ALSO THE WHOLE
C                        GROUP IS DELETED FROM 'KINT'.
C
C                        INTEGER VALUES EXTRACTED PUT IN WORDS N,N+1 ETC
C                        OF ARRAY 'KINT' .
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXTINT(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      NN(1) = N1
      NN(2) = N2
      NN(3) = N3
      NN(4) = N4
      NN(5) = N5
C
      IRET = 0
C
      K = N
c
C*          1.1  CONVERT GROUP .
C                ---------------
 110  CONTINUE
C
      DO 111 J=1,5
         IF ( NN(J).EQ.0 ) RETURN
         CALL EXTINT ( I,NN(J),K )
         IF ( I.LT.0 ) THEN
                            IRET = J
                               DO 50 JJ=1,5
                               IF(NN(JJ) .EQ. 0) RETURN
                               KINT(N+JJ-1) = MINDIC
50                             CONTINUE
                            RETURN
                       END IF
         K = K + 1
  111 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRFILE( IHEAD,IERR )
C
C**** *ERRFILE*
C
C
C     PURPOSE.
C     --------
C         WRITE PROBLEM BULLETIN TO THE ERROR FILE TOGATHER WITH
C         KEY.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRFILE(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      CHARACTER*1 Y63
      CHARACTER*80 YOUT,YOUTA
      CHARACTER*16384 YCHAR
      CHARACTER*3 YSPEC
C
      YSPEC=CHAR(13)//CHAR(13)//CHAR(10)
      Y63  =CHAR(63)
C     ------------------------------------------------------------------
C*          1.   WRITE BULLETIN TO THE ERROR FILE.
C                ---------------------------------
 100  CONTINUE
C
      J1=1
C
C*          1.1  OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 110  CONTINUE
C      
      OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='SYNO.error.dat',
     C     STATUS='UNKNOWN',
C LAC     C     CARRIAGECONTROL='LIST',
C LAC     C     SHARED,
     C     RECL=80                      )
C
C     -----------------------------------------------------------------
C*          2. INITIALIZE POINTERS.
C              --------------------
 200  CONTINUE
C
      IST=1
      IEND=1
C     -----------------------------------------------------------------
C*          3. WRITE BULLETIN INTO ERROR FILE AND MARK ERROR.
C              ----------------------------------------------
 300  CONTINUE
C
      YOUT=' '
      YOUTA=' '
C
      CALL NEXTEND(IEND,ILEN)
      IF(IEND.GT.ILEN) GO TO 500
      CALL NEXTPRT(IEND,ILEN)
C      IF(IEND.GT.ILEN) GO TO 500
      IEND=IEND-1
C
      II=0
C
      DO 301 I=IST,IEND
C
      II=II+1
      IF(KCHAR(I).GT.127) THEN
                             YOUTA(II:II)=Y63
                             ISIGN=1
                          END IF
C LAC      YOUT(II:II)=CHAR(KCHAR(I).AND.127)
      YOUT(II:II)=CHAR(AND(KCHAR(I),127))
C
 301  CONTINUE
C
      IEND=IEND+1
      IST=IEND
C
      WRITE(10,'(A)') YOUT
      IF(ISIGN.EQ.1)  WRITE(10,'(A)') YOUTA
      ISIGN=0
C
C
      GO TO 300
C
 400  CONTINUE
      PRINT*,'+++ ERROR DURING OPENNING UNIT 10 +++, IOS=',IOS
C
 500  CONTINUE
      CLOSE(10)
C
      RETURN
      END
      
      SUBROUTINE NEXTVAL ( I,N,K )
C
C**** *NEXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE FIRST WORD CONTAINING THE VALUE 'N' IN
C         ARRAY 'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT    : 'KCHAR' CONTAINS ONE BULLETIN , ONE CHARACTER PER
C                    WORD.
C
C         OUTPUT   : I = REQUIRED LOCATION . I > K MEANS VALUE NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTVAL(I,N,K)*
c
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT VALUE.
C                --------------
 100  CONTINUE
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
C LAC         KAR = KCHAR(I) .AND. 127
         KAR = AND(KCHAR(I),127)
         IF ( KAR .EQ. N ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
c
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKEDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE

      LODATA = .TRUE.
      LODOT = .TRUE.
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ. 1)  WRITE(*,30000) I,(IA(IK),IK=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(IK),IK=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(IK),IK=I,I2)
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE

      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,KL,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     KL      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
      DIMENSION IA(1)
C     ------------------------------------------------------------------
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,KL,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,KL
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))

101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SYNEXP1(IERR )
C
C**** *SYNEXP1*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR SYNOP DATA.
C         BASIC REPORT. 
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SYNEXP1(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATUM(I,J,K)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*9 CVAL
      CHARACTER*24 CUNIT
      integer date_time(8)
C
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      include 'comdate.h'
C
      CHARACTER*9 CIDENT
      INCLUDE 'comkeyc.h'
      
      common /retarda/ iretarda
      
      integer ndeltatime
      external ndeltatime
C
C     ------------------------------------------------------------------
C*          1.   INCREASE COUNTER OF SUBSETS BY ONE.
C                -----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=0
      NSUB=NSUB+1
      Ns   =NSUB
C
      DO 101 I=1,900
      DO 102 J=1,2
      VALUES(I,J)=999999.
102   CONTINUE
101   CONTINUE 
C
C*          1.1  GET CURRENT DATE (YEAR AND MONTH).
C                ----------------------------------
 110  CONTINUE
      CALL DATUM (KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------      
c        verificando o numero de mensagens com mais de 
c        48 horas de atraso na recepcao.
c
c      call datim (date_time)
      icen = iyear*.01        
      NY1=iYEAR - (icen *100)      
      idhj = (ny1*1000000)+(nm*10000)+(nd*100)
      id48 = NDELTATIME(Idhj,-48)
      idob = (ny1*1000000)+(imonth*10000)+(kdec(1)*100)
      if (idob .le. id48) then
          iretarda = iretarda + 1
      endif
C     ------------------------------------------------------------------
C*          2.   SYNOP - LAND BASED STATION.
C                --------------------------
 200  CONTINUE
C
      IF(KDEC(4).EQ.11.OR.
     1   KDEC(4).EQ.14    ) THEN
C     -----------------------------------------------------------------
C*          2.1  SYNOP LAND ( MANUAL/AUTOMATIC) STATION.
C                ----------------------------------------
C                LOW ALTITUDE STATION.
C                ---------------------
 210  CONTINUE
C
      IF(KDEC(23).GT.1) GO TO 230
C
      VALUES( 1,NSUB)=(KINT( 9)-48)*10+KINT(10)-48
      VALUES( 2,NSUB)=(KINT(11)-48)*100+(KINT(12)-48)*10
     1                +KINT(13)-48
       VALUES( 3,NSUB)=999999.
       IF(KDEC(4).EQ.11) VALUES(3,NSUB)=1.
       IF(KDEC(4).EQ.14) VALUES(3,NSUB)=0.
c
       VALUES( 4,NSUB)=float(IYEAR)
       VALUES( 5,NSUB)=FLOAT(IMONTH)
       VALUES( 6,NSUB)=FLOAT(KDEC(1))
       VALUES( 7,NSUB)=FLOAT(KDEC(2))
       VALUES( 8,NSUB)=FLOAT(KDEC(9))
       VALUES( 9,NSUB)=KDEC(5)/100.
       VALUES(10,NSUB)=KDEC(6)/100.
       VALUES(11,NSUB)=999999.
       IF(KDEC(8).NE.MINDIC) VALUES(11,NSUB)=FLOAT(KDEC(8))
       VALUES(12,NSUB)=999999.
       IF(KDEC(34).NE.MINDIC) VALUES(12,NSUB)=KDEC(34)*10.
       VALUES(13,NSUB)=999999.
       IF(KDEC(35).NE.MINDIC) VALUES(13,NSUB)=KDEC(35)*10.
       VALUES(14,NSUB)=999999.
       IF(KDEC(39).NE.MINDIC) VALUES(14,NSUB)=KDEC(39)*10.
       VALUES(15,NSUB)=999999.
       IF(KDEC(38).NE.MINDIC)
     1    THEN 
             VALUES(15,NSUB)=KDEC(38)
             IF(KDEC(38).GE.9) VALUES(15,NSUB)=15.
          END IF
       VALUES(16,NSUB)=999999.
       IF(KDEC(25).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(25))
       VALUES(17,NSUB)=999999.
       IF(KDEC(26).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(26))
       VALUES(18,NSUB)=999999.
       IF(KDEC(31).NE.MINDIC)
     1    VALUES(18,NSUB)=KDEC(31)/10.+273.16
       VALUES(19,NSUB)=999999.
       IF(KDEC(32).NE.MINDIC)
     1    VALUES(19,NSUB)=KDEC(32)/10.+273.16
       VALUES(20,NSUB)=999999.
       IF(KDEC(33).NE.MINDIC) VALUES(20,NSUB)=FLOAT(KDEC(33))
       VALUES(21,NSUB)=999999.
       IF(KDEC(27).NE.MINDIC) VALUES(21,NSUB)=FLOAT(KDEC(27))
       VALUES(22,NSUB)=999999.
       IF(KDEC(28).NE.MINDIC)
     1    THEN
             VALUES(22,NSUB)=FLOAT(KDEC(28))
             IF(KDEC(4).EQ.14)VALUES(22,NSUB)=FLOAT(KDEC(28))+100.
          END IF
       VALUES(23,NSUB)=999999.
       IF(KDEC(29).NE.MINDIC)
     1    THEN
             VALUES(23,NSUB)=FLOAT(KDEC(29))
             IF(KDEC(4).EQ.14)VALUES(23,NSUB)=FLOAT(KDEC(29))+10.
          END IF
       VALUES(24,NSUB)=999999.
       IF(KDEC(30).NE.MINDIC)
     1    THEN
             VALUES(24,NSUB)=FLOAT(KDEC(30))
             IF(KDEC(4).EQ.14)VALUES(24,NSUB)=FLOAT(KDEC(30))+10.
          END IF
       VALUES(25,NSUB)=999999.
       CALL IC2700(KDEC(42),ICOVER)
       VALUES(25,NSUB)=FLOAT(ICOVER)
       VALUES(26,NSUB)=1.
       VALUES(27,NSUB)=999999.
       IF(KDEC(44).NE.MINDIC) VALUES(27,NSUB)=FLOAT(KDEC(44))
       VALUES(28,NSUB)=999999.
       IF(KDEC(43).NE.MINDIC.AND.KDEC(43).NE.16381
     1                      .AND.KDEC(43).NE.16382)
     1           VALUES(28,NSUB)=FLOAT(KDEC(43))
       VALUES(29,NSUB)=999999.
       IF(KDEC(45).NE.MINDIC.AND.KDEC(45).NE.14)
     1    THEN
             VALUES(29,NSUB)=FLOAT(KDEC(45))+30.
          ELSE
             VALUES(29,NSUB)=62.
          END IF
       VALUES(30,NSUB)=999999.
       IF(KDEC(46).NE.MINDIC.AND.KDEC(46).NE.14)
     1    THEN
             VALUES(30,NSUB)=FLOAT(KDEC(46))+20.
          ELSE
             VALUES(30,NSUB)=61.
          END IF
       VALUES(31,NSUB)=999999.
       IF(KDEC(47).NE.MINDIC.AND.KDEC(47).NE.14)
     1    THEN
             VALUES(31,NSUB)=FLOAT(KDEC(47))+10.
          ELSE
             VALUES(31,NSUB)=60.
          END IF
       VALUES(32,NSUB)=1.
       VALUES(33,NSUB)=999999.
       IF(KDEC(75).NE.MINDIC) VALUES(33,NSUB)=FLOAT(KDEC(75))
       VALUES(34,NSUB)=999999.
       IF(KDEC(76).NE.MINDIC) VALUES(34,NSUB)=FLOAT(KDEC(76))
       VALUES(35,NSUB)=999999.
       IF(KDEC(77).NE.MINDIC) VALUES(35,NSUB)=FLOAT(KDEC(77))
       VALUES(36,NSUB)=2.
       VALUES(37,NSUB)=999999.
       IF(KDEC(78).NE.MINDIC) VALUES(37,NSUB)=FLOAT(KDEC(78))
       VALUES(38,NSUB)=999999.
       IF(KDEC(79).NE.MINDIC) VALUES(38,NSUB)=FLOAT(KDEC(79))
       VALUES(39,NSUB)=999999.
       IF(KDEC(80).NE.MINDIC) VALUES(39,NSUB)=FLOAT(KDEC(80))
       VALUES(40,NSUB)=3.
       VALUES(41,NSUB)=999999.
       IF(KDEC(81).NE.MINDIC) VALUES(41,NSUB)=FLOAT(KDEC(81))
       VALUES(42,NSUB)=999999.
       IF(KDEC(82).NE.MINDIC) VALUES(42,NSUB)=FLOAT(KDEC(82))
       VALUES(43,NSUB)=999999.
       IF(KDEC(83).NE.MINDIC) VALUES(43,NSUB)=FLOAT(KDEC(83))
       VALUES(44,NSUB)=63.
       VALUES(45,NSUB)=999999.
       IF(KDEC(84).NE.MINDIC) VALUES(45,NSUB)=FLOAT(KDEC(84))
       VALUES(46,NSUB)=999999.
       IF(KDEC(85).NE.MINDIC) VALUES(46,NSUB)=FLOAT(KDEC(85))
       VALUES(47,NSUB)=999999.
       IF(KDEC(86).NE.MINDIC) VALUES(47,NSUB)=FLOAT(KDEC(86))
       VALUES(48,NSUB)=999999.
       IF(KDEC(40).NE.MINDIC) VALUES(48,NSUB)=FLOAT(KDEC(40))/10.
       VALUES(49,NSUB)=999999.
       IF(KDEC(99).NE.MINDIC) VALUES(49,NSUB)=FLOAT(KDEC(99))/100.  
c
C      UPDATE NUMBER OF ELEMENTS.
C
       M=49   
C
C*          2.2   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 220  CONTINUE
C
      NBUFTYPE=0
      NTYPE=1                           ! SURFACE DATA
      IF(KDEC(4).EQ. 11) NSBTYPE=1      ! SYNOP LAND
      IF(KDEC(4).EQ. 14) NSBTYPE=3      ! SYNOP LAND (AUTO)
C
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES( 9,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1        CHAR(KINT(12))//CHAR(KINT(13))//'    '  
C
      NRECR=1
C
       RETURN
C
C*          2.3  SYNOP LAND ( MANUAL/AUTOMATIC) STATION.
C                ----------------------------------------
C                HIGH ALTITUDE STATION.
C                ---------------------
 230  CONTINUE
C
      VALUES( 1,NSUB)=(KINT(09)-48)*10+KINT(10)-48
      VALUES( 2,NSUB)=(KINT(11)-48)*100+(KINT(12)-48)*10
     1                +KINT(13)-48
       VALUES( 3,NSUB)=999999.
       IF(KDEC(4).EQ.11) VALUES(3,NSUB)=1.
       IF(KDEC(4).EQ.14) VALUES(3,NSUB)=0.
       VALUES( 4,NSUB)=float(IYEAR)
       VALUES( 5,NSUB)=FLOAT(IMONTH)
       VALUES( 6,NSUB)=FLOAT(KDEC(1))
       VALUES( 7,NSUB)=FLOAT(KDEC(2))
       VALUES( 8,NSUB)=FLOAT(KDEC(9))
       VALUES( 9,NSUB)=KDEC(5)/100.
       VALUES(10,NSUB)=KDEC(6)/100.
       VALUES(11,NSUB)=999999.
       IF(KDEC(8).NE.MINDIC) VALUES(11,NSUB)=FLOAT(KDEC(8))
       VALUES(12,NSUB)=999999.
       IF(KDEC(34).NE.MINDIC) VALUES(12,NSUB)=KDEC(34)*10.
       VALUES(13,NSUB)=999999.
       IF(KDEC(36).NE.MINDIC) VALUES(13,NSUB)=KDEC(36)*100.
       VALUES(14,NSUB)=999999.
       IF(KDEC(37).NE.MINDIC) VALUES(14,NSUB)=KDEC(37)*9.8   
       VALUES(15,NSUB)=999999.
       IF(KDEC(39).NE.MINDIC) VALUES(15,NSUB)=KDEC(39)*10.
       VALUES(16,NSUB)=999999.
       IF(KDEC(38).NE.MINDIC)
     1    THEN 
             VALUES(16,NSUB)=KDEC(38)
             IF(KDEC(38).GE.9) VALUES(16,NSUB)=15.
          END IF
       VALUES(17,NSUB)=999999.
       IF(KDEC(25).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(25))
       VALUES(18,NSUB)=999999.
       IF(KDEC(26).NE.MINDIC) VALUES(18,NSUB)=FLOAT(KDEC(26))
       VALUES(19,NSUB)=999999.
       IF(KDEC(31).NE.MINDIC)
     1    VALUES(19,NSUB)=KDEC(31)/10.+273.16
       VALUES(20,NSUB)=999999.
       IF(KDEC(32).NE.MINDIC)
     1    VALUES(20,NSUB)=KDEC(32)/10.+273.16
       VALUES(21,NSUB)=999999.
       IF(KDEC(33).NE.MINDIC) VALUES(21,NSUB)=FLOAT(KDEC(33))
       VALUES(22,NSUB)=999999.
       IF(KDEC(27).NE.MINDIC) VALUES(22,NSUB)=FLOAT(KDEC(27))
       VALUES(23,NSUB)=999999.
       IF(KDEC(28).NE.MINDIC)
     1    THEN
             VALUES(23,NSUB)=FLOAT(KDEC(28))
             IF(KDEC(4).EQ.14)VALUES(23,NSUB)=FLOAT(KDEC(28))+100.
          END IF
       VALUES(24,NSUB)=999999.
       IF(KDEC(29).NE.MINDIC)
     1    THEN
             VALUES(24,NSUB)=FLOAT(KDEC(29))
             IF(KDEC(4).EQ.14)VALUES(24,NSUB)=FLOAT(KDEC(29))+10.
          END IF
       VALUES(25,NSUB)=999999.
       IF(KDEC(30).NE.MINDIC)
     1    THEN
             VALUES(25,NSUB)=FLOAT(KDEC(30))
             IF(KDEC(4).EQ.14)VALUES(25,NSUB)=FLOAT(KDEC(30))+10.
          END IF
       VALUES(26,NSUB)=999999.
       CALL IC2700(KDEC(42),ICOVER)
       VALUES(26,NSUB)=FLOAT(ICOVER)
       VALUES(27,NSUB)=1.
       VALUES(28,NSUB)=999999.
       IF(KDEC(44).NE.MINDIC) VALUES(28,NSUB)=FLOAT(KDEC(44))
       VALUES(29,NSUB)=999999.
       IF(KDEC(43).NE.MINDIC.AND.KDEC(43).NE.16381
     1                      .AND.KDEC(43).NE.16382)
     1           VALUES(29,NSUB)=FLOAT(KDEC(43))
       VALUES(30,NSUB)=999999.
       IF(KDEC(45).NE.MINDIC.AND.KDEC(45).NE.14)
     1    THEN
             VALUES(30,NSUB)=FLOAT(KDEC(45))+30.
          ELSE
             VALUES(30,NSUB)=62.
          END IF
       VALUES(31,NSUB)=999999.
       IF(KDEC(46).NE.MINDIC.AND.KDEC(46).NE.14)
     1    THEN
             VALUES(31,NSUB)=FLOAT(KDEC(46))+20.
          ELSE
             VALUES(31,NSUB)=61.
          END IF
       VALUES(32,NSUB)=999999.
       IF(KDEC(47).NE.MINDIC.AND.KDEC(47).NE.14)
     1    THEN
             VALUES(32,NSUB)=FLOAT(KDEC(47))+10.
          ELSE
             VALUES(32,NSUB)=60.
          END IF
       VALUES(33,NSUB)=999999.
       IF(KDEC(40).NE.MINDIC) VALUES(33,NSUB)=FLOAT(KDEC(40))/10.
       VALUES(34,NSUB)=999999.
       IF(KDEC(99).NE.MINDIC) VALUES(34,NSUB)=FLOAT(KDEC(99))/100.  
C
C      UPDATE NUMBER OF ELEMENTS.
C
       M=34   
C
C
C*          2.4   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 240  CONTINUE
C
      NBUFTYPE=0
      NTYPE=1                           ! SURFACE DATA
      IF(KDEC(4).EQ. 11) NSBTYPE=1      ! SYNOP LAND
      IF(KDEC(4).EQ. 14) NSBTYPE=3      ! SYNOP LAND (AUTO)
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES( 9,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1        CHAR(KINT(12))//CHAR(KINT(13))//'    '  
C
      NRECR=1
      RETURN
      END IF
C
C     -----------------------------------------------------------------
C*          3.   SYNOP- SHIP REPORTS.
C                -------------------------
 300  CONTINUE
C
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24)
     1   THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(1)= CHAR(KINT(09))//CHAR(KINT(10))//
     1               CHAR(KINT(11))//
     1               CHAR(KINT(12))//CHAR(KINT(13))//'    '  
            VALUES( 2,NSUB)=999999.
            IF(KDEC(49).NE.MINDIC) VALUES( 2,NSUB)=FLOAT(KDEC(49))
            VALUES( 3,NSUB)=999999.
            IF(KDEC(50).NE.MINDIC) VALUES( 3,NSUB)=FLOAT(KDEC(50))
            VALUES( 4,NSUB)=1.     
            IF(KDEC(4).EQ.24) VALUES(4,NSUB)=0.
            VALUES( 5,NSUB)=float(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(34).NE.MINDIC) VALUES(12,NSUB)=KDEC(34)*10.
            VALUES(13,NSUB)=999999.
            IF(KDEC(35).NE.MINDIC) VALUES(13,NSUB)=KDEC(35)*10.
            VALUES(14,NSUB)=999999.
            IF(KDEC(39).NE.MINDIC) VALUES(14,NSUB)=KDEC(39)*10.
            VALUES(15,NSUB)=999999.
            IF(KDEC(38).NE.MINDIC)
     1         THEN 
                  VALUES(15,NSUB)=KDEC(38)
                  IF(KDEC(38).GE.9) VALUES(15,NSUB)=15.
               END IF
            VALUES(16,NSUB)=999999.
            IF(KDEC(25).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(25))
            VALUES(17,NSUB)=999999.
            IF(KDEC(26).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(26))
            VALUES(18,NSUB)=999999.
            IF(KDEC(31).NE.MINDIC)
     1      VALUES(18,NSUB)=KDEC(31)/10.+273.16
            VALUES(19,NSUB)=999999.
            IF(KDEC(32).NE.MINDIC)
     1        VALUES(19,NSUB)=KDEC(32)/10.+273.16
            VALUES(20,NSUB)=999999.
            IF(KDEC(33).NE.MINDIC) VALUES(20,NSUB)=FLOAT(KDEC(33))
            VALUES(21,NSUB)=999999.
            IF(KDEC(27).NE.MINDIC) VALUES(21,NSUB)=FLOAT(KDEC(27))
            VALUES(22,NSUB)=999999.
            IF(KDEC(28).NE.MINDIC)
     1         THEN
                  VALUES(22,NSUB)=FLOAT(KDEC(28))
                  IF(KDEC(4).EQ.24)VALUES(22,NSUB)=FLOAT(KDEC(28))+100.
               END IF
            VALUES(23,NSUB)=999999.
            IF(KDEC(29).NE.MINDIC)
     1         THEN
                  VALUES(23,NSUB)=FLOAT(KDEC(29))
                  IF(KDEC(4).EQ.24)VALUES(23,NSUB)=FLOAT(KDEC(29))+10.
               END IF
            VALUES(24,NSUB)=999999.
            IF(KDEC(30).NE.MINDIC)
     1         THEN
                  VALUES(24,NSUB)=FLOAT(KDEC(30))
                  IF(KDEC(4).EQ.24)VALUES(24,NSUB)=FLOAT(KDEC(30))+10.
               END IF
            VALUES(25,NSUB)=999999.
            CALL IC2700(KDEC(42),ICOVER)
            VALUES(25,NSUB)=FLOAT(ICOVER)
            VALUES(26,NSUB)=1.
            VALUES(27,NSUB)=999999.
            IF(KDEC(44).NE.MINDIC) VALUES(27,NSUB)=FLOAT(KDEC(44))
            VALUES(28,NSUB)=999999.
            IF(KDEC(43).NE.MINDIC.AND.KDEC(43).NE.16381
     1                           .AND.KDEC(43).NE.16382)
     1           VALUES(28,NSUB)=FLOAT(KDEC(43))
            VALUES(29,NSUB)=999999.
            IF(KDEC(45).NE.MINDIC.AND.KDEC(45).NE.14)
     1         THEN
                  VALUES(29,NSUB)=FLOAT(KDEC(45))+30.
               ELSE
                  VALUES(29,NSUB)=62.
               END IF
            VALUES(30,NSUB)=999999.
            IF(KDEC(46).NE.MINDIC.AND.KDEC(46).NE.14)
     1         THEN
                  VALUES(30,NSUB)=FLOAT(KDEC(46))+20.
               ELSE
                  VALUES(30,NSUB)=61.
               END IF
            VALUES(31,NSUB)=999999.
            IF(KDEC(47).NE.MINDIC.AND.KDEC(47).NE.14)
     1         THEN
                  VALUES(31,NSUB)=FLOAT(KDEC(47))+10.
               ELSE
                  VALUES(31,NSUB)=60.
               END IF
            VALUES(32,NSUB)=999999.
            IF(KDEC(51).NE.MINDIC) VALUES(32,NSUB)=KDEC( 51)/10.+273.16
            IF(kdec(120).ne.mindic)VALUES(33,NSUB)=KDEC(120)/10.+273.16
C
            M=33  
C
C
C*          3.1   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 310  CONTINUE
C
      NTYPE=1
      IF(KDEC(4).EQ. 21) THEN
         NBUFTYPE=1                     ! SURFACE SEA
         NSBTYPE=11                     ! SYNOP SHIP
      END IF
      IF(KDEC(4).EQ. 22) THEN
         NBUFTYPE=1                     ! SURFACE SEA 
         NSBTYPE=9                      ! SYNOP SHIP (ABBREVIATED)
      END IF 
C
      IF(KDEC(4).EQ. 23) THEN 
         NBUFTYPE=1                     ! SURFACE SEA 
         NSBTYPE=19                     ! SYNOP SHIP (REDUCED)
      END IF 
C
      IF(KDEC(4).EQ. 24) THEN
         NBUFTYPE=1                     ! SURFACE SEA 
         NSBTYPE=13                     ! SYNOP SHIP (AUTO)
      END IF 
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1        CHAR(KINT(12))//CHAR(KINT(13))//'    '  
C
      NRECR=1
      RETURN
C 
      END IF
C
      IERR=1
C
      RETURN
      END
      
      SUBROUTINE SYNEXP2(IERR )
C
C**** *SYNEXP2*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR SYNOP DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SYNEXP2(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATUM(I,J,K)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      include 'comdate.h'
C
      CHARACTER*9 CVAL
      CHARACTER*24 CUNIT
      integer date_time(8)
c      
      common /retarda/ iretarda
      integer ndeltatime
      external ndeltatime
C
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
C
      CHARACTER*9 CIDENT
      INCLUDE 'comkeyc.h' 
C
C     ------------------------------------------------------------------
C*          1.   INCREASE COUNTER OF SUBSETS BY ONE.
C                -----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=0
      NSUB=NSUB+1
      Ns   =NSUB
C
      DO 101 I=1,900
      DO 102 J=1,2
      VALUES(I,J)=999999.
 102  CONTINUE
 101  CONTINUE 
C
C*          1.1  GET CURRENT DATE (YEAR AND MONTH).
C                ----------------------------------
 110  CONTINUE
C
	CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------      
c        verificando o numero de mensagens com mais de 
c        48 horas de atraso na recepcao.
c----
c      call datim (date_time)
      icen = iyear*.01        
      NY1=iYEAR - (icen *100)      
      idhj = (ny1*1000000)+(nm*10000)+(nd*100)
      id48 = NDELTATIME(Idhj,-48)
      idob = (ny1*1000000)+(imonth*10000)+(kdec(1)*100)
      if (idob .le. id48) then
          iretarda = iretarda + 1
      endif
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
C*          2.   SYNOP - LAND BASED STATION.
C                --------------------------
 200  CONTINUE
C
      IF(KDEC(4).EQ.11.OR.
     1   KDEC(4).EQ.14    ) THEN
C     -----------------------------------------------------------------
C*          2.1  SYNOP LAND ( MANUAL/AUTOMATIC) STATION.
C                ----------------------------------------
 210  CONTINUE
C
      VALUES( 1,NSUB)=(KINT(09)-48)*10+KINT(10)-48
      VALUES( 2,NSUB)=(KINT(11)-48)*100+(KINT(12)-48)*10
     1                +KINT(13)-48
       VALUES( 3,NSUB)=999999.
       IF(KDEC(4).EQ.11) VALUES(3,NSUB)=1.
       IF(KDEC(4).EQ.14) VALUES(3,NSUB)=0.
       VALUES( 4,NSUB)=float(IYEAR)
       VALUES( 5,NSUB)=FLOAT(IMONTH)
       VALUES( 6,NSUB)=FLOAT(KDEC(1))
       VALUES( 7,NSUB)=FLOAT(KDEC(2))
       VALUES( 8,NSUB)=FLOAT(KDEC(9))
       VALUES( 9,NSUB)=KDEC(5)/100.
       VALUES(10,NSUB)=KDEC(6)/100.
       VALUES(11,NSUB)=999999.
       IF(KDEC(8).NE.MINDIC) VALUES(11,NSUB)=FLOAT(KDEC(8))
       VALUES(12,NSUB)=999999.
       IF(KDEC(70).NE.MINDIC) VALUES(12,NSUB)=KDEC(70)/10.+273.16
       VALUES(13,NSUB)=999999.
       IF(KDEC(73).NE.MINDIC) VALUES(13,NSUB)=KDEC(73)/10.+273.16
       VALUES(14,NSUB)=999999.
       IF(KDEC(71).NE.MINDIC) VALUES(14,NSUB)=KDEC(71)/10.+273.16
       VALUES(15,NSUB)=999999.
       IF(KDEC(110).NE.MINDIC) VALUES(15,NSUB)=FLOAT(KDEC(110))
       VALUES(16,NSUB)=999999.
       IF(KDEC(112).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(112))
       VALUES(17,NSUB)=999999.
       IF(KDEC(111).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(111))
       VALUES(18,NSUB)=999999.
       IF(KDEC(97).NE.MINDIC) VALUES(18,NSUB)=FLOAT(KDEC(97))
       IF(KDEC(98).NE.MINDIC) VALUES(18,NSUB)=KDEC(98)+10.
C
C      SPECIAL PHENOMENA BUFR TABLES NOT DEFINED, SO WMO CODE TABLE 
C      VALUES RETAINED.
C
       VALUES(19,NSUB)=999999.
       IF(KDEC(87).NE.MINDIC.AND.KDEC(88).NE.MINDIC) THEN 
          VALUES(19,NSUB)=FLOAT(KDEC(87)*100+KDEC(88))
       END IF
       VALUES(20,NSUB)=999999.
       IF(KDEC(89).NE.MINDIC.AND.KDEC(90).NE.MINDIC) THEN
           VALUES(20,NSUB)=FLOAT(KDEC(89)*100+KDEC(90))
       END IF
       VALUES(21,NSUB)=999999.
       IF(KDEC(91).NE.MINDIC.AND.KDEC(92).NE.MINDIC) THEN 
          VALUES(21,NSUB)=FLOAT(KDEC(91)*100+KDEC(92))
       END IF
       VALUES(22,NSUB)=999999.
       IF(KDEC(93).NE.MINDIC.AND.KDEC(94).NE.MINDIC) THEN 
          VALUES(22,NSUB)=FLOAT(KDEC(93)*100+KDEC(94))
       END IF
C
C      UPDATE NUMBER OF ELEMENTS.
C
       M=22
C
C
C*          2.2   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 220  CONTINUE
C
      NBUFTYPE=0
      NTYPE=1                           ! SURFACE DATA
      IF(KDEC(4).EQ. 11) NSBTYPE=2      ! SYNOP LAND REC 2
      IF(KDEC(4).EQ. 14) NSBTYPE=4      ! SYNOP LAND (AUTO) REC 2
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES( 9,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1        CHAR(KINT(12))//CHAR(KINT(13))//'    '  
      NRECR=1
C
       RETURN
C
       END IF
C
C     -----------------------------------------------------------------
C*          3.   SYNOP- SHIP REPORTS.
C                -------------------------
 300  CONTINUE
C
      IF(KDEC(4).EQ.21.OR.KDEC(4).EQ.24) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(1)= CHAR(KINT(09))//CHAR(KINT(10))//
     1               CHAR(KINT(11))//
     1               CHAR(KINT(12))//CHAR(KINT(13))//'    '  
            VALUES( 2,NSUB)=999999.
            IF(KDEC(49).NE.MINDIC) VALUES(2,NSUB)=FLOAT(KDEC(49))
            VALUES( 3,NSUB)=999999.
            IF(KDEC(50).NE.MINDIC) VALUES(3,NSUB)=FLOAT(KDEC(50))
            VALUES( 4,NSUB)=1.     
            IF(KDEC(4).EQ.24) VALUES(4,NSUB)=0.
            VALUES( 5,NSUB)=IYEAR
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
C
C           TMIN, TMAX.
C
            VALUES(12,NSUB)=999999.
            IF(KDEC(73).NE.MINDIC) VALUES(12,NSUB)=KDEC(73)/10.+273.16
            VALUES(13,NSUB)=999999.
            IF(KDEC(71).NE.MINDIC) VALUES(13,NSUB)=KDEC(71)/10.+273.16
C
C           WIND WAVES
C
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            IF(KDEC(54).NE.MINDIC) VALUES(15,NSUB)=FLOAT(KDEC(54)) 
            VALUES(16,NSUB)=999999.
            IF(KDEC(55).NE.MINDIC) VALUES(16,NSUB)=KDEC(55)/10. 
C
C           SWELL WAVES
C
            VALUES(17,NSUB)=999999.
            IF(KDEC(56).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(56)) 
            VALUES(18,NSUB)=999999.
            IF(KDEC(58).NE.MINDIC) VALUES(18,NSUB)=FLOAT(KDEC(58)) 
            VALUES(19,NSUB)=999999.
            IF(KDEC(59).NE.MINDIC) VALUES(19,NSUB)=KDEC(59)/10. 
C
C           SWELL WAVES
C
            VALUES(20,NSUB)=999999.
            IF(KDEC(57).NE.MINDIC) VALUES(20,NSUB)=FLOAT(KDEC(57)) 
            VALUES(21,NSUB)=999999.
            IF(KDEC(60).NE.MINDIC) VALUES(21,NSUB)=FLOAT(KDEC(60)) 
            VALUES(22,NSUB)=999999.
            IF(KDEC(61).NE.MINDIC) VALUES(22,NSUB)=KDEC(61)/10. 
C
C           WAVES
C
            VALUES(23,NSUB)=999999.
            VALUES(24,NSUB)=999999.
            IF(KDEC(52).NE.MINDIC) VALUES(24,NSUB)=FLOAT(KDEC(52)) 
            VALUES(25,NSUB)=999999.
            IF(KDEC(53).NE.MINDIC) VALUES(25,NSUB)=KDEC(53)/10. 
C
C           EVAPORATION/NET_RADIATION/SUNSHINE
C
            VALUES(26,NSUB)=999999.
            IF(KDEC(110).NE.MINDIC) VALUES(26,NSUB)=KDEC(110)
            VALUES(27,NSUB)=999999.
            IF(KDEC(112).NE.MINDIC) VALUES(27,NSUB)=KDEC(112)
            VALUES(28,NSUB)=999999.
            IF(KDEC(111).NE.MINDIC) VALUES(28,NSUB)=KDEC(111)
C
C           SPECIAL PHENOMENA ; OLD WMO CODE TABLE VALUES RETAIND.
C             
            VALUES(29,NSUB)=999999.
            IF(KDEC(87).NE.MINDIC.AND.KDEC(88).NE.MINDIC) THEN 
               VALUES(29,NSUB)=FLOAT(KDEC(87)*100+KDEC(88))
            END IF
            VALUES(30,NSUB)=999999.
            IF(KDEC(89).NE.MINDIC.AND.KDEC(90).NE.MINDIC) THEN 
               VALUES(30,NSUB)=FLOAT(KDEC(89)*100+KDEC(90))
            END IF
            VALUES(31,NSUB)=999999.
            IF(KDEC(91).NE.MINDIC.AND.KDEC(92).NE.MINDIC) THEN 
               VALUES(31,NSUB)=FLOAT(KDEC(91)*100+KDEC(92))
            END IF
            VALUES(32,NSUB)=999999.
            IF(KDEC(93).NE.MINDIC.AND.KDEC(94).NE.MINDIC) THEN 
               VALUES(32,NSUB)=FLOAT(KDEC(93)*100+KDEC(94))
            END IF
C
C           ICING
C
            VALUES(33,NSUB)=999999.
            IF(KDEC(62).NE.MINDIC)
     1         THEN
                  CALL IC1751(KDEC(62),IBCODE)
                  VALUES(33,NSUB)=FLOAT(IBCODE)
               END IF 
            VALUES(34,NSUB)=999999.
            IF(KDEC(63).NE.MINDIC) VALUES(34,NSUB)=KDEC(63)/10.
            VALUES(35,NSUB)=999999.
            IF(KDEC(64).NE.MINDIC)
     1         THEN
                  CALL IC3551(KDEC(64),IBCODE)
                  VALUES(35,NSUB)=FLOAT(IBCODE) 
               END IF
            VALUES(36,NSUB)=999999.
            IF(KDEC(65).NE.MINDIC)
     1         THEN
                  CALL IC639(KDEC(65),IBCODE)
                  VALUES(36,NSUB)=FLOAT(IBCODE)
               END IF 
            VALUES(37,NSUB)=999999.
            IF(KDEC(66).NE.MINDIC) VALUES(37,NSUB)=FLOAT(KDEC(66)) 
            VALUES(38,NSUB)=999999.
            IF(KDEC(68).NE.MINDIC) VALUES(38,NSUB)=FLOAT(KDEC(68)) 
            VALUES(39,NSUB)=999999.
            IF(KDEC(69).NE.MINDIC) VALUES(39,NSUB)=FLOAT(KDEC(69)) 
C
            M=39
C                       
C
C*          3.1   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 310  CONTINUE
C
         NTYPE=1                           ! SURFACE DATA
         IF(KDEC(4).EQ. 21) THEN
            NBUFTYPE=1                     ! SURFACE SEA
            NSBTYPE=12                     ! SYNOP SHIP (REC 2)
         END IF
C
         IF(KDEC(4).EQ. 24) THEN
            NBUFTYPE=1                     ! SURFACE SEA 
            NSBTYPE=14                     ! SYNOP SHIP (AUTO, REC 2)
         END IF 
C
         NYEAR =IYEAR
         NMONTH=IMONTH
         NDAY  =KDEC(1)
         NHOUR =KDEC(2)  
         NMINUTE=KDEC(9)
         NSECOND=0
C
         JSCALE=5
         JREFLAT= -9000000
         JREFLON=-18000000
C
         NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
         NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
C
         NLAT2=0  
         NLON2=0
C
         NOBS=NSUB
C
         CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1           CHAR(KINT(12))//CHAR(KINT(13))//'    '  
         NRECR=1
C
         RETURN
C
      END IF
C
      IERR=1
C
      RETURN
      END
      SUBROUTINE BUFRENC(K,IERR )
C
C**** *BUFRENC*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL SYNOP
C         REPORT FROM FULLY EXPANDED BUFR FORMAT INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUFRENC(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SETWT(K,IERR)*
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1(K,IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3(K,IERR)*
C         *CALL* *SEC4(IERR)*
C         *CALL* *SEC5(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C           1.1 SET WORKING TABLES AND BUFR SECTION DATA.
C               -----------------------------------------
 110  CONTINUE
C
      CALL SETWT( K,IERR )
      CALL SEC0 ( IERR )
      CALL SEC1 ( IERR )
      CALL SEC2 ( IERR )
      CALL SEC3 ( K,IERR )
      CALL SEC4 ( IERR )
      CALL SEC5 ( IERR )
      CALL PUTBUFR( K,IERR )
C     ------------------------------------------------------------------
C
      RETURN
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
      DIMENSION KD(*)
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT,24)
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1(IERR)
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 14/11/1991  Bufr Edition 2 introduced.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      
C     ------------------------------------------------------------------
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C     ------------------------------------------------------------------
C*          4.   BUFR master table (zero if WMO  FM 94-IX Ext used)
C                ---------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR  MESSAGE TYPE.
C                --------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED (CURRENTLY 2).
C                --------------------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C      ------------------------------------------------------------------
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      RYEAR=VALUES(4,1)
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) RYEAR=VALUES(5,1)
      icen = (ryear * .01)
      IYEAR=RYEAR - (icen * 100.)
      if (iyear .eq. 0) iyear=100
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      IMONTH=VALUES(5,1)
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) IMONTH=VALUES(6,1)
      CALL PACK(NBPW,MBUF(NWPT),IMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      IDAY=VALUES(6,1)
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) IDAY=VALUES(7,1)
      CALL PACK(NBPW,MBUF(NWPT),IDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      IHOUR=VALUES(7,1)
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) IHOUR=VALUES(8,1)
      CALL PACK(NBPW,MBUF(NWPT),IHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                -------------
 1400 CONTINUE
C
      IMIN=VALUES(8,1)
      IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) IMIN=VALUES(9,1)
      CALL PACK(NBPW,MBUF(NWPT),IMIN,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---- -------- -- --- -------- -- --- -------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY (48 BYTES).
C
 140  CONTINUE
C 
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3(K,IERR )
C
C**** *SEC3*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3(K,IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS WHICH DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     SYNOP- BASIC REPORT
C
      IF(K.EQ.1) THEN
C
         IF(KDEC(4).EQ.11.OR.KDEC(4).EQ.14) THEN
            IF(KDEC(23).LE.1) THEN
               CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),5,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
               IY=  IWTR(48)-(IWTR(48)/100)*100
               CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 8)
C
C              CHECK IF Q/C PERFORMED.
C
               IBIT1=0
               DO 161 I=M+1,M+M
               IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161           CONTINUE
C
               IF(IBIT1.EQ.0) GO TO 170
C
               MQ=56
               CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
               GO TO 170
            END IF
C
            IF(KDEC(23).GT.1) THEN
               CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
               IY=  IWTR(33)-(IWTR(33)/100)*100
               CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 8)
C
C
C              CHECK IF Q/C PERFORMED.
C
               IBIT1=0
               DO 162 I=M+1,M+M
               IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 162           CONTINUE
C
               IF(IBIT1.EQ.0) GO TO 170
C
               MQ=41
               CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
               GO TO 170
            END IF
         END IF
C
         IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),05,NWPT,NBPT, 8)
C
C
C           CHECK IF Q/C PERFORMED.
C
            IBIT1=0
            DO 163 I=M+1,M+M
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 163        CONTINUE
C
            IF(IBIT1.EQ.0) GO TO 170
C
            MQ=37
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
C
            GO TO 170
         END IF
      END IF

C     SYNOP- SECOND RECORD
C
      IF(K.EQ.2) THEN
        IF(KDEC(4).EQ.11.OR.KDEC(4).EQ.14) THEN
           CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
           IY=  IWTR(13)-(IWTR(13)/100)*100
           CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
           IY=  IWTR(14)-(IWTR(14)/100)*100
           CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),14,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),15,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),14,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),62,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),192,NWPT,NBPT, 8)
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),192,NWPT,NBPT, 8)
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),192,NWPT,NBPT, 8)
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),192,NWPT,NBPT, 8)
C
C
C          CHECK IF Q/C PERFORMED.
C
           IBIT1=0
           DO 164 I=M+1,M+M
           IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 164       CONTINUE
C
           IF(IBIT1.EQ.0) GO TO 170
C
           MQ=28
           CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
           CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
           CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
           CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
           GO TO 170
         END IF
C
         IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),36,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
            IY=  IWTR(12)-(IWTR(12)/100)*100
            CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),12,NWPT,NBPT, 6)
            IY=  IWTR(13)-(IWTR(13)/100)*100
            CALL PACK(NBPW,MBUF(NWPT),IY,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),24,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,2)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT,6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,2)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT,6)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT,8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,2)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT,6)
            CALL PACK(NBPW,MBUF(NWPT),21,NWPT,NBPT,8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),13,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),14,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),15,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),14,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),63,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),63,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),63,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),63,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),32,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),34,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),37,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),38,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),20,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),36,NWPT,NBPT, 8)
C
C
C           CHECK IF Q/C PERFORMED.
C
            IBIT1=0
            DO 165 I=M+1,M+M
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 165        CONTINUE
C
            IF(IBIT1.EQ.0) GO TO 170
C
            MQ=43
            CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)

C
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
         END IF
      END IF
C
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE

      CALL OCTNUM(IWPTB,IBPTB)
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC4( IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
c
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C      
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
      DO 201 I=1,Ns
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
C
      IF(YUNIT.EQ.'CCITTIA5') THEN
         IST=NINT(VAL)/1000
         NCHAR=NINT(VAL)-IST*1000
         YVAL=CVAL(IST)
         DO 203 II=1,NCHAR
         IPACK=ICHAR(YVAL(II:II))
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203     CONTINUE
         GO TO 202
      END IF
C
      IF(VAL.EQ.999999.) THEN
c      print*,nwpt,nbpt,ibdw,val
         CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
         
      ELSE
         IF(ISCALE.LT.0) THEN
            ISCALE=IABS(ISCALE)
            IPACK=NINT(VAL/10**ISCALE) - IREF
         ELSE
            IPACK=NINT(VAL*10**ISCALE) - IREF
         END IF
C
c	print*,nwpt,nbpt,ibdw,val
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
      END IF
C
 202  CONTINUE
C
      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.031031) THEN
C 
C          SET BIT FLAG
C
           IBIT1=0
C
           DO 215 JI=M+1,M+M
C
           IPACK=1
           IF(VALUES(JI,I).NE.999999.) IPACK=0
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
C
 215       CONTINUE
C           
        END IF
C
        IF(IREV.EQ.001031) THEN
           VAL=46.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001032) THEN
           VAL=999999.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001201) THEN
           VAL=1.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.033007) THEN
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 216       CONTINUE
C
        END IF
C
 210    CONTINUE
C
      END IF
C
 201  CONTINUE
C     ------------------------------------------------------------------
C*         12.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 1200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C     ------------------------------------------------------------------
 1300 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt = 0
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
      SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         croot='./'
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
C      
      end

      SUBROUTINE SETWT(K,IERR)
C
C**** *SETWT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWT(K,IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
C
      CHARACTER*9  CVAL
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
C
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU(jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
c
      DIMENSION ITBTRL(56),ITBTRH(41),ITBTRSH(37),ITBTRL2(28)
     1,         ITBTRA(56),ITBTRS2(43)
C
      DATA ITBTRL/001001,001002,002001,004001,004002
     1,           004003,004004,004005,005001,006001
     2,           007001,010004,010051,010061,010063
     5,           011011,011012,012004,012006,013003
     6,           020001,020003,020004,020005,020010
     7,           008002,020011,020013,020012,020012
     8,           020012,008002,020011,020012,020013
     A,           008002,020011,020012,020013,008002
     B,           020011,020012,020013,008002,020011
     C,           020012,020013,013020,013021,013022
     D,           013023,013013,031031,001031
     E,           001201,033007/
C
      DATA ITBTRH/001001,001002,002001,004001,004002
     1,           004003,004004,004005,005001,006001
     2,           007001,010004,007004,010003,010061
     5,           010063,011011,011012,012004,012006
     6,           013003,020001,020003,020004,020005
     7,           020010,008002,020011,020013,020012
     8,           020012,020012,013020,013021,013022
     A,           013023,013013,031031,001031
     B,           001201,033007/
C
      DATA ITBTRSH/001011,001012,001013,002001,004001
     1,            004002,004003,004004,004005,005002
     2,            006002,010004,010051,010061,010063
     5,            011011,011012,012004,012006,013003
     6,            020001,020003,020004,020005,020010
     7,            008002,020011,020013,020012,020012
     8,            020012,022042,012005,031031,001031
     9,            001201,033007/
C
      DATA ITBTRL2/001001,001002,002001,004001,004002
     1,            004003,004004,004005,005001,006001
     2,            007001,012013,012015,012017,012014
     5,            012016,013031,014015,014031,020062
     6,            020192,020192,020192,020192,031031
     7,            001031,001201,033007/
C
      DATA ITBTRS2/001011,001012,001013,002001,004001
     1,            004002,004003,004004,004005,005002
     2,            006002,012015,012014,022002,022012
     5,            022022,022003,022013,022023,022003
     6,            022013,022023,022001,022011,022021
     7,            013031,014015,014031,020063,020063
     8,            020063,020063,020033,020031,020032
     9,            020034,020037,020038,020036,031031
     A,            001031,001201,033007/
C
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR SYNOP DATA.
C                ----------------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
C     SET UP BASIC SURFACE REPORT.
C
      IF(K.EQ.1) THEN
C
         IF(KDEC(4).EQ.11.OR.KDEC(4).EQ.14) THEN
            IF(KDEC(23).LE.1) THEN
               J=0
               DO 101 I=1,13
               J=J+1 
               ITBTRA(J)=ITBTRL(I)
 101           CONTINUE 
C
               J=J+1
               ITBTRA(J)=ITBTRL(14)
               IF(KDEC(38).EQ.9) ITBTRA(J)=010062
C
               DO 1101 I=15,47
               J=J+1 
               ITBTRA(J)=ITBTRL(I)
 1101          CONTINUE 
C
C              TOTAL PRECIPITATION CAN BE OVER 3,6,12,24 HOURS.
C
               J=J+1
               ITBTRA(J)=ITBTRL(51)
               IF(KDEC(41).EQ.3) ITBTRA(J)=ITBTRL(48)
               IF(KDEC(41).EQ.6) ITBTRA(J)=ITBTRL(49)
               IF(KDEC(41).EQ.12)ITBTRA(J)=ITBTRL(50)
               IF(KDEC(41).EQ.24)ITBTRA(J)=ITBTRL(51)
C
               J=J+1
               ITBTRA(J)=ITBTRL(52)
C
               J=J+1
               ITBTRA(J)=ITBTRL(53)
               J=J+1
               ITBTRA(J)=ITBTRL(54)
               J=J+1
               ITBTRA(J)=ITBTRL(55)
               J=J+1
               ITBTRA(J)=ITBTRL(56)
C     
               GO TO 110
C
            ELSE
C
               J=0
               DO 102 I=1,15
               J=J+1 
               ITBTRA(J)=ITBTRH(I)
 102           CONTINUE 
C
               IF(KDEC(38).EQ.9) ITBTRA(J)=010062
C
               DO 1102 I=16,32
               J=J+1 
               ITBTRA(J)=ITBTRH(I)
 1102          CONTINUE 
C
C              TOTAL PRECIPITATION CAN BE OVER 3,6,12,24 HOURS.
C
               J=J+1
               ITBTRA(J)=ITBTRH(36)
               IF(KDEC(41).EQ.3) ITBTRA(J)=ITBTRH(33)
               IF(KDEC(41).EQ.6) ITBTRA(J)=ITBTRH(34)
               IF(KDEC(41).EQ.12)ITBTRA(J)=ITBTRH(35)
               IF(KDEC(41).EQ.24)ITBTRA(J)=ITBTRH(36)
C
               J=J+1
               ITBTRA(J)=ITBTRH(37)
C
C
               J=J+1
               ITBTRA(J)=ITBTRH(38)
               J=J+1
               ITBTRA(J)=ITBTRH(39)
               J=J+1
               ITBTRA(J)=ITBTRH(40)
               J=J+1
               ITBTRA(J)=ITBTRH(41)
C     
               GO TO 110
C 
            END IF
         END IF
C
C        SYNOP SHIP OBSERVATIONS
C
         IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) THEN
            J=0
            DO 103 I=1,13
            J=J+1 
            ITBTRA(J)=ITBTRSH(I)
 103        CONTINUE 
C
            J=J+1
            ITBTRA(J)=ITBTRSH(14)
            IF(KDEC(38).EQ.9) ITBTRA(J)=010062
            DO 1103 I=15,32
            J=J+1 
            ITBTRA(J)=ITBTRSH(I)
 1103       CONTINUE 
C
            J=J+1
            ITBTRA(J)=ITBTRSH(33)
            J=J+1
            ITBTRA(J)=ITBTRSH(34)
            J=J+1
            ITBTRA(J)=ITBTRSH(35)
            J=J+1
            ITBTRA(J)=ITBTRSH(36)
            J=J+1
            ITBTRA(J)=ITBTRSH(37)
C     
            GO TO 110
C
         END IF
C     -----------------------------------------------------------------  
         IERR=1
         RETURN

 110     CONTINUE
C
         DO 111 I=1,J
C
         ITR=ITBTRA(I)
C
         DO 112 II=1,JP2
C
         IF(ITR.EQ.NTABBTR(II)) THEN
            IWTR (I)=NTABBTR(II)
            IWTS (I)=NTABBS (II)
            IWTDW(I)=NTABBDW(II)
            IWTRV(I)=NTABBRV(II)
            CUNIT(I)=CTABBU(II)
            GO TO 111
         END IF
C
 112     CONTINUE
C
       PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 111     CONTINUE
C
      END IF
C
C     -----------------------------------------------------------------
C             2. SET UP SECOND RECORD FOR SYNOP OBS.
C                -----------------------------------
 200  CONTINUE
C
      IF(K.EQ.2) THEN
C
         IF(KDEC(4).EQ.11.OR.KDEC(4).EQ.14) THEN
            J=0
            DO 201 I=1,12
            J=J+1 
            ITBTRA(J)=ITBTRL2(I)
 201        CONTINUE 
C
            J=J+1
            ITBTRA(J)=ITBTRL2(14)
            IF(KDEC(74).EQ.12) ITBTRA(J)=ITBTRL2(13)
            J=J+1
            ITBTRA(J)=ITBTRL2(16)
            IF(KDEC(72).EQ.12) ITBTRA(J)=ITBTRL2(15)
C
            DO 202 I=17,24
            J=J+1 
            ITBTRA(J)=ITBTRL2(I)
 202        CONTINUE 
C
            J=J+1
            ITBTRA(J)=ITBTRL2(25)
            J=J+1
            ITBTRA(J)=ITBTRL2(26)
            J=J+1
            ITBTRA(J)=ITBTRL2(27)
            J=J+1
            ITBTRA(J)=ITBTRL2(28)
C      
            GO TO 210
C 
         END IF
C
         IF(KDEC(4).GE.21.AND.KDEC(4).LE.24) THEN
            J=0
            DO 203 I=1,11
            J=J+1
            ITBTRA(J)=ITBTRS2(I)
 203        CONTINUE
C
            J=J+1
            ITBTRA(J)=ITBTRS2(12)
            IF(KDEC(74).EQ.24) ITBTRA(J)=012017
            J=J+1
            ITBTRA(J)=ITBTRS2(13)
            IF(KDEC(72).EQ.24) ITBTRA(J)=012016
C
            DO 204 I=14,39
            J=J+1
            ITBTRA(J)=ITBTRS2(I)
 204        CONTINUE
C
            J=J+1
            ITBTRA(J)=ITBTRS2(40)
            J=J+1
            ITBTRA(J)=ITBTRS2(41)
            J=J+1
            ITBTRA(J)=ITBTRS2(42)
            J=J+1
            ITBTRA(J)=ITBTRS2(43)
C     
            GO TO 210
         END IF
C
         IERR=1
         RETURN
C  
C     -----------------------------------------------------------------
C
 210     CONTINUE
C
         DO 211 I=1,J
C
         ITR=ITBTRA(I)
C
         DO 212 II=1,JP2
C
         IF(ITR.EQ.NTABBTR(II)) THEN
            IWTR (I)=NTABBTR(II)
            IWTS (I)=NTABBS (II)
            IWTDW(I)=NTABBDW(II)
            IWTRV(I)=NTABBRV(II)
            CUNIT(I)=CTABBU(II)
            GO TO 211
         END IF
C
 212     CONTINUE
C
       PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 211     CONTINUE
C
         RETURN
      END IF
      END
      
      SUBROUTINE PUTBUFR(K,IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
      INCLUDE 'comrec.h'
      include 'comdate.h'
C
      common /recwriten/ irecswriten
      common /repetida/ irepetida
c
      CHARACTER*15000 YOUT
      CHARACTER*9  CIDENT
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      character*18 ytime
      CHARACTER*11 CTABNAME
C
      character*48 records_writen(6000)
      character*46 ckey_aux
      equivalence(ckey_aux,ckey(3:3))
c
      DIMENSION IKEY(12)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)
C
C     ------------------------------------------------------------------
C*          1. DEFINE RDB FILE NAME AND OPEN RDB FILE.
C                -------------------------------------
 100  CONTINUE
C
      IRET=0
      
c      icen = nyear*.01        
c      NY=NYEAR - (icen *100) 
      WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101)
     1       NY,NM,ND,NH,NMIN,NSEC
C
c      print*,ytime
      CTABNAME='SYNO_'//YTIME(1:8)
      GO TO 102
C
 101  CONTINUE
C
      PRINT*,'BAD DATE OR TIME , OBSERVATION IS SKIPPED. IOSTAT=',IOS
      RETURN
C
 102  CONTINUE
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)
c
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      YKEY(13:13)=CIDENT(1:1)
      YKEY(17:17)=CIDENT(5:5)
      YKEY(18:18)=CIDENT(4:4)
      YKEY(19:19)=CIDENT(3:3)
      YKEY(20:20)=CIDENT(2:2)
      YKEY(21:24)=' '
      YKEY(25:32)=' '
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
C
      IF(KDEC(21).EQ.MINDIC) THEN
                                NCORR=0
                             ELSE
                                NCORR=KDEC(21)
                             END IF
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN) 
                  END IF
C      
c      CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc)
c      
      iyyy=ny
      imo=nm
      idd=nd
      ihh=nh
      imm=nmin
      iss=nsec
C
c      print*,iyyy,imo,idd
      IW =9
      IBT=0
c      print*,ilength
C
C       SET LENGTH OF RECORD
C
       CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)      
C
C        SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C       SET TIME BULLETIN WAS RECEIVED
C
      CALL PACK(32,IKEY(IW),NRDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NRMIN,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRSEC,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORR,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRECR,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,IW,IBT,8)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,24)      

C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
C     WORD 8 BIT 16
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c      pass = 9
c      do 10 ii = 1,41,4
c        pass = pass + 1
c         do 20 jj = 1,4
c            yout(((pass*4+1)-jj):((pass*4+1)-jj)) =
c     *       ckey_aux(((ii-1)+jj):((ii-1)+jj))
c 20   continue  
c 10   continue
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c
       yout(84:84) = ckey(47:47)
       yout(83:83) = ckey(48:48)
C
      mbuf(1)=ilength
      
C*          3.1  WRITE REPORT INTO RDB.
C               --------------------
 310  CONTINUE
 
      ierr = 0
       
      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      do 11 i=1,irecswriten
         if(records_writen(i)(1:32).eq.ckey(1:32)) then
           irecswriten = irecswriten - 1
	   irepetida = irepetida + 1
           go to 400
         end if
 11   continue
      records_writen(irecswriten)(1:48) = ckey
      WRITE(99,'(a)')YOUT(5:ilength+4)
C     -----------------------------------------------------------------
 400  continue
C
      RETURN
      END
      
      SUBROUTINE KTOMPSI(IA)
C
C**** *KTOMPSI*
C
C
C     PURPOSE.
C     --------
C
C         CONVERTS KNOTS TO METRES PER SECOND, ROUNDING
C         TO NEAREST METRE.
C
C         INPUT    :  IA WIND SPEED IN KNOTS (INTEGER)
C
C         OUTPUT   :  IA WIND SPEED IN M/S (INTEGER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KTOMPSI(IA)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C     ------------------------------------------------------------------
C
C*          1.   CONVERT WIND IN KNOTS TO METER PER SECOND .
C                -------------------------------------------
 100  CONTINUE
C
C
      IA=NINT(0.5148 * IA +0.5)
      RETURN
      END
      
      FUNCTION P(Z)
C
      DATA A/5.252368255329/, B/44330.769230769/
      DATA  C/0.000157583169442/
      DATA  PTRO/226.547172/, PO/1013.25/
C
      IF (Z.GT.11000.) GO TO 50
      Y = 1.-Z/B
      P = PO*(Y**A)
      RETURN
C
50    Y = -C*(Z-11000.)
      P = PTRO*EXP(Y)
      RETURN
      END
      
      SUBROUTINE SAVBULL ( IERR )
C
C**** *SAVBULL*
C
C
C     PURPOSE.
C     --------
C
C         WRITE COMPLETE BULLETIN TO ERROR FILE .
C
C         BULLETIN IN KCHAR(1)-KCHAR(IGS) IN CCITT 5.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVBULL(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
C
      CHARACTER*80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
      YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
c
      ierr = 1
c
      YLINE=' '
      YLINEA=' '
c
      OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='SYNO.error.dat',
C LAC     C     ACCESS='APPEND',
     C     POSITION='APPEND',
     C     STATUS='UNKNOWN',
C LAC     C     CARRIAGECONTROL='LIST',  
C LAC     C     SHARED,
     C     RECL=80                      )
C
      IP = 1
      JP = IP
      J = IGS
C
C*          1.1  OUTPUT INITIAL CONTROL CHARACTERS.
C                ----------------------------------
 110  CONTINUE
C
      CALL NEXTPRT (JP,IGS)
      K = JP - IP
      N1 = 0
      DO 111 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
                                   YLINEA(N1:N1)=Y63
                                   ISIGN=1
C LAC                                   KCHAR(IP)=KCHAR(IP).AND.127
                                   KCHAR(IP)=AND(KCHAR(IP),127)
                                          END IF
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
  111 CONTINUE
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
      YLINE=' '
      YLINEA=' '
C
 120  CONTINUE
C
      CALL NEXTPRT (IP,J)
      IF (IP .GT. J) GO TO 400
      JP = IP
      CALL NEXTEND (JP,J)
      CALL NEXTPRT (JP,J)
      K = JP - IP
      N1 = 0
      DO 112 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127 )
     C                      THEN
                               YLINEA(N1:N1) = Y63
                               ISIGN= 1
C LAC                               KCHAR(IP) = KCHAR(IP).AND.127
                               KCHAR(IP) = AND(KCHAR(IP),127)
                            END IF
C
      YLINE(N1:N1) = CHAR(KCHAR(IP))
      IP = IP + 1
C
  112 CONTINUE
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
C
      YLINE=' '
      YLINEA=' '
C
      GO TO 120
C
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS
 400  CONTINUE
C
      WRITE(10,'(A)') YGS
C
C     REMOVE PARITY BIT
C
      DO 410 I = 1 , IGS
C LAC      KCHAR(I) = KCHAR(I) .AND. 127
      KCHAR(I) = AND(KCHAR(I),127)
 410  CONTINUE
C
      CLOSE(10)
C 
      RETURN
      END
      
      SUBROUTINE SAVREP ( IHEAD,IERR)
C
C**** *SAVREP*
C
C
C     PURPOSE.
C     --------
C
C         WRITE REPORT IN ERROR TO THE ERROR FILE.
C
C                 IHEAD = 0 , WRITE BULLETIN HEADER AND ERROR REPORT
C                             TO ERROR FILE.
C                       = 1 , WRITE ERROR REPORT ONLY.
C                       = 2 , WRITE 'GS' CHARACTER AT END.
C
C                 IERR NOT USED.
C
C                 IHEAD SET TO 1 IF HEADER WRITTEN , OTHERWISE
C                       UNCHANGED.
C
C                 IERR SET TO -1 , IF ERROR IN WRITE , OTHERWISE
C                       UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVREP(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
      DIMENSION ISTART(4),IFIN(4)
C
      CHARACTER *80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
C      IF(IERR .EQ. 0) RETURN
c
      ierr = 1
c
      YLINE=' '
      YLINEA=' '
c
      OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='SYNO.error.dat',
C LAC     C     ACCESS='APPEND',
     C     POSITION='APPEND',
     C     STATUS='UNKNOWN',
C LAC     C     CARRIAGECONTROL='LIST',
C LAC     C     SHARED,
     C     RECL=80                      )
c
C*          1.2  WRITE BULLETIN HEADER TO ERROR
C                ------------------------------
C                FILE IF NOT ALREADY DONE.
C                -------------------------
 120  CONTINUE
C
      IF ( IHEAD.NE.0 ) GO TO 130
C
C
      ISTART(1) = 1
      ISTART(2) = ISL
      ISTART(3) = IAH
      ISTART(4) = IMI
C
      IFIN(1) = ISL
      IFIN(2) = IAH
      IFIN(3) = JAH
      CALL NEXTEND(IFIN(3),IGS)
      CALL NEXTPRT(IFIN(3),IGS)
      IFIN(4) = JMI
      CALL NEXTEND(IFIN(4),IGS)
      CALL NEXTPRT(IFIN(4),IGS)
C
      IP = 0
      N2 = 0
C
      IHEAD = 1
C
      NN = 4
C
      DO 121 N=1,NN
         K = IFIN(N) - ISTART(N) 
         IF(K.GT.80) K=80
         DO 122 N1=1,K
            N2 = N2 + 1
            IP = IP + 1
            IF (KCHAR(IP).GT.127)
     C                      THEN
                                YLINEA(N2:N2) = Y63
                                ISIGN=1
C LAC                                KCHAR(IP)=KCHAR(IP).AND.127
                                KCHAR(IP)=AND(KCHAR(IP),127)
                            END IF
C
            YLINE(N2:N2) = CHAR(KCHAR(IP))
C
  122    CONTINUE
C
c
         if(k.le.2) go to 18
c
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N2)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N2)
         ISIGN=0
      END IF
C
 18   continue
c
         YLINE=' '
         YLINEA=' '
C
      N2 = 0
C
  121 CONTINUE
C
C
C*           1.3   WRITE ERROR REPORT , IF REQUIRED.
C***               ---------------------------------
 130  CONTINUE
C
      IF ( IHEAD.EQ.2 ) GO TO 140
C
C
C     AVOID WRITING REPORT TWICE IF MIMIMJMJ  LINE IS
C     MISSING.
C
      IF ( IAH.EQ.KPT ) THEN
           CLOSE(10)
           RETURN
      END IF
C
C     AVOID WRITING MIMIMJMJ TWICE ( CORRUPT MIMIMJMJ CAN BE TAKEN
C     AS STATION NUMBER )
C
      IF ( KPT.LT.IFIN(4) ) KPT = IFIN(4)
C
C
      IP = KPT
      IF(KDEC(4) .EQ. 35 .OR. KDEC(4) .EQ. 36) IP = IMI
      IF(KDEC(4) .EQ. 32 .OR. KDEC(4) .EQ. 33) IP = IMI
      J = IEQ+ 3
      IF ( J.GT.IGS) J = IGS
C
  133 CALL NEXTPRT (IP,J)
      IF (IP.GT.J) THEN
          CLOSE(10)
          RETURN
       END IF
      JP = IP
      CALL NEXTEND(JP,J)
      CALL NEXTPRT(JP,J)
      K = JP - IP
      N1 = 0
      IF(K.GT.80) K=80
      DO 131 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127)
     C                        THEN
                                  YLINEA(N1:N1) = Y63
                                  ISIGN= 1
C LAC                                  KCHAR(IP) = KCHAR(IP).AND.127
                                  KCHAR(IP) = AND(KCHAR(IP),127)
                              END IF
C
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
 131  CONTINUE
C
         if(k.le.2) go to 19
c
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
c
      YLINE=' '
      YLINEA=' '
C
      GO TO 133
C
C*              1.4 WRITE 'GS' AT END OF BULLETIN.
C                   ------------------------------
 140  CONTINUE
C
      YLINE(1:4)= YGS
C
      WRITE (10,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:4)
C
C
      GO TO 400
C     ----------------------------------------------------------------
 300  CONTINUE
C
      IERR = -1
      PRINT*,'ERROR IN WRITING INTO ERROR FILE IOS=',IOS 
C     ----------------------------------------------------------------
 400  CONTINUE
C
      CLOSE(10)
C
C     REMOVE PARITY BIT
C
      DO 500 I = 1 , IGS
C LAC       KCHAR(I) = KCHAR(I) .AND. 127
      KCHAR(I) = AND(KCHAR(I),127)
 500  CONTINUE

      RETURN
      END
      
      SUBROUTINE ERRSTA (IPART,IMARK,IFIRST,NUMBER)
C
C**** *ERRSTA*
C
C
C     PURPOSE.
C     --------
C
C         COUNTS THE NUMBER OF ERRORS IN THE REPORT
C         COUNTS THE NUMBER OF ERRORS IN THE DECODING JOB
C         MARKS THE ERROR BIT TO KDEC
C         ADDS ?-MARK TO KCHAR AT THE ERRONEUS GROUP
C
C         INPUT     : IPART    - INDICATOR OF NOER
C                                (IN TEMPS  3 = A, 4 = B, 5 = C, 6 = D)
C                     IMARK    = 1 IF ? IS TO BE ADDED TO ERRONEUS GROUP
C                     IFIRST   = O IF FIRST DECODING ATTEMPT OF THE REPORT
C                              = 1 OTHERWISE
C                     NUMBER   - NUMBER OF ERRORS IN THE REPORT SO FAR
C
C         OUTPUT    : NUMBER   - NEW NUMBER OF ERRORS
C                     NOER     - NUMBER OF ERRONEUS REPORT (INCREASED BY 1
C                                IF THE FIRST ERROR IN THE REPORT)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRSTA(IPART,IMARK,IFIRST,NUMBER)*
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOV.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R. CINTRA.
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
 100  CONTINUE
C
      IF(NUMBER .GE. 0) NUMBER = NUMBER + 1
      IF ( IFIRST.EQ.0 )
     C   THEN
            IF(NUMBER .EQ. 1)
     C          NUMRERR(IPART)=NUMRERR(IPART) + 1
            NOER(IPART,KERR)=NOER(IPART,KERR) + 1
C            KERBIT =ISHFT(KDEC(20),1-KERR) .AND. 1
C            IF(KERBIT .EQ. 0) KDEC(20) = KDEC(20) + 2**(KERR-1)
         END IF
C
      IPT = IABS(IPT)
C LAC      IF(IMARK .EQ. 1) KCHAR(IPT) = KCHAR(IPT) .OR. 128
      IF(IMARK .EQ. 1) KCHAR(IPT) = OR(KCHAR(IPT),128)
      IF(IMARK .EQ. 2)
     C   THEN
            NPT = IPT
            CALL NEXSEP2(NPT,IEQ,*200)
            CALL PREPRT(NPT,IMI,*200)
C LAC            KCHAR(NPT) = KCHAR(NPT) .OR. 128
            KCHAR(NPT) = OR(KCHAR(NPT),28)
         END IF
C
200   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE REMEEE
C
C**** *REMEEE*
C
C
C     PURPOSE.
C     --------
C
C         HANDLE TYPING ERRORS CORRECTED BY THE 'E E E'
C         PROCEDURE AS SPECIFIED IN GTS MANUAL.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *REMEEE*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C         OUTPUT    : E'S , ERRONEUS CHARACTERS AND REPEATED GROUPS REPLACED
C                     BY SPACE CHARACTERS. THESE ARE IGNORED IN SCANNING
C                     ROUTINES.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CHECK FOR 'E E E'. 'EEE' IS ACCEPTED EVEN
C               THOUGH THIS MAY BE  AMBIGUOUS WITH A SYNOP '333' GROUP IN
C               LETTER SHIFT. FREQUENTLY  ONLY 1 OR 2 'E'S MAY BE USED.
C               THESE ALSO CATERED FOR.
 100  CONTINUE
C
C     SKIP PAST SHIP'S CALL SIGN AND LOCATE 'E' IF ANY EXISTS.
C
      I = IPT + 4
      N = 69
      CALL NEXTVAL(I,N,IEQ)
      IF(I .GT. IEQ) RETURN
C
C     'E' CHARACTER FOUND. REPLACE 'E' AND ANY FOLLOWING 'E'S BY SPACES
C     E.G.  40118 7012EE 40118 70500  BECOMES
C           40118 7012   40118 70500 .
C
      K = I
      CALL NEXTFIG(K,IEQ)
      IF(K .GE. IEQ) RETURN
C
            DO 101 J=I,K-1
               IF((KCHAR(J) .NE. 10) .AND. (KCHAR(J) .NE. 13))
     1             KCHAR(J) = 32
101         CONTINUE
C
C     SET POINTER TO CHARACTER BEFORE THE 'E'. CHANGE
C     THIS CHARACTER TO A 'SPACE'.
C       E.G.  40118 7012   40118 70500  BECOMES
C             40118 701    40118 70500 .
C
      N = I - 1
      IF((KCHAR(N) .NE. 10) .AND. (KCHAR(N) .NE. 13))
     1    KCHAR(N) = 32
C
C     SCANNING BACKWARDS REPLACE CHARACTERS BY 'SPACE'
C     UNTIL A 'SPACE' CHARACTER IS ENCOUNTERED.
C        E.G.  40118 701    40118 70500  BECOMES
C              40118        40118 70500 .
C
      DO 102 I=N-1,IPT,-1
          IF(KCHAR(I) .EQ. 32) GO TO 300
          IF((KCHAR(I) .NE. 10) .AND. (KCHAR(I) .NE. 13))
     1        KCHAR(I) = 32
  102 CONTINUE
C
C     NO CHARACTER FOUND
C
      GO TO 100
C
C     ---------------------------------------------------------------------
C*           3. 'I' NOW POINTS TO THE 'SPACE' AFTER LAST FIGURE OF THE GROUP
C               BEFORE THE SERIES OF SPACES AND 'K' POINTS TO FIRST FIGURE
C               OF FOLLOWING GROUP. IF THESE GROUPS ARE THE SAME REMOVE
C               ONE GROUP (SECOND).
C               E.G.  40118        40118 70500  BECOMES
C                     40118              70500 .
C
 300  CONTINUE
C
      I = I - 5
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   N = K + 4
                   DO 301 I=K,N
                       KCHAR(I) = 32
  301              CONTINUE
               END IF
C
C
C*           4.  SOMETIMES MORE THAN 1 GROUP HAS TO BE DELETED
C                E.G.  40118 59623 7012EE 40118 70500 .
C                THIS WILL NOW HAVE BECOME
C                40118 59623        40118         AND POINTERS ARE
C                      I            K
C                40118 59623 NEED TO BE REMOVED.
 400  CONTINUE
C
      I = I - 6
      N = K - 1
      IF((KCHAR(I)  .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   DO 401 J=I,N
                       KCHAR(J) = 32
  401              CONTINUE
               END IF
C
C     GO BACK TO BEGINNING OF SUBROUTINE TO FIND OUT
C     IF THERE ARE MORE 'E'-CORRECTIONS.
C
      GO TO 100
C
      END
      
      SUBROUTINE NEXTMI(I,J,II)
C
C**** *NEXTMI*
C
C
C     PURPOSE.
C     --------
C
C         TO FIND NEXT MIMIMJMJ GROUP IN THE BULLETIN.
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT GROUP OF
C         ('TTAA' OR 'TTBB' OR 'TTCC' OR 'TTDD' ETC.)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTMI(I,J,II)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C
C         OUTPUT    : II- POSITION OF THE FIRST CHARACTER
C                         IN REQUIRED GROUP
C                         IF CHARACTER NOT FOUND II = 99999
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION MIMJ(26)
C
C
      DATA MIMJ /65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
     &           80,81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C*          1.   FIND NEXT MIMIMJMJ GROUP.
C                -------------------------
 100  CONTINUE
C
C
      II=9999
      K =IABS(I)
      M =IABS(I)
C
 101  CONTINUE
C
      CALL NEXSEP2(M,J,*1000)
      CALL NEXPRT2(M,J,*1000)
C
      IF(M.GE.J) RETURN
C
      K1= KCHAR(M  )
      K2= KCHAR(M+1)
      K3= KCHAR(M+2)
      K4= KCHAR(M+3)
C
      DO 102 N=1,26
C
      IF(K1.EQ.MIMJ(N).AND.K2.EQ.MIMJ(N))
     &   THEN
C
            DO 103 NN=1,26
C
            IF(K3.EQ.MIMJ(NN).AND.K4.EQ.MIMJ(NN))
     &         THEN
                  CALL PRESEP(M,K,*1000)
                  CALL PREPRT(M,K,*1000)
                  II= M+1
                  RETURN
               END IF
C
 103        CONTINUE
C
         END IF
C
 102  CONTINUE
C
       GO TO 101
C
 1000 CONTINUE
C
      RETURN
      END
      
	SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATIM(YDTIME)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'comdate.h'
      
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili          
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
      
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c       print*,iyear,imonth,iday,ihour,imin,isec 
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      
      IF(IDAY.GE.IDD) THEN
         IMM=IMONTH
         IYY=IYEAR
         ima=imonth
         RETURN
      END IF
C
      IF(IDAY.LT.IDD) THEN
         IF(IMONTH.EQ.1) THEN
            IMM=12
            IYY=IYEAR-1
            RETURN
         END IF
         IMM=IMONTH-1
         IYY=IYEAR
      END IF     
C
      RETURN
      END
      
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C     
c      integer date_time (8)

      include 'comdate.h'
      
      integer date_time(8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt.1 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)
      else
c             PRINT*,'Passando a data ', arg
             
             read(arg(1:4),'(i4.4)') ny
             read(arg(5:6),'(i2.2)') nm
             read(arg(7:8),'(i2.2)') nd
             read(arg(9:10),'(i2.2)') nh
             read(arg(11:12),'(i2.2)') nmin
             nutc = 0
             nsec = 0
             ncc = 0
             date_time(1) = ny
             date_time(2) = nm
             date_time(3) = nd
             date_time(4) = nutc
             date_time(5) = nh
             date_time(6) = nmin
             date_time(7) = nsec
             date_time(8) = ncc
             
      end if
c      print*,ny,nm,nd,nutc,NH,NMIN,NSEC,ncc
C----------------------------------------------------------------
      RETURN
      END
      
      SUBROUTINE GETNEXT(IERR )
C
C**** *GETNEXT*
C
C
C     PURPOSE.
C     --------
C         GET NEXT MESSAGE FROM MDB.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GETNEXT(IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          Ro. Cintra       *CPTEC*     May/1999.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     
      CHARACTER*15000 YCHAR
      CHARACTER*25 YTIME
      character*78 cstr
c
      data cstr/'                   ship decoding'/
C
      DATA NSKIP/0/
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR=0
      NWPT=1
      NBPT=0
      NSUB=0
      ilenby=0
      ychar=' '
C
c                write last time stamp processed.
c
      if(ostream) then
         WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=410)
     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
         print*,'ytime=',ytime
         WRITE(17,9906,IOSTAT=IOS,ERR=410)
     1      CSTR,CSTREAM,CTSTAMP,YTIME
C
         REWIND(17)
c
      end if
      go to 110
c
 410  continue
c
      print*,' Error writing time stamp.'
C
 9906 FORMAT(1h ,A,
     1     //1h ,'stream             ',A,
     1      /1h ,'time stamp         ',a,
     1     //1h ,'last time updated  ',a  )
c
C           1.1  GET NEXT MESSAGE.
C                -----------------
 110  CONTINUE
      ostream=.true.
      ILEN=ilenby
      
      read(ctstamp,'(4x,4i2)') nrday,nrhour,nrmin,nrsec
c      print*,'Current time stamp is ',ctstamp(1:16)
c
 115  CONTINUE
C
      NUMBULL=NUMBULL+1 
C
C           1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C           1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.EQ.NSKIP) GO TO 110
C
C
C           1.4  TRANSFER BULLETIN TO 'KCHAR' ONE CHARACTER PER WORD.
C                ----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
C LAC      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
      KCHAR(I)=AND(ICHAR(YCHAR(I:I)),127)
C
 141  CONTINUE     
      RETURN
C
C     ----------------------------------------------------------------- 
 400  CONTINUE
C
c 9902 FORMAT(1H ,' BULLETIN NUMBER = ',I9)
C
      END
